//CID://+v5eqR~:                                                   //~v5eqR~
//***********************************************************************//~v57GI~
//* ucvebc.c                                                       //~v57GI~
//***********************************************************************//~v57GI~
//v5eq:041030 ebc<-->sjis:CP290 option(katakana extended)          //~v5eqI~
//                        (previous C1027 is english extended)     //~v5eqI~
//v5ep:041030 (BUG)ebc<-->sjis:ebc "?" should be 0x6f (not 3f)     //~v5epI~
//v5en:041026 ebc<-->sjis:assign euro currency symbole to 0x80(pc) //~v5enI~
//                        ebc-4a(cent) is also conv to pc-80       //~v5enI~
//v5em:041026 ebc<-->sjis chkprint also sbcs tbl                   //~v5emI~
//v5ek:041026 ebc<-->sjis dbcs support;option of asume SO top of line//~v5emI~
//v5ei:041023 ebc<-->sjis dbcs support;xe cont line support        //~v5eiI~
//v5eg:041023 ebc<-->sjis dbcs support;sosi isrt/del/rep option support//~v5egI~
//v5ef:041023 ebc<-->sjis dbcs support,dbcs errrep char support    //~v5efI~
//v5ed:041020 ebc<-->sjis dbcs support                             //~v5edI~
//v57V:030727 conv ascii<->ebc ctl char option                     //~v57VI~
//v57U:030726 conv ascii-->ebc(CP1027pg)                 //~v57UI~
//v57T:030726 some EBC codepage                                    //~v57TI~
//v57S:030726 hankaku katakana<-->alphabet small letter conversion //~v57SI~
//v57G:030607 for EBCDIC-->ASCII conversion                        //~v57GI~
//***********************************************************************//~v57GI~
//***********************************************************************//~v57GI~
                                                                   //~v57GI~
#include <stdio.h>                                                 //~v57GI~
#include <string.h>                                                //~v57GI~
#include <stdlib.h>                                                //~v57GI~
                                                                   //~v57GI~
                                                                   //~v57GI~
#include <ulib.h>                                                  //~v57GI~
#include <uerr.h>                                                  //~v57GI~
#include <ucvebc.h>                                                //~v57GI~
#include <ucvebc2.h>                                               //~v5edR~
#include <udbcschk.h>                                              //~v57SI~
                                                                   //~v57GI~
#if 0                                                              //~v57VI~
//**************************************************************** //~v57GI~
// abcdefghijklmnopqrstuvwxyz                                      //~v57SI~
//                                       //~v57SI~
//                    //~v57SI~
// abcdefghi      jklmnopqr    stuvwxyz                            //~v57SI~
static unsigned char Skandl[256]=                                  //~v57SI~
//       0123456789abcdef                                          //~v57SI~
        "................"     //00-0f                             //~v57SI~
        "................"     //10-1f                             //~v57SI~
        "................"     //20-2f                             //~v57SI~
        "................"     //30-3f                             //~v57SI~
        " ..............."     //40-4f                             //~v57SI~
        "................"     //50-5f                             //~v57SI~
        "."     //60-6f  x61(a)-->x6f(o)            //~v57SI~
        "....."     //70-7f  x70(p)-->x7a(z)            //~v57SI~
        "................"     //80-8f                             //~v57SI~
        "................"     //90-9f                             //~v57SI~
        "................"     //a0-af                             //~v57SI~
        ".abcdefghi......"     //b0-bf  xb1()-->xb9()            //~v57SI~
        "jklmnopqr....stu"     //c0-cf  xc0()-->xc8(),xcd()-->xcf()//~v57SI~
        "vwxyz..........."     //d0-df  xd0()-->xd4()            //~v57SI~
        "................"     //e0-ef                             //~v57SI~
        "................";    //f0-ff                             //~v57SI~
#endif                                                             //~v57VI~
#if 0                                                              //~v57TR~
static unsigned char Sebc2asc[256]=                                //~v57GI~
//       0123456789abcdef                                          //~v57GI~
        "................"     //00-0f                             //~v57GI~
        "................"     //10-1f                             //~v57GI~
        "................"     //20-2f                             //~v57GI~
        "................"     //30-3f                             //~v57GI~
        " ...........<(+|"     //40-4f                             //~v57GI~
        "&.........!.*);."     //50-5f                             //~v57GI~
        "-/.........,%_>?"     //60-6f                             //~v57GI~
        "..........:#@'=\""     //70-7f                            //~v57GI~
        "................"     //80-8f                             //~v57GI~
        "................"     //90-9f                             //~v57GI~
        "................"     //a0-af                             //~v57GI~
        "................"     //b0-bf                             //~v57GI~
        "{ABCDEFGHI......"     //c0-cf                             //~v57GI~
        "}JKLMNOPQR......"     //d0-df                             //~v57GI~
        "..STUVWXYZ......"     //e0-ef                             //~v57GI~
        "0123456789......";    //f0-ff                             //~v57GI~
#endif                                                             //~v57TI~
                                                                   //~v57TI~
#define EBC_CR   0x0d                                              //~v57GI~
#define EBC_NL   0x15                                              //~v57GI~
#define EBC_PERIOD 0x4b                                            //~v57TI~
                                                                   //~v57TI~
#if 0                                                              //~v57TI~
//EBCDIC common 58 char(missing lower-case letter and '!')         //~v57TI~
static unsigned char Sebcbase[256]=                                //~v57TI~
//       0123456789abcdef                                          //~v57TI~
        "................"     //00-0f                             //~v57TI~
        "................"     //10-1f                             //~v57TI~
        "................"     //20-2f                             //~v57TI~
        "................"     //30-3f                             //~v57TI~
        " ...........<(+."     //40-4f                             //~v57TI~
        "&...........*);."     //50-5f                             //~v57TI~
        "-/.........,%_>?"     //60-6f                             //~v57TI~
        "..........:#@'=\""     //70-7f                            //~v57TI~
        "................"     //80-8f                             //~v57TI~
        "................"     //90-9f                             //~v57TI~
        "................"     //a0-af                             //~v57TI~
        "................"     //b0-bf                             //~v57TI~
        ".ABCDEFGHI......"     //c0-cf                             //~v57TI~
        ".JKLMNOPQR......"     //d0-df                             //~v57TI~
        "..STUVWXYZ......"     //e0-ef                             //~v57TI~
        "0123456789......";    //f0-ff                             //~v57TI~
//**CP930:{pJi =sbcs:290(EBCpJi)+dbcs:300           //~v57TI~
//**CP939:{pg =sbcs:1027+dbcs:300                       //~v57TI~
//**CP5026:sbcs:290+dbcs:300                                       //~v57TI~
//**CP5035:sbcs:1027+dbcs:300                                      //~v57TI~
//EBCDIC-US base+33 char added:  a-z,$,bloken bar,`,~,{,},\(back slash)//~v57TI~
static unsigned char SebcUS[256]=                                  //~v57TI~
//       0123456789abcdef                                          //~v57TI~
        "................"     //00-0f                             //~v57TI~
        "................"     //10-1f                             //~v57TI~
        "................"     //20-2f                             //~v57TI~
        "................"     //30-3f                             //~v57TI~
        " ...........<(+|"     //40-4f  4a:cent(no ascii)          //~v57TI~
        "&.........!$*);."     //50-5f  5f:not(no ascii)           //~v57TI~
        "-/.........,%_>?"     //60-6f  6a:broken bar(no ascii)    //~v57TI~
        ".........`:#@'=\""    //70-7f                             //~v57TR~
        ".abcdefghi......"     //80-8f                             //~v57TI~
        ".jklmnopqr......"     //90-9f                             //~v57TI~
        "..stuvwxyz......"     //a0-af  a1:childa(no ascii)        //~v57TI~
        "................"     //b0-bf                             //~v57TI~
        "{ABCDEFGHI......"     //c0-cf                             //~v57TI~
        "}JKLMNOPQR......"     //d0-df                             //~v57TI~
        "..STUVWXYZ......"     //e0-ef e0:backslash(no ascii)      //~v57TR~
        "0123456789......";    //f0-ff                             //~v57TI~
//EBCDIC-CP281({p) EBC-US+4 char repled                //~v57TI~
//   4a:cent-->pond,5b:doller-->yen,a1:tilde->upper line,eo:backslash->doller//~v57TI~
static unsigned char SebcCP281[256]=                               //~v57TI~
//       0123456789abcdef                                          //~v57TI~
        "................"     //00-0f                             //~v57TI~
        "................"     //10-1f                             //~v57TI~
        "................"     //20-2f                             //~v57TI~
        "................"     //30-3f                             //~v57TI~
        " ...........<(+|"     //40-4f  4a:pond(no ascii)          //~v57TI~
        "&.........!\\*);."    //50-5f  5b(yen),5f:not(no ascii)   //~v57TR~
        "-/.........,%_>?"     //60-6f  6a:broken bar(no ascii)    //~v57TI~
        ".........`:#@'=\""    //70-7f                             //~v57TR~
        ".abcdefghi......"     //80-8f                             //~v57TI~
        ".jklmnopqr......"     //90-9f                             //~v57TI~
        ".~stuvwxyz......"     //a0-af  a1:upper line              //~v57TI~
        "................"     //b0-bf                             //~v57TI~
        "{ABCDEFGHI......"     //c0-cf                             //~v57TI~
        "}JKLMNOPQR......"     //d0-df                             //~v57TI~
        "$.STUVWXYZ......"     //e0-ef e0:doller                   //~v57TI~
        "0123456789......";    //f0-ff                             //~v57TI~
#endif                                                             //~v57VI~
//EBCDIC-CP290({Ji) cp281+(lowercase-->kana,                //~v57TI~
//            then added lower case: a-z,[,],~,^,cent,backslash,{,}//~v57TI~
static unsigned char SebcCP290[256]=                               //~v57TI~
//       0123456789abcdef                                          //~v57TI~
        "................"     //00-0f                             //~v57TI~
        "................"     //10-1f                             //~v57TI~
        "................"     //20-2f                             //~v57TI~
        "................"     //30-3f                             //~v57TI~
//      " ..<(+|"     //40-4f  4a:pond(no ascii)          //~v5eqR~
        " \xa0.<(+|"  //40-4f  4a:pond(-->a0)             //~v5eqI~
//      "&..!\\*);."    //50-5f  5b:yen,5f:not(no ascii)    //~v5eqR~
        "&..!\\*);\xfd" //50-5f  5b:yen,5f:not(-->fd)       //~v5eqI~
        "-/abcdefgh.,%_>?"     //60-6f  6a:broken bar(no ascii)    //~v57TI~
        "[ijklmnop`:#@'=\""    //70-7f                             //~v57TI~
        "]q"     //80-8f                             //~v57TI~
//      "rs"     //90-9f                             //~v5eqR~
        "r."     //90-9f  Bug creect("s")            //~v5eqI~
//      ".~s"     //a0-af  a0:tilde(no ascii),a1:upper line//~v5eqR~
        "\xff~s"  //a0-af  a0:tilde(-->ff),a1:upper line//~v5eqI~
//      "^..tuvwxyz"     //b0-bf  b1:cent(no ascii),b2:backslash(no ascii)//~v5eqR~
        "^\x80\xfetuvwxyz"  //b0-bf  b1:cent(-->80),b2:backslash(-->fe)//~v5eqI~
        "{ABCDEFGHI......"     //c0-cf                             //~v57TI~
        "}JKLMNOPQR......"     //d0-df                             //~v57TI~
//      "$.STUVWXYZ......"     //e0-ef e0:doller                   //~v5eqR~
        "$\x80STUVWXYZ......"  //e0-ef e0:doller,e1:euro(-->80:dup with cent)//~v5eqI~
        "0123456789......";    //f0-ff                             //~v57TI~
#if 0                                                              //~v57VI~
//EBCDIC-CP1027({pg) EBC-US+katakana                //~v57TI~
//   4a:cent-->pond,5b:doller-->yen,a1:tilde->upper line,eo:backslash->doller//~v57TI~
static unsigned char SebcCP1027[256]=                              //~v57TI~
//       0123456789abcdef                                          //~v57TI~
        "................"     //00-0f                             //~v57TI~
        "................"     //10-1f                             //~v57TI~
        "................"     //20-2f                             //~v57TI~
        "................"     //30-3f                             //~v57TI~
        " ...<(+|"     //40-4f  4a:cent(no ascii)          //~v57TI~
        "&!$*);."     //50-5f  5f:not(no ascii)           //~v57TR~
        "-/.,%_>?"     //60-6f  6a:broken bar(no ascii)    //~v57TI~
        "`:#@'=\""    //70-7f                             //~v57TR~
        ".abcdefghi"     //80-8f                             //~v57TI~
        ".jklmnopqr"     //90-9f                             //~v57TI~
        "~.stuvwxyz["     //a0-af  a0:upper line,a1:tilde(no ascii)//~v57TI~
        "^.\\]"    //b0-bf  b1:pond(no ascii),b2:yen   //~v57TR~
        "{ABCDEFGHI......"     //c0-cf                             //~v57TI~
        "}JKLMNOPQR......"     //d0-df                             //~v57TI~
        "..STUVWXYZ......"     //e0-ef  e0:backslash               //~v57UR~
        "0123456789......";    //f0-ff                             //~v57TI~
#endif                                                             //~v57TI~
//EBCDIC-CP1027({pg:EBC-US+katakana)+IBM942(conv cent,pond,not,backslash,tilde//~v57TR~
//   4a:cent-->pond,5b:doller-->yen,a1:tilde->upper line,eo:backslash->doller//~v57TI~
static unsigned char SebcCP1027[256]=                              //~v57TI~
//       0123456789abcdef                                          //~v57TI~
        "................"     //00-0f                             //~v57TI~
        "................"     //10-1f                             //~v57TI~
        "................"     //20-2f                             //~v57TI~
        "................"     //30-3f                             //~v57TI~
        " .\x80.<(+|"  //40-4f  4a:cent(-->x80)            //~v57TI~
        "&!$*);\xfd"  //50-5f  5f:not(-->xfd)             //~v57TR~
        "-/.,%_>?"     //60-6f  6a:broken bar(no ascii)    //~v57TI~
        "`:#@'=\""     //70-7f                            //~v57TI~
        ".abcdefghi"     //80-8f                             //~v57TI~
        ".jklmnopqr"     //90-9f                             //~v57TI~
        "~\xffstuvwxyz["  //a0-af  a0:upper line,a1:tilde(-->\xff)//~v57TR~
        "^\xa0\\]" //b0-bf  b1:pond(-->xa0),b2:yen     //~v57TR~
        "{ABCDEFGHI......"     //c0-cf                             //~v57TI~
        "}JKLMNOPQR......"     //d0-df                             //~v57TI~
//      "\xfe.STUVWXYZ......"  //e0-ef e0:backslash(-->xfe)        //~v5enR~
        "\xfe\x80STUVWXYZ......"  //e0-ef e0:backslash(-->xfe),e1:euro//~v5enI~
        "0123456789......";    //f0-ff                             //~v57TI~
static unsigned char Stbla2e[256];                                 //~v57UI~
                                                                   //~v57VI~
static unsigned char Stblctle2a[0x40]=	//ebcdic ctl cahr-->ascii  //~v57VI~
{0x00,0x01,0x02,0x03,0xff,0x09,0xff,0x7f,//nul,soh,stx,etx,(pf),ht,(lc),del//~v57VI~
 0xff,0xff,0xff,0x0b,0x0c,0x0d,0x0e,0x0f,//(ge),(rlf),(smm),vt,ff,cr,so,si//~v57VI~
 0x10,0x11,0x12,0x13,0xff,0x0a,0x08,0xff,//del,dc1,dc2,dc3(tm),(res),nl,bs,(il)//~v57VI~
 0x18,0x19,0xff,0xff,0x1c,0x1d,0x1e,0x1f,//can,em,(cc),(cui),ifs,igs,irs,ius//~v57VI~
 0xff,0xff,0xff,0xff,0xff,0xff,0x17,0x1b,//(ds),(sos),(fs),-,(byp),(lf),etb,esc//~v57VI~
 0xff,0xff,0xff,0xff,0xff,0x05,0x06,0x07,//-,-,(sm),(cu2),-,enq,ack,bel//~v57VI~
 0xff,0xff,0x16,0xff,0xff,0xff,0xff,0x04,//-,-,syn,-,(pn),(rs),(uc),eot//~v57VI~
 0xff,0xff,0xff,0xff,0x14,0x15,0xff,0x1a //-,-,-,(cu3),dc4,nak,-,sub//~v57VI~
};                                                                 //~v57VI~
static unsigned char Stblctla2e[0x80];	//ebcdic ctl cahr<--ascii  //~v57VI~
static unsigned char SebcCP290rev[256],SebcCP1027rev[256];         //~v57VI~
//*******************************************************          //~v57UI~
//void ucvebcinita2e(void);                                        //~v5eqR~
void ucvebcinita2e(int Popt);                                      //~v5eqI~
void ucvebcinitkandl(void);                                        //~v57VI~
//*******************************************************          //~v57GI~
//*dummy for lib(same name as file)						*          //~v57GI~
//*******************************************************          //~v57GI~
void ucvebc(void)                                                  //~v57GI~
{                                                                  //~v57GI~
	return;                                                        //~v57GI~
}//ucvebc                                                          //~v57GI~
//**************************************************************** //~v57GI~
//*get translation table                                           //~v57GI~
//*ret :table addr                                                 //~v57GI~
//**************************************************************** //~v57GI~
unsigned char *ucvebc_gettrte2a(void)                              //~v57GI~
{                                                                  //~v57GI~
//********************                                             //~v57GI~
//  return Sebc2asc;                                               //~v57TR~
    return SebcCP1027;                                             //~v57TI~
}//ureac_init                                                      //~v57GI~
//**************************************************************** //~v57GI~
//*ebc-->asc by cp1027({pg)                         //~v57UR~
//*parm7:output length(reduced by tabskip)                         //~v5eiR~
//*ret :rc:UDBCSCHK_RC_DBCSFOUND                                   //~v5eiI~
//**************************************************************** //~v57GI~
//int ucvebc_2asc(int Popt,unsigned char *Pibuff,unsigned char *Pobuff,int Plen)//~v57TR~
//int ucvebc2asc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,unsigned char *Pobuff,int Plen,UCHAR Prepchar)//~v5efR~
//int ucvebc2asc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,unsigned char *Pobuff,int Plen,int Prepchar)//~v5eiR~
int ucvebc2asc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,//~v5eiI~
               unsigned char *Pobuff,int Plen,int Prepchar,int *Ppoutlen)//~v5eiI~
{                                                                  //~v57GI~
	UCHAR *pci,*pco,*pce;                                          //~v57GR~
    int crlfsw,ctlsw;                                              //~v57VR~
    UCHAR *pcvt,cho,chi,ctlc;                                      //~v57VR~
    UCHAR *pdbcs,tabid;                                            //~v57UI~
    int   skiplen=0;                                               //~v57UI~
    int reslen,dbcschklen,dbcsoutlen;                              //~v5edR~
    int dbcsrepchar;                                               //~v5efI~
    int topsw=EBC2ASC_BUFTOP;                                      //~v5eiI~
    int rc=0;                                                      //~v5eiI~
    int rc2;                                                       //~v5eiI~
//********************                                             //~v57GI~
	dbcsrepchar=(int)((UINT)Prepchar>>8);                          //~v5eqR~
    Prepchar&=0xff;		//sbcs rep char                            //~v5efI~
    if (!Prepchar)                                                 //~v57UI~
        Prepchar='?';                                              //~v57UI~
  if (Popt&EBC2ASC_CP290)                                          //~v5eqI~
	pcvt=SebcCP290;                                                //~v5eqI~
  else                                                             //~v5eqI~
	pcvt=SebcCP1027;                                               //~v57TR~
	crlfsw=Popt & EBC2ASC_CRLF;                                    //~v57GI~
	ctlsw=Popt & EBC2ASC_CTL;                                      //~v57VI~
    pdbcs=Ppdbcs;                                                  //~v57UI~
//  for (pci=Pibuff,pco=Pobuff,pce=pci+Plen;pci<pce;)              //~v5eiR~
    for (pci=Pibuff,pco=Pobuff,pce=pci+Plen;pci<pce;topsw=0)       //~v5eiI~
    {                                                              //~v57GI~
    	chi=*pci++;                                                //~v57TI~
        if (Ppdbcs)                                                //~v57UI~
        {                                                          //~v57UI~
	    	tabid=*pdbcs++;                                        //~v57UI~
            if (tabid==UDBCSCHK_TAB)                               //~v57UI~
            	chi=UDBCSCHK_TAB;                                  //~v57UI~
            else                                                   //~v57UI~
            	if (chi==' ' && tabid!=0)	//tab cont             //~v57UI~
                {                                                  //~v57UI~
                	skiplen++;                                     //~v57UI~
                	continue;                                      //~v57UI~
                }                                                  //~v57UI~
        }                                                          //~v57UI~
//      if (chi==CHAR_SO    //shiftout                             //~v5eiR~
//      &&  Popt & EBC2ASC_DBCS) //dbcs conv                       //~v5eiR~
        if (Popt & EBC2ASC_DBCS)  //dbcs conv                      //~v5eiR~
        if (chi==CHAR_SO                                           //~v5eiR~
        ||  (topsw && Popt & EBC2ASC_SOCONT))	//top of dbcs continued line of SO pending//~v5eiR~
        {                                                          //~v5edR~
        	pci--;                                                 //~v5edR~
            reslen=(int)((ULONG)pce-(ULONG)pci);                   //~v5edR~
//          ucvebc2_stre2s(Popt,pci,pco,reslen,&dbcschklen,&dbcsoutlen,Prepchar);//~v5efR~
            rc2=ucvebc2_stre2s(Popt|topsw,pci,pco,reslen,&dbcschklen,&dbcsoutlen,dbcsrepchar);//~v5eiR~
            pci+=dbcschklen;                                       //~v5edR~
            pco+=dbcsoutlen;                                       //~v5edR~
            rc|=rc2;                                               //~v5eiI~
            skiplen+=dbcschklen-dbcsoutlen;                        //~v5egI~
	   		if (Popt & EBC2ASC_LNCONT		//cont line  end by dbcs split//~v5eiI~
	   		&&  rc2 & EBC2ASC_RC_HALFBYTE)                         //~v5eiI~
            	break;                                             //~v5eiI~
            continue;                                              //~v5edR~
        }                                                          //~v5edR~
    	if (ctlsw                                                  //~v57VI~
		&& chi<0x40      //ctl char                                //~v57VI~
		&& (ctlc=Stblctle2a[chi])!=0xff)    //corresponding ascii defined//~v57VR~
        {                                                          //~v57VI~
        	*pco++=ctlc;	                                       //~v57VI~
            continue;                                              //~v57VI~
        }                                                          //~v57VI~
    	if (crlfsw)                                                //~v57GI~
        {                                                          //~v57GI~
//      	if (*pci==EBC_NL)                                      //~v57TR~
        	if (chi==EBC_NL)                                       //~v57TI~
            {                                                      //~v57TI~
//          	*pco++='\n',pci++;                                 //~v57TR~
            	*pco++='\n';                                       //~v57TI~
                continue;                                          //~v57TI~
            }                                                      //~v57TI~
            else                                                   //~v57GI~
//      	if (*pci==EBC_CR)                                      //~v57TR~
        	if (chi==EBC_CR)                                       //~v57TI~
            {                                                      //~v57TI~
//          	*pco++='\r',pci++;                                 //~v57TR~
            	*pco++='\r';                                       //~v57TI~
                continue;                                          //~v57TI~
            }                                                      //~v57TI~
//          else                                                   //~v57TR~
//  			*pco++=Sebc2asc[*pci++];                           //~v57TR~
        }                                                          //~v57GI~
//      else                                                       //~v57TR~
//  		*pco++=Sebc2asc[*pci++];                               //~v57TR~
   		cho=pcvt[chi];                                             //~v57TI~
        if (cho=='.')                                              //~v57TI~
        	if (chi!=EBC_PERIOD)                                   //~v57TI~
                cho=(UCHAR)Prepchar;                               //~v5eqR~
   		*pco++=cho;                                                //~v57TI~
    }                                                              //~v57GI~
//  return Plen;                                                   //~v57UR~
//  return Plen-skiplen;                                           //~v5eiR~
	if (Ppoutlen)                                                  //~v5eiI~
		*Ppoutlen=(int)((ULONG)pco-(ULONG)Pobuff);                 //~v5eiI~
    return rc;                                                     //~v5eiI~
}//ucvebc2asc                                                      //~v57UR~
//**************************************************************** //~v57UI~
//*ebc<--asc by cp1027({pg)                         //~v57UI~
//*ret :rc:UDBCSCHK_RC_DBCSFOUND|DBCSCHK_RC_DBCSSPLIT|UDBCSCHK_RC_DBCSERR//~v5eiR~
//**************************************************************** //~v57UI~
//int ucvasc2ebc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,unsigned char *Pobuff,int Plen,UCHAR Prepchar)//~v5efR~
int ucvasc2ebc(int Popt,unsigned char *Pibuff,unsigned char *Ppdbcs,//~v5eiR~
				unsigned char *Pobuff,int Plen,int Prepchar,int *Ppoutlen)//~v5eiR~
{                                                                  //~v57UI~
	UCHAR *pci,*pco,*pce;                                          //~v57UI~
    int crlfsw,ctlsw;                                              //~v57VR~
    UCHAR *pcvt,cho,chi,ctlc;                                      //~v57VR~
    int S1stsw=0;                                                  //~v57UI~
    UCHAR *pdbcs,tabid;                                            //~v57UI~
    int   skiplen=0;                                               //~v57UI~
    int dbcsrepchar,reslen,dbcschklen,dbcsoutlen;                  //~v5edR~
    int topsw=EBC2ASC_BUFTOP;                                      //~v5egR~
    int rc=0,rc2;                                                  //~v5eiI~
//********************                                             //~v57UI~
    if (!S1stsw)                                                   //~v57UI~
    {                                                              //~v57UI~
    	S1stsw=1;                                                  //~v57UI~
//      ucvebcinita2e();                                           //~v5eqR~
        ucvebcinita2e(Popt);                                       //~v5eqI~
    }                                                              //~v57UI~
	dbcsrepchar=(int)((UINT)Prepchar>>8);                          //~v5eqR~
    Prepchar&=0xff;		//sbcs rep char                            //~v5efI~
    if (!Prepchar)                                                 //~v57UI~
//      Prepchar='?';                                              //~v5epR~
        Prepchar=CHAR_EBC_ERR;                                     //~v5epI~
	pcvt=Stbla2e;                                                  //~v57UI~
	crlfsw=Popt & EBC2ASC_CRLF;                                    //~v57UI~
	ctlsw=Popt & EBC2ASC_CTL;                                      //~v57VI~
    pdbcs=Ppdbcs;                                                  //~v57UI~
//  for (pci=Pibuff,pco=Pobuff,pce=pci+Plen;pci<pce;)              //~v5eiR~
    for (pci=Pibuff,pco=Pobuff,pce=pci+Plen;pci<pce;topsw=0)       //~v5eiI~
    {                                                              //~v57UI~
    	chi=*pci++;                                                //~v57UI~
        if (Popt & EBC2ASC_DBCS)  //dbcs conv                      //~v5eiR~
        if ((topsw && Popt & EBC2ASC_SOCONT)	//top of continued line of SO pending//~v5eiR~
		||  SJIS1(chi))	//dbcs 1st byte                            //~v5eiR~
        {                                                          //~v5edR~
        	pci--;                                                 //~v5edR~
            reslen=(int)((ULONG)pce-(ULONG)pci);                   //~v5edR~
//          ucvebc2_strs2e(Popt,pci,pco,reslen,&dbcschklen,&dbcsoutlen,dbcsrepchar);//~v5egR~
            rc2=                                                   //~v5eiI~
            ucvebc2_strs2e(Popt|topsw,pci,pco,reslen,&dbcschklen,&dbcsoutlen,dbcsrepchar);//~v5egR~
            pci+=dbcschklen;                                       //~v5edR~
            pco+=dbcsoutlen;                                       //~v5edR~
            rc|=rc2;                                               //~v5eiI~
	   		if (Popt & EBC2ASC_LNCONT		//cont line  end by dbcs split//~v5eiI~
	   		&&  rc2 & EBC2ASC_RC_HALFBYTE)                         //~v5eiI~
            	break;                                             //~v5eiI~
            continue;                                              //~v5edR~
        }                                                          //~v5edR~
        if (Ppdbcs)                                                //~v57UI~
        {                                                          //~v57UI~
	    	tabid=*pdbcs++;                                        //~v57UI~
            if (tabid==UDBCSCHK_TAB)                               //~v57UI~
            	chi=UDBCSCHK_TAB;                                  //~v57UI~
            else                                                   //~v57UI~
            	if (chi==' ' && tabid!=0)	//tab cont             //~v57UI~
                {                                                  //~v57UI~
                	skiplen++;                                     //~v57UI~
                	continue;                                      //~v57UI~
                }                                                  //~v57UI~
        }                                                          //~v57UI~
    	if (ctlsw                                                  //~v57VI~
		&& chi<sizeof(Stblctla2e)     //ctl char(<x20 and 7f)      //~v57VR~
		&& (ctlc=Stblctla2e[chi])!=0xff)       //corresponding ebc defined//~v57VR~
        {                                                          //~v57VI~
        	*pco++=ctlc;                                           //~v57VI~
            continue;                                              //~v57VI~
        }                                                          //~v57VI~
    	if (crlfsw)                                                //~v57UI~
        {                                                          //~v57UI~
        	if (chi=='\n')                                         //~v57UI~
            {                                                      //~v57UI~
            	*pco++=EBC_NL;                                     //~v57UI~
                continue;                                          //~v57UI~
            }                                                      //~v57UI~
            else                                                   //~v57UI~
        	if (chi=='\r')                                         //~v57UI~
            {                                                      //~v57UI~
            	*pco++=EBC_CR;                                     //~v57UI~
                continue;                                          //~v57UI~
            }                                                      //~v57UI~
        }                                                          //~v57UI~
   		cho=pcvt[chi];                                             //~v57UI~
        if (!cho)                                                  //~v57UI~
        	cho=(UCHAR)Prepchar;                                   //~v5eqR~
   		*pco++=cho;                                                //~v57UI~
    }                                                              //~v57UI~
//  return Plen-skiplen;                                           //~v5eiR~
    if (Ppoutlen)                                                  //~v5eiI~
		*Ppoutlen=(int)((ULONG)pco-(ULONG)Pobuff);                 //~v5eiR~
    return rc;                                                     //~v5eiI~
}//ucvasc2ebc                                                      //~v57UI~
//**************************************************************** //~v57UI~
//*ebc<--asc by cp1027({pg)                         //~v57UI~
//*ret :length                                                     //~v57UI~
//**************************************************************** //~v57UI~
//void ucvebcinita2e(void)                                         //~v5eqR~
void ucvebcinita2e(int Popt)                                       //+v5eqR~
{                                                                  //~v57UI~
	UCHAR *pc;                                                     //~v57UR~
    int ii;                                                        //~v57UR~
    UCHAR ch;                                                      //~v57UR~
//********************                                             //~v57UI~
  if (Popt&EBC2ASC_CP290)                                          //~v5eqI~
	pc=SebcCP290;                                                  //~v5eqI~
  else                                                             //~v5eqI~
	pc=SebcCP1027;                                                 //~v57UI~
	for (ii=0;ii<256;ii++)                                         //~v57UI~
    {                                                              //~v57UI~
    	ch=*pc++;                                                  //~v57UI~
        if (ch=='.')                                               //~v57UI~
        	if (ii!=EBC_PERIOD)                                    //~v57UI~
            	continue;		//no ebc char                      //~v57UI~
        Stbla2e[ch]=(UCHAR)ii;                                     //~v5eqR~
    }                                                              //~v57UI~
	pc=Stblctle2a;                                                 //~v57VI~
    memset(Stblctla2e,0xff,sizeof(Stblctla2e));	//id of no corresponding ebc//~v57VI~
	for (ii=0;ii<sizeof(Stblctle2a);ii++)                          //~v57VI~
    {                                                              //~v57VI~
    	ch=*pc++;                                                  //~v57VI~
        if (ch==0xff) 	//no corresponding ascii                   //~v57VI~
            continue;		//no ebc char                          //~v57VI~
        Stblctla2e[ch]=(UCHAR)ii;  //map ascii-->ebc               //~v5eqR~
    }                                                              //~v57VI~
    return;                                                        //~v57UR~
}//ucvebcinita2e                                                   //~v57UI~
//**************************************************************** //~v57SI~
//*hankaku katakana & alphabet lowercase                           //~v57SI~
//* if outbuff==0;chk only                                         //~v57SI~
//*ret :when chkonly; 1:conv may occur,0:not found                 //~v57SR~
//*    :     conv   ; conv len                                     //~v57SI~
//**************************************************************** //~v57SI~
int ucvkandl(int Popt,unsigned char *Pibuff,unsigned char *Pobuff,int Plen)//~v57SI~
{                                                                  //~v57SI~
	UCHAR *pci,*pco,*pce;                                          //~v57SI~
    int k2lsw;                                                     //~v57SR~
    UCHAR ch,ch2;                                                  //~v57SR~
    int S1stsw=0;                                                  //~v57VI~
//********************                                             //~v57SI~
    if (!S1stsw)                                                   //~v57VI~
    {                                                              //~v57VI~
    	S1stsw=1;                                                  //~v57VI~
        ucvebcinitkandl();                                         //~v57VI~
    }                                                              //~v57VI~
	k2lsw=Popt & KANDL_K2L;                                        //~v57SI~
	for (pci=Pibuff,pco=Pobuff,pce=pci+Plen;pci<pce;)              //~v57SI~
    {                                                              //~v57SI~
    	ch=*pci++;                                                 //~v57SI~
        if (udbcschk(ch))                                          //~v57SI~
        {                                                          //~v57SI~
            if (Pobuff)                                            //~v57SI~
            {                                                      //~v57SI~
        		*pco++=ch;                                         //~v57SR~
                if (pci==pce)                                      //~v57SI~
                	return KANDL_RC_DBCSSPLIT;                     //~v57SI~
        		*pco++=*pci;                                       //~v57SR~
            }                                                      //~v57SI~
            pci++;                                                 //~v57SI~
            continue;                                              //~v57SI~
        }                                                          //~v57SI~
//sbcs                                                             //~v57SI~
    	if (k2lsw)                                                 //~v57SI~
        {                                                          //~v57SI~
//      	if (ch>0x80)	//may katakana                         //~v57VR~
//          {                                                      //~v57VR~
//          	ch2=Skandl[ch];                                    //~v57VR~
            	ch2=SebcCP290rev[ch];	//back to ebc              //~v57VR~
//              if (ch2!='.')                                      //~v57VR~
                if (ch2)                                           //~v57VI~
                {                                                  //~v57SI~
                	if (!Pobuff)                                   //~v57SI~
                    	return KANDL_RC_WILLCONV;                  //~v57SR~
//              	ch=ch2;		//conv                             //~v57VR~
                	ch=SebcCP1027[ch2];  //re-conv by 1027         //~v57VR~
                }                                                  //~v57SI~
//          }                                                      //~v57VR~
        }                                                          //~v57SI~
        else		//l-->k                                        //~v57SI~
        {                                                          //~v57VI~
//      	if (ch<0x80)	//may alphabetic                       //~v57VR~
//          {                                                      //~v57VR~
//          	ch2=Skandl[ch];                                    //~v57VR~
            	ch2=SebcCP1027rev[ch];	//back to ebc              //~v57VR~
//              if (ch2!='.')                                      //~v57VR~
                if (ch2)                                           //~v57VI~
                {                                                  //~v57SI~
                	if (!Pobuff)                                   //~v57SI~
                    	return KANDL_RC_WILLCONV;                  //~v57SI~
//              	ch=ch2;		//conv                             //~v57VR~
                	ch=SebcCP290[ch2];   //re-conv by 290          //~v57VR~
                }                                                  //~v57SI~
//          }                                                      //~v57VR~
        }                                                          //~v57VI~
        if (Pobuff)                                                //~v57SI~
    		*pco++=ch;                                             //~v57SR~
    }                                                              //~v57SI~
    if (!Pobuff)	//chk only                                     //~v57SI~
    	return 0;                                                  //~v57SR~
    return Plen;                                                   //~v57SI~
}//ucvkandi                                                        //~v57SI~
//**************************************************************** //~v57VI~
//*reverse tbl clraeteion ascii-->EBC                              //~v57VI~
//*ret :length                                                     //~v57VI~
//**************************************************************** //~v57VI~
void ucvebcinitkandl(void)                                         //~v57VI~
{                                                                  //~v57VI~
	UCHAR *pc;                                                     //~v57VI~
    int ii;                                                        //~v57VI~
    UCHAR ch;                                                      //~v57VI~
//********************                                             //~v57VI~
	pc=SebcCP1027;                                                 //~v57VI~
	for (ii=0;ii<256;ii++)                                         //~v57VI~
    {                                                              //~v57VI~
    	ch=*pc++;                                                  //~v57VI~
        if (ch!='.'                                                //~v57VR~
        &&  ch!=SebcCP290[ii])                                     //~v57VI~
        	SebcCP1027rev[ch]=(UCHAR)ii;                           //~v5eqR~
    }                                                              //~v57VI~
	pc=SebcCP290;                                                  //~v57VR~
	for (ii=0;ii<256;ii++)                                         //~v57VI~
    {                                                              //~v57VI~
    	ch=*pc++;                                                  //~v57VI~
        if (ch!='.'                                                //~v57VR~
        &&  ch!=SebcCP1027[ii])                                    //~v57VI~
        	SebcCP290rev[ch]=(UCHAR)ii;                            //~v5eqR~
    }                                                              //~v57VI~
    return;                                                        //~v57VI~
}//ucvebcinitkandl                                                 //~v57VI~
//**************************************************************** //~v5emR~
//*ebc-->sjis                                                      //~v5emR~
//*ret :none                                                       //~v5emR~
//**************************************************************** //~v5emR~
int ucvebc2_chkprintsbcs(int Popt,int Prepchar)                    //~v5emR~
{                                                                  //~v5emR~
    UCHAR cv256out[256],cv256inp[256],*pc;                         //~v5emR~
    int ans,key,outlen,ii,jj;                                      //~v5emR~
//********************                                             //~v5emR~
    pc=cv256inp;                                                   //~v5emR~
    for (ii=0;ii<256;ii++)                                         //~v5emR~
        *pc++=(UCHAR)ii;                                           //~v5eqR~
    if (Popt & EBC2ASC_A2E)                                        //~v5emR~
    {                                                              //~v5emR~
        printf("*** SJIS --> EBCDIC SBCS conversion table ***\n"); //~v5emR~
        ucvasc2ebc(Popt,cv256inp,0,cv256out,256,Prepchar,&outlen); //~v5emR~
    }                                                              //~v5emR~
    else                                                           //~v5emR~
    {                                                              //~v5emR~
        printf("*** EBCDIC --> SJIS SBCS conversion table ***\n"); //~v5emR~
        ucvebc2asc(Popt,cv256inp,0,cv256out,256,Prepchar,&outlen); //~v5emR~
    }                                                              //~v5emR~
    printf("***   option:");                                       //~v5emI~
    if (Prepchar)                                                  //~v5emI~
    	printf("err-char=\"%c\"",Prepchar);                        //~v5emR~
    else                                                           //~v5emI~
    	printf("err-char=?(default)");                             //~v5emI~
    if (Popt & EBC2ASC_CTL)                                        //~v5emI~
    	printf(" default:no ANK/CRLF");                            //~v5enR~
    else                                                           //~v5emI~
    if (Popt & EBC2ASC_CRLF)                                       //~v5emI~
        printf(" CRLF ");                                          //~v5emI~
    else                                                           //~v5emI~
        printf(" ANK ");                                           //~v5emI~
    if (Popt & EBC2ASC_CP290)                                      //~v5eqI~
        printf(" CP290");                                          //~v5eqI~
    else                                                           //~v5eqI~
        printf(" CP1027(default)");                                //~v5eqR~
    printf("\n");                                                  //~v5emI~
    printf("    0-    1-    2-    3-    4-    5-    6-    7-    8-    9-    a-    b-    c-    d-    e-    f-\n");//~v5enR~
    for (ii=0;ii<16;ii++)                                          //~v5emR~
    {                                                              //~v5emR~
        printf("-%1x ",ii);                                        //~v5enR~
        for (jj=0;jj<16;jj++)                                      //~v5emR~
        {                                                          //~v5emR~
            key=cv256inp[(jj<<4)+ii];                              //~v5emI~
            ans=cv256out[(jj<<4)+ii];                              //~v5emR~
		    if (Popt & EBC2ASC_A2E)                                //~v5emI~
    		  if (!(Popt & EBC2ASC_CTL))                           //~v5enR~
                if (key<' ')                                       //~v5enI~
        	    	printf(" %02x:%02x",key,ans);                  //~v5enI~
                else                                               //~v5enI~
        	    	printf(" %c :%02x",key,ans);                   //~v5enI~
              else                                                 //~v5enI~
        	    printf(" %c :%02x",key,ans);                       //~v5enR~
            else                                                   //~v5emI~
        	    printf(" %02x:%c ",ans,ans);                       //~v5enR~
        }                                                          //~v5emR~
        printf("\n");                                              //~v5emI~
    }                                                              //~v5emR~
    return 0;                                                      //~v5emR~
}//ucvebc2_chkprintsbcs                                            //~v5emR~
