//CID://+v5ejR~:                                                   //~v5ejR~
//***********************************************************************
//v5ej:041023 ebc<-->sjis dbcs support;delete rep any char by so/si//~v5ejI~
//v5ei:041023 ebc<-->sjis dbcs support;xe cont line support        //~v5eiI~
//v5eh:041023 ebc<-->sjis dbcs support;length chk option(before set conversion out)//~v5ehI~
//v5ef:041023 ebc<-->sjis dbcs support,dbcs errrep char support    //~v5efI~
//v5ed:041020 ebc<-->sjis dbcs support
//***********************************************************************
//* ucvebc2c
//* ebc<->sjis dbcs conversion
//***********************************************************************
//***********************************************************************

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <ulib.h>
#include <uerr.h>
#include <ucvebc.h>
#include <ucvebc2.h>
#include <udbcschk.h>
//*******************************************************
static EBCMAPTBL *Spe2st=0,*Sps2et;
static DUPMAPTBL *Spdupmap=0;
static JISNEWOLDTBL *Spnewoldt=0;
int    Se2stctr,Ss2etctr,Snewoldctr,Sduptctr;
//*******************************************************
int ucvebc2_codecomp(const void *Pent1,const void *Pent2);
int ucvebc2_s2esub(int Popt,EBCMAPTBL *Ppmapt);
int ucvebc2_e2ssub(int Popt,EBCMAPTBL *Ppmapt);
int ucvebc2_setso(int Popt,UCHAR *Pinp,UCHAR *Pout,                //~v5eiI~
			int Pinplen,int *Poutlen);                             //~v5eiI~
int ucvebc2_setsi(int Popt,UCHAR *Pinp,UCHAR *Pout,                //~v5eiM~
			int Pinplen,int *Pchklen,int *Poutlen);                //~v5eiI~
//*******************************************************
//*dummy for lib(same name as file)						*
//*******************************************************
void ucvebc2(void)
{
	return;
}//ucvebc
//****************************************************************
//*get translation table
//*ret :table addr
//****************************************************************
int ucvebc2_init(void)
{
//********************
	return ucvebc2gettbl(&Spe2st,&Se2stctr,&Sps2et,&Ss2etctr,
						&Spdupmap,&Sduptctr,&Spnewoldt,&Snewoldctr);
}//ucvebc2_init
//****************************************************************
//*get translation table
//*ret :table addr
//****************************************************************
int ucvebc2_codecomp(const void *Pent1,const void *Pent2)
{
	int key1,key2;
//********************
	key1=(int)(((EBCMAPTBL*)(ULONG)Pent1)->EMfrom);                //~v5ejR~
	key2=(int)(((EBCMAPTBL*)(ULONG)Pent2)->EMfrom);                //~v5ejR~
	return (key1-key2);
}//ucvebc2_codecomp
//****************************************************************
//*ebc-->sjis
//*ret :0 if err
//****************************************************************
int ucvebc2_s2e(int Popt,USHORT Psjis)
{
	EBCMAPTBL *panst;
    int ans;
//********************
	if (!Spe2st)
		ucvebc2_init();
	panst=(EBCMAPTBL*)bsearch((void*)(&Psjis),(void*)Sps2et,(UINT)Ss2etctr,sizeof(EBCMAPTBL),ucvebc2_codecomp);//~v5ejR~
    if (!panst)
    	return 0;
	ans=ucvebc2_s2esub(Popt,panst);
    return ans;
}//ucvebc2_s2e
//****************************************************************
//*ebc-->sjis
//*ret :0 if err
//****************************************************************
int ucvebc2_e2s(int Popt,USHORT Pebc)
{
	EBCMAPTBL *panst;
    int ans;
//********************
	if (!Spe2st)
		ucvebc2_init();
	panst=(EBCMAPTBL*)bsearch(&Pebc,Spe2st,(UINT)Se2stctr,sizeof(EBCMAPTBL),ucvebc2_codecomp);//~v5ejR~
    if (!panst)
    	return 0;
	ans=ucvebc2_e2ssub(Popt,panst);
    return ans;
}//ucvebc2_e2s
//****************************************************************
//*ebc-->sjis
//*ret :none
//****************************************************************
int ucvebc2_chkprint(int Popt)
{
	EBCMAPTBL *pmapt,*pmapte;
    int ans,key;
//********************
	if (!Spe2st)
		ucvebc2_init();
	if (Popt & EBC2ASC_A2E)
    {
    	printf("*** SJIS --> EBCDIC conversion table ***\n");
        printf("***   option:");
    	if (!(Popt & (EBC2ASC_OLD|EBC2ASC_NEW)))
            printf(" default(JIS83)");
        else
        {
            if (Popt & EBC2ASC_OLD)
                printf(" JIS78");
            if (Popt & EBC2ASC_NEW)
                printf(" JIS83");
        }
        printf("\n");
        for (pmapt=Sps2et,pmapte=Sps2et+Ss2etctr;pmapt<pmapte;pmapt++)
        {
			ans=ucvebc2_s2esub(Popt,pmapt);
            key=(int)pmapt->EMfrom;
            printf("0x%04x-->0x%04x  //%c%c\n",key,ans,(char)((UINT)key>>8),(char)(key&255));//~v5ejR~
        }
    }
    else   //e2s
    {
    	printf("*** EBCDIC --> SJIS conversion table ***\n");
        printf("***   option:");
    	if (!(Popt & (EBC2ASC_NEC|EBC2ASC_IBM)))
        	printf(" default(IBM)");
        else
        {
    		if (Popt & EBC2ASC_NEC)
            	printf(" NEC");
    		if (Popt & EBC2ASC_IBM)
            	printf(" IBM");
        }
    	if (!(Popt & (EBC2ASC_OLD|EBC2ASC_NEW)))
            printf(" & default(JIS83)");
        else
        {
            if (Popt & EBC2ASC_OLD)
                printf(" & JIS78");
            if (Popt & EBC2ASC_NEW)
                printf(" & JIS83");
        }
        printf("\n");
        for (pmapt=Spe2st,pmapte=Spe2st+Se2stctr;pmapt<pmapte;pmapt++)
        {
			ans=ucvebc2_e2ssub(Popt,pmapt);
            key=(int)pmapt->EMfrom;
            printf("0x%04x-->0x%04x  //%c%c\n",key,ans,(char)((UINT)ans>>8),(char)(ans&255));//~v5ejR~
        }
    }
	return 0;
}//ucvebc2_chkprint
//****************************************************************
//*ebc-->sjis
//*ret :none
//****************************************************************
int ucvebc2_chkprintnewold(int Popt)
{
	JISNEWOLDTBL *pmapt,*pmapte;
    int sjis1,sjis2,ebc1,ebc2;
//********************
	if (!Spe2st)
		ucvebc2_init();
	if (Popt & EBC2ASC_A2E)
    {
    	printf("*** JIS78 & JIS83 exchange list ***\n");
    	printf("SJIS            JIS-83:JIS-78\n");
        for (pmapt=Spnewoldt,pmapte=Spnewoldt+Snewoldctr;pmapt<pmapte;pmapt+=2)//1st entry is dummy
        {
            sjis1=(int)(pmapt->JSTsjisnew);
            sjis2=(int)((pmapt+1)->JSTsjisnew);
            ebc1=(int)(pmapt->JSTebc);
            ebc2=(int)((pmapt+1)->JSTebc);
            printf("0x%04x (%c%c) --> %04x  : %04x\n",
					sjis1,(UINT)sjis1>>8,sjis1&255,ebc1,ebc2);     //~v5ejR~
            printf("0x%04x (%c%c) --> %04x  : %04x\n",
					sjis2,(UINT)sjis2>>8,sjis2&255,ebc2,ebc1);     //~v5ejR~
        }
    }
    else   //e2s
    {
    	printf("*** JIS78 & JIS83 exchange list ***\n");
    	printf("EBC        JIS-83   : JIS-78\n");
        for (pmapt=Spnewoldt,pmapte=Spnewoldt+Snewoldctr;pmapt<pmapte;pmapt+=2)//1st entry is dummy
        {
            sjis1=(int)(pmapt->JSTsjisnew);
            sjis2=(int)((pmapt+1)->JSTsjisnew);
            ebc1=(int)(pmapt->JSTebc);
            ebc2=(int)((pmapt+1)->JSTebc);
            printf("0x%04x --> %04x (%c%c): %04x (%c%c)\n",
					ebc1,sjis1,(UINT)sjis1>>8,sjis1&255,sjis2,(UINT)sjis2>>8,sjis2&255);//~v5ejR~
            printf("0x%04x --> %04x (%c%c): %04x (%c%c)\n",
					ebc2,sjis2,(UINT)sjis2>>8,sjis2&255,sjis1,(UINT)sjis1>>8,sjis1&255);//~v5ejR~
        }
    }
	return 0;
}//ucvebc2_chkprintnewold
//****************************************************************
//*ebc-->sjis
//*ret :none
//****************************************************************
int ucvebc2_chkprintdup(int Popt)
{
	DUPMAPTBL *pmapt,*pmapte;
    int ebc,sjis,sjis1,sjis2,sjis3;
//********************
	if (!Spe2st)
		ucvebc2_init();
    printf("*** SJIS duplicated code point list ***\n");
    printf("EBC    : NonKanji: NEC  : IBM\n");
    for (pmapt=Spdupmap,pmapte=Spdupmap+Sduptctr;pmapt<pmapte;pmapt++)//1st entry is dummy
    {
        ebc=(int)(pmapt->DMebc);
        sjis1=(int)(pmapt->DMnonkanji);
        sjis2=(int)(pmapt->DMnec);
        sjis3=(int)(pmapt->DMibm);
        sjis=sjis1;
        if (!sjis)
        	sjis=sjis2;
        if (!sjis)
        	sjis=sjis3;
        printf("0x%04x :",ebc);
        if (sjis1)
        	printf("    %04x :",sjis1);
        else
        	printf("    -    :");
        if (sjis2)
        	printf(" %04x :",sjis2);
        else
        	printf(" -    :");
        if (sjis3)
        	printf(" %04x :",sjis3);
        else
        	printf(" -    :");
        printf(" (%c%c)\n",(UINT)sjis>>8,sjis&255);                //~v5ejR~
    }
	return 0;
}//ucvebc2_chkprintdup
//****************************************************************
//*ebc-->sjis
//*ret :0 if err
//****************************************************************
int ucvebc2_e2ssub(int Popt,EBCMAPTBL *Ppmapt)
{
	DUPMAPTBL *pdupmap;
    int ans,newoldidx;
//********************
    ans=(int)(Ppmapt->EMto);
    if (ans>0x1000)		//1:1 mapping
    	return ans;
    if (ans & UCVEBC2_DUP2)  //map to nec or ibm area
    {
    	pdupmap=Spdupmap+(ans&0xff);
    	if (Popt & EBC2ASC_NEC)
        	ans=pdupmap->DMnec;
        else
        {
    		if (Popt & EBC2ASC_IBM)
            {
        		ans=pdupmap->DMibm;
            	if (!ans)
	        		ans=pdupmap->DMnonkanji;
            }
            else
            {
		        ans=pdupmap->DMnonkanji;
            	if (!ans)
	        		ans=pdupmap->DMibm;
            }
        }
    }
    else
    if (ans & UCVEBC2_DUP3)  //3 puplicated code(std nonkanji,nec,ibm)
    {
    	pdupmap=Spdupmap+(ans&0xff);
    	if (Popt & EBC2ASC_NEC)
        	ans=pdupmap->DMnec;
        else
        {
            if (Popt & EBC2ASC_OLD)  //new jis seq mapping
                ans=pdupmap->DMibm;
            else
                ans=pdupmap->DMnonkanji;
        }
    }
    else	//new-old sjis mapping
    {
        if (Popt & EBC2ASC_OLD)  //new jis seq mapping
        {
            if (ans & 0x01) //odd number index is new
                newoldidx=ans;  //use next even number index entry
            else
                newoldidx=ans-2;//use prev odd number index entry
        }
        else    //NEW or no parm
            newoldidx=ans-1;    //use the entry(index start from 1)
	    ans=(int)((Spnewoldt+newoldidx)->JSTsjisnew);
    }
    return ans;
}//ucvebc2_e2ssub
//****************************************************************
//*ebc<--sjis
//*ret :0 if err
//****************************************************************
int ucvebc2_s2esub(int Popt,EBCMAPTBL *Ppmapt)
{
    int ans,newoldidx;
//********************
    ans=(int)(Ppmapt->EMto);
    if (ans>=0x4040)	//lowest ebc
    	return ans;
    if (Popt & EBC2ASC_OLD)  //new jis seq mapping
    {
    	if (ans & 0x01)	//odd number index is new
	    	newoldidx=ans;	//use next even number index entry
        else
	    	newoldidx=ans-2;//use prev odd number index entry
    }
    else    //NEW or no parm
    	newoldidx=ans-1;	//use the entry(index start from 1)
    ans=(int)((Spnewoldt+newoldidx)->JSTebc);
    return ans;
}//ucvebc2_e2ssub
//****************************************************************
//*ebc-->sjis  string conv
//*            rep so/si by space or delete so/si by option        //~v5efI~
//*ret :0x01:err rep occured,0x04 last is 1byte or 1byte+SI        //~v5efR~
//****************************************************************
int ucvebc2_stre2s(int Popt,UCHAR *Pinp,UCHAR *Pout,
			int Pinplen,int *Pchklen,int *Poutlen,int Prepchar)
{
	char *pi,*po,*pie;
    int ebc,rc=0,sjis;
//**************************
    if (!Prepchar)
        Prepchar=0x8148;    //"H"                                 //~v5efR~
	pi=Pinp;
	po=Pout;
    pie=pi+Pinplen;	//end addr
	if (*pi==CHAR_SO)
    {
    	if (Popt & EBC2ASC_SOSI) //rep so/si by spce(default)      //~v5efR~
            *po++=' ';      //rep SO by space
        pi++;
    }
    for (;pi<pie;)
    {
    	if (*pi==CHAR_SI)
        	break;
    	ebc=(int)*pi++;
        if (pi==pie)  //2nd byte missing                           //~v5eiR~
        {
        	pi--;                                                  //+v5ejR~
            rc|=EBC2ASC_RC_HALFBYTE;                               //~v5efR~
            break;
        }
        ebc=(ebc<<8)+(int)*pi++;
        sjis=ucvebc2_e2s(Popt,(USHORT)ebc);
        if (sjis)
        {
        	*po++=(char)((UINT)sjis>>8);                           //~v5ejR~
        	*po++=(char)(sjis&255);
        }
        else
        {
            rc|=EBC2ASC_RC_ERRREP;                                 //~v5efR~
        	*po++=(char)((UINT)Prepchar>>8);                       //~v5ejR~
        	*po++=(char)(Prepchar&255);                            //~v5efR~
        }
    }
	if (pi<pie && *pi==CHAR_SI)
    {
    	if (Popt & EBC2ASC_SOSI) //rep by space(default)           //~v5efR~
            *po++=' ';      //rep SO by space
        pi++;
        rc|=EBC2ASC_RC_DBCSFOUND; //dbcs found                     //~v5eiM~
    }
    else                                                           //~v5eiI~
    {                                                              //~v5eiI~
        if (Popt & EBC2ASC_LNCONT)                                 //~v5eiR~
        {                                                          //~v5eiI~
       		rc|=EBC2ASC_RC_SIPEND;                                 //~v5eiI~
	        rc|=EBC2ASC_RC_DBCSFOUND; //dbcs found                 //~v5eiI~
        }                                                          //~v5eiI~
    }                                                              //~v5eiI~
    *Pchklen=(int)((ULONG)pi-(ULONG)Pinp);
    *Poutlen=(int)((ULONG)po-(ULONG)Pout);
    return rc;
}//ucvebc2_stre2s
//****************************************************************
//*ebc<--sjis  string conv
//*parm 3:Pout:output area;if 0 no output set(return output length)//~v5ehI~
//*ret :0x01:err rep occured,0x02:set SI failed,0x04:last is 1st byte of dbcs//~v5efR~
//****************************************************************
int ucvebc2_strs2e(int Popt,UCHAR *Pinp,UCHAR *Pout,
			int Pinplen,int *Pchklen,int *Poutlen,int Prepchar)
{
	char *pi,*po,*pie;
    int ebc,rc=0,sjis,dbcssw=0,len,chklen,outlen;                  //~v5eiR~
//**************************
    if (!Prepchar)
        Prepchar=EBCDBCS_Q; //ebcdic dbcs "?"
	pi=Pinp;
	po=Pout;
    pie=pi+Pinplen;	//end addr
    if ((Popt & EBC2ASC_SOCONT)                                    //~v5eiR~
    &&  (Popt & EBC2ASC_BUFTOP)) //dbcs continued from prev line   //~v5eiI~
    	dbcssw=1;	//set SI                                       //~v5eiI~
    for (;pi<pie;)                                                 //~v5eiR~
    {
    	sjis=(int)*pi;
        if (!SJIS1(sjis))	//dbcs 1st byte
        	break;
        if (pi+1==pie)
        {                                                          //~v5efI~
            rc|=EBC2ASC_RC_HALFBYTE;                               //~v5efI~
        	break;
        }                                                          //~v5efI~
        pi++;
        sjis=(sjis<<8)+(int)*pi++;
        ebc=ucvebc2_s2e(Popt,(USHORT)sjis);
        if (!dbcssw)
        {
        	dbcssw=1;
            rc|=ucvebc2_setso(Popt,pi-2,po,Pinplen,&outlen);       //~v5eiR~
            po+=outlen;                                            //~v5eiR~
        }//1st dbcs                                                //~v5efR~
        if (ebc)
        {
	        *po++=(char)((UINT)ebc>>8);                            //~v5ejR~
	        *po++=(char)(ebc&255);                                 //~v5eiR~
        }
        else
        {
        	*po++=(char)((UINT)Prepchar>>8);                       //~v5ejR~
        	*po++=(char)(Prepchar&255);                            //~v5eiR~
            rc|=EBC2ASC_RC_ERRREP;                                 //~v5efI~
        }
    }
    if (dbcssw)
    {
        rc|=EBC2ASC_RC_DBCSFOUND; //dbcs found                     //~v5eiI~
      	 if (Popt & (EBC2ASC_SOSI | EBC2ASC_SOSIOS))//SOSI SET OPTION//~v5ejR~
      	 {                                                         //~v5eiR~
       		if ((Popt & EBC2ASC_LNCONT)                            //~v5eiR~
	   		&&  (pi==pie || rc & EBC2ASC_RC_HALFBYTE))	//line continued to next//~v5eiR~
       			rc|=EBC2ASC_RC_SIPEND;                             //~v5eiR~
       		else	//line not continued to next line              //~v5eiR~
            {                                                      //~v5eiI~
				len=(int)((ULONG)pie-(ULONG)pi);                   //~v5eiI~
				rc|=ucvebc2_setsi(Popt,pi,po,len,&chklen,&outlen); //~v5eiI~
                pi+=chklen;                                        //~v5eiI~
                po+=outlen;                                        //~v5eiI~
            }                                                      //~v5eiI~
      	 }//SOSI SET OPTION                                        //~v5eiR~
    }
    *Pchklen=(int)((ULONG)pi-(ULONG)Pinp);
    *Poutlen=(int)((ULONG)po-(ULONG)Pout);
    return rc;
}//ucvebc2_strs2e
//**************************************************************** //~v5eiI~
//*write SI                                                        //~v5eiI~
//**************************************************************** //~v5eiI~
int ucvebc2_setsi(int Popt,UCHAR *Pinp,UCHAR *Pout,                //~v5eiI~
			int Pinplen,int *Pchklen,int *Poutlen)                 //~v5eiI~
{                                                                  //~v5eiI~
	char *pi,*po,*pie;                                             //~v5eiI~
    int rc=0;                                                      //~v5eiI~
//**************************                                       //~v5eiI~
    pi=Pinp;                                                       //~v5eiI~
    po=Pout;                                                       //~v5eiI~
    pie=pi+Pinplen;	//end addr                                     //~v5eiI~
    if (Popt & EBC2ASC_SOSI) //ins so/si                           //~v5eiI~
        *po++=CHAR_SI;                                             //~v5eiI~
    else                                                           //~v5eiI~
    if (Popt & EBC2ASC_SOSIOS) //override space                    //~v5ejR~
    {                                                              //~v5eiI~
        if (pi<pie && *pi==' ')                                    //~v5eiI~
        {                                                          //~v5eiI~
            pi++;                                                  //+v5ejR~
            *po++=CHAR_SI;                                         //~v5eiI~
        }                                                          //~v5eiI~
        else                                                       //~v5eiI~
        {                                                          //~v5eiI~
            *po++=CHAR_SI;                                         //~v5eiI~
            rc|=EBC2ASC_RC_ISRTSI;    //inserted SI                //~v5eiI~
        }                                                          //~v5eiI~
    }                                                              //~v5eiI~
//  else                                                           //~v5ejR~
//  if (Popt & EBC2ASC_SOSIOA) //override any char                 //~v5ejR~
//  {                                                              //~v5ejR~
//      if (pi<pie)                                                //~v5ejR~
//      {                                                          //~v5ejR~
//          *pi++;                                                 //~v5ejR~
//          *po++=CHAR_SI;                                         //~v5ejR~
//      }                                                          //~v5ejR~
//      else                                                       //~v5ejR~
//      {                                                          //~v5ejR~
//          *po++=CHAR_SI;                                         //~v5ejR~
//          rc|=EBC2ASC_RC_ISRTSI;    //inserted SI                //~v5ejR~
//      }                                                          //~v5ejR~
//  }                                                              //~v5ejR~
    *Pchklen=(int)((ULONG)pi-(ULONG)Pinp);                         //~v5eiI~
    *Poutlen=(int)((ULONG)po-(ULONG)Pout);                         //~v5eiI~
    return rc;                                                     //~v5eiI~
}//ucvebc2_setsi                                                   //~v5eiI~
//**************************************************************** //~v5eiI~
//*write SO                                                        //~v5eiI~
//**************************************************************** //~v5eiI~
int ucvebc2_setso(int Popt,UCHAR *Pinp,UCHAR *Pout,                //~v5eiI~
			int Pinplen,int *Poutlen)                              //~v5eiI~
{                                                                  //~v5eiI~
	char *po;                                                      //~v5eiR~
    int rc=0;                                                      //~v5eiI~
//**************************                                       //~v5eiI~
    po=Pout;                                                       //~v5eiI~
    if (Popt & EBC2ASC_SOSI) //ins so/si                           //~v5eiI~
        *po++=CHAR_SO;                                             //~v5eiI~
    else                                                           //~v5eiI~
    if (Popt & EBC2ASC_SOSIOS) //override space                    //~v5ejR~
    {                                                              //~v5eiI~
        if (Popt & EBC2ASC_BUFTOP) //override spece                //~v5eiI~
        {                                                          //~v5eiI~
            rc|=EBC2ASC_RC_ISRTTOPSO;    //insertion occued        //~v5eiR~
            *po++=CHAR_SO;                                         //~v5eiI~
        }                                                          //~v5eiI~
        else                                                       //~v5eiI~
        if (*(Pinp-1)==' ')                                        //~v5eiI~
            *(po-1)=CHAR_SO;                                       //~v5eiI~
        else                                                       //~v5eiI~
        {                                                          //~v5eiI~
            *po++=CHAR_SO;                                         //~v5eiI~
            rc|=EBC2ASC_RC_ISRTSO;    //insertion occued           //~v5eiI~
        }                                                          //~v5eiI~
    }                                                              //~v5eiI~
//  else                                                           //~v5ejR~
//  if (Popt & EBC2ASC_SOSIOA) //override any char                 //~v5ejR~
//  {                                                              //~v5ejR~
//      if (Popt & EBC2ASC_BUFTOP) //override spece                //~v5ejR~
//      {                                                          //~v5ejR~
//          rc|=EBC2ASC_RC_ISRTSO;    //insertion occued           //~v5ejR~
//          *po++=CHAR_SO;                                         //~v5ejR~
//      }                                                          //~v5ejR~
//      else                                                       //~v5ejR~
//          *po++=CHAR_SO;                                         //~v5ejR~
//  }                                                              //~v5ejR~
    *Poutlen=(int)((ULONG)po-(ULONG)Pout);                         //~v5eiI~
    return rc;                                                     //~v5eiI~
}//ucvebc2_setso                                                   //~v5eiI~
