//*CID://+v5b6R~:                             update#=  150;       //+v5b6R~
//**************************************************               //~v57cI~
//* ucvucs.h                                                       //~v57cI~
//**************************************************               //~v57cI~
//v5h6:060321 ucs conv:support \u option for sjis2ucs(\uxxxx format output)//+v5b6I~
//v5b3:040122 \uxxxx unicode fmt conv support                      //~v5b3I~
//v57p:030118 (AIX)display all ms932 char                          //~v57pI~
//v57m:030111 (BUG)rrmsg function:display byte                     //~v57mI~
//v57k:030106 cp943,sjis option(ucvucst is ms932)                  //~v57kR~
//v57k:030101 add termfunc(free word)                              //~v57kI~
//v57j:021231 ucs conv:err callback function support               //~v57iI~
//v57i:021231 ucs conv:set rc for ucs=-1                           //~v57iI~
//v57c:021214 unicode,utf8 conversion support                      //~v57cI~
//**************************************************               //~v57cI~
#if defined(DOS) && !defined(DPMI)                                 //~v57cI~
	#define UCVUINTERRUCS    0xffff                                //~v57cI~
#else                                                              //~v57cI~
	#define UCVUINTERRUCS    0xffffffff                            //~v57cI~
#endif                                                             //~v57cI~
#define UCVERRUCS        0xffff                                    //~v57cR~
#define UCVULONGERRUCS   0xffffffff                                //~v57cI~
//*                                                                //~v57cI~
#define UCVUCS_FMTERR   0x01                                       //~v57cR~
#define UCVUCS_LENERR   0x02                                       //~v57cR~
#define UCVUCS_CONVERR  0x04                                       //~v57cI~
#define UCVUCS_BUFFOVF  0x08                                       //~v57cR~
#define UCVUCS_ERRCH    0x00ff //replace char for err ucs code to sjis//~v57kR~
#define UCVUCS_LE       0x0100 //output ucs by little endian       //~v57cR~
#define UCVUCS_UCS4     0x0200 //accept ucs4                       //~v57cR~
#define UCVUCS_BOM      0x0400 //chk file BOM (Big endian if no BOM),write BOM//~v57cR~
#define UCVUCS_FULLREC  0x0800 //force conv last len err byte      //~v57cR~
#define UCVUCS_NOERRMSG 0x1000 //no err msg output option          //~v57cI~
#define UCVUCS_CP943C   0x2000 //sjis -->ucs by ibm cp943c         //~v57kR~
#define UCVUCS_CPMS932  0x4000 //sjis -->ucs by ms932              //~v57kR~
#define UCVUCS_NEC      0x8000 //sjis<-- ucs to NEC select SJIS range//~v57kR~
#define UCVUCS_ESCUCS 0x010000 //input is \uxxxx unicode fmt       //~v5b3R~
//**************************************************               //~v57cI~
typedef int (UCVUCS_FREAD)(UCHAR *Preadbuff,int Pbuffsz,int *Preadlen);	//read func//~v57cI~
typedef int (UCVUCS_FWRITE)(UCHAR *Preadbuff,int Pwritelen);	//write func//~v57cI~
typedef int (UCVUCS_FERR)(int Prc,int Poffs,int Poutoffs,UCHAR *Perrbyte,int Perrbytelen);	//err callback//~v57mR~
typedef int (UCVUCS_FCONV)(UCVUCS_FREAD *Pfread,UCVUCS_FWRITE *Pfwrite,UCVUCS_FERR *Pferr,//~v57iR~
			 ULONG Popt,UCHAR *Pibuff,int Pibuffsz,UCHAR *Pobuff,int Pobuffsz);//~v57kR~
//**************************************************               //~v57cI~
int ucp932init(USHORT **Ps2u,USHORT **Pu2s);                       //~v57kI~
//**************************************************               //~v57kI~
int ucp932term(void);                                              //~v57kR~
//**************************************************               //~v57pI~
ULONG ucp932sjis2ucs(int Psjis);                                   //~v57pI~
//**************************************************               //~v57kI~
ULONG uccvsjis2ucs(ULONG Popt,int Psjis);                          //~v57kR~
//**************************************************               //~v57iI~
//int uccvsjis2ucss(ULONG Popt,int Psjis,UCHAR *Pucs);             //+v5b6R~
int uccvsjis2ucss(ULONG Popt,int Psjis,UCHAR *Pucs,int *Poutlen);  //+v5b6I~
//**************************************************               //~v57cI~
int uccvucs2sjis(ULONG Popt,ULONG Pucs);                           //~v57kR~
//**************************************************               //~v57cI~
int uccvucs2utf(ULONG Pucs,UCHAR *Putf);                           //~v57cR~
//**************************************************               //~v57cI~
int uccvucss2utf(ULONG Popt,UCHAR *Ppucs,UCHAR *Putf);             //~v57kR~
//**************************************************               //~v57cI~
int ucvsucs2utf(UCVUCS_FERR *Pferr,ULONG Popt,UCHAR *Pibuff,int Pibufflen,UCHAR *Pobuff,int Pobufflen,//~v57kR~
				int *Ppchklen,int *Ppoutlen,int *Pperrctr);        //~v57iR~
//**************************************************               //~v57cI~
int uccvutf2ucs(ULONG Popt,UCHAR *Putf,int Plen,ULONG *Ppucs,int *Ppchklen);//~v57kR~
//**************************************************               //~v57cI~
int ucvsutf2ucs(UCVUCS_FERR *Pferr,ULONG Popt,UCHAR *Pibuff,int Pibufflen,UCHAR *Pobuff,int Pobufflen,//~v57kR~
				int *Ppchklen,int *Ppoutlen,int *Pperrctr);        //~v57iR~
//**************************************************               //~v57cI~
//int uccvutf2ucss(ULONG Popt,UCHAR *Putf,int Plen,UCHAR *Pucs,int *Ppchklen);//+v5b6R~
int uccvutf2ucss(ULONG Popt,UCHAR *Putf,int Plen,UCHAR *Pucs,int *Ppchklen,int *Poutlen);//+v5b6I~
//**************************************************               //~v57cI~
//int uccvsjis2utf(int Psjis,UCHAR *Putf);                         //~v57iR~
//int uccvsjis2utf(int Psjis,UCHAR *Putf,int *Pplen);              //~v57kR~
int uccvsjis2utf(ULONG Popt,int Psjis,UCHAR *Putf,int *Pplen);     //~v57kR~
//**************************************************               //~v57cI~
int uccvutf2sjis(ULONG Popt,UCHAR *Putf,int Plen,int *Ppsjis,int *Ppchklen);//~v57kR~
//**************************************************               //~v57cI~
int ucvssjis2utf(UCVUCS_FERR *Pferr,ULONG Popt,UCHAR *Pibuff,int Pibufflen,UCHAR *Pobuff,int Pobufflen,//~v57kR~
				int *Ppchklen,int *Ppoutlen,int *Pperrctr);        //~v57iR~
//**************************************************               //~v57cI~
int ucvsutf2sjis(UCVUCS_FERR *Pferr,ULONG Popt,UCHAR *Pibuff,int Pibufflen,UCHAR *Pobuff,int Pobufflen,//~v57kR~
				int *Ppchklen,int *Ppoutlen,int *Pperrctr);        //~v57iR~
//**************************************************               //~v57cI~
int ucvsucs2sjis(UCVUCS_FERR *Pferr,ULONG Popt,UCHAR *Pibuff,int Pibufflen,UCHAR *Pobuff,int Pobufflen,//~v57kR~
				int *Ppchklen,int *Ppoutlen,int *Pperrctr);        //~v57iR~
//**************************************************               //~v57iI~
int ucvssjis2ucs(UCVUCS_FERR *Pferr,ULONG Popt,UCHAR *Pibuff,int Pibufflen,UCHAR *Pobuff,int Pobufflen,//~v57kR~
				int *Ppchklen,int *Ppoutlen,int *Pperrctr);        //~v57iR~
//**************************************************               //~v57cI~
UCVUCS_FCONV ucvfsjis2ucs;                                         //~v57cR~
UCVUCS_FCONV ucvfucs2sjis;                                         //~v57cI~
UCVUCS_FCONV ucvfutf2ucs;                                          //~v57cI~
UCVUCS_FCONV ucvfucs2utf;                                          //~v57cI~
UCVUCS_FCONV ucvfsjis2utf;                                         //~v57cI~
UCVUCS_FCONV ucvfutf2sjis;                                         //~v57cI~
//**************************************************               //~v57cI~
int ucvbomchk(ULONG *Ppopt,UCHAR *Putf,int Putfbufflen);           //~v57kR~
//**************************************************               //~v57cI~
int ucvbomset(ULONG Popt,UCHAR *Putf);                             //~v57kR~
//**************************************************               //~v57cI~
int ucvsetucss(ULONG Ppopt,ULONG Pucs,UCHAR *Pucss);               //~v57kR~
//**************************************************               //~v57cI~
ULONG ucvgetucss(ULONG Popt,UCHAR *Pucs);                          //~v57kR~
