//*CID://+v5jdR~:                             update#=  233;       //~v5jdR~
//************************************************************* //~5903R~
//*ufile2f.c                                                       //~v56jR~
//*  FTP  version of                                               //~v56jR~
//      rename,remove,umkdir,urmdir,uattrib,ugetftime,usetftime,ucopypathinfo//~v56jR~
//************************************************************* //~5617I~
//v5jd:061002 3270 support:rename/delete                           //~v5jdI~
//v5fq:050321 (BUG:FTP)multidel/multirename err rc set missing     //~v5fqI~
//v5fn:050317 (FTP)undel support                                   //~v5fnI~
//v5fd:050101 (FTP)fulction to delete multiple file at once.       //~v5fdI~
//v5ev:041031 ftp chmod:try rsh after setmod failed                //~v5evI~
//v5d7:040529 (FTP)delete process duplicated                       //~v5d7I~
//v5cn:040508 (FTP:BUG)abend when mkdir faile(551:exist)           //~v5cnI~
//v5bg:040204 (FTP:BUG)rename should have valid pathname for newname//~v5bfI~
//v5bf:040204 (FTP:BUG)space containing filename support           //~v5bfI~
//v5am:040110 (FTP)del file in a dir at once for performance       //~v5amI~
//v5ah:040108 (FTP)ignore new name path on rename                  //~v5ahI~
//v5af:040106 pass PUFTPHOST as parm not but nodename to chk TZ,SJIS option etc//~v5afI~
//************************************************************* //~5903I~
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>                                              //~5825I~
#include <sys/types.h>                                             //~0827I~
#include <sys/stat.h>                                              //~0827R~
#ifdef UNX                                                         //~v56jI~
	#include <unistd.h>                                            //~v56jR~
#else                                                              //~v56jI~
	#include <dos.h>                                               //~v56jI~
	#include <error.h>                                             //~v56jI~
#endif                                                             //~v56jI~
//*******************************************************
//*******************************************************
#include <ulib.h>
#include <uque.h>                                                  //~v56jI~
#include <ufile.h>
#include <ufile2.h>                                             //~5826I~
#include <ufile5.h>                                                //~v56jI~
#include <ufemsg.h>                                                //~v036I~
#include <uerr.h>
#include <ualloc.h>                                             //~5913I~
#include <ustring.h>                                               //~v085I~
#include <utrace.h>                                                //~v012I~
#include <uedit.h>                                                 //~v195R~
#ifdef UNX                                                         //~v56jI~
	#include <uunxsub.h>                                           //~v56jR~
#endif                                                             //~v56jI~
#ifdef FTPSUPP                                                     //~v56jI~
#ifdef UNX                                                         //~v56jI~
	#include <ufile2l.h>                                           //~v56jI~
#endif                                                             //~v56jI~
	#include <uftp.h>                                              //~v56jI~
	#include <ufile1f.h>                                           //~v56jI~
#endif                                                             //~v56jI~
#include <uproc.h>                                                 //~v5evR~
#include <uproc2.h>                                                //~v5evI~
#include <u3270.h>                                                 //~v5jdI~
#include <u32702.h>                                                //~v5jdI~
//*******************************************************
static int Srenameopt=0;                                           //~v56jI~
//*******************************************************
int uftprenamesub(PUFTPHOST Ppuftph,UCHAR *Poldname,UCHAR *Pnewname);//~v5afR~
int uftpwildrename(PUFTPHOST Ppuftph,UCHAR *Pfullpath,PUDIRLIST Ppudirlist,PVOID Pparm);//~v5afR~
int ufile2putstmt(FILE *Phfile,char *Pcmd,char *Pfnm);             //~v5amI~
int uftpxdelrchk(PUFWF2PARM Ppfwf2p,char **Ppstdo,int Pstdoctr);   //~v5amI~
int uftpmultidelrchk(PUFWF2PARM Ppfwf2p,char **Ppstdo,int Pstdoctr);//~v5fdI~
int uftpmultirenamerchk(PUFWF2PARM Ppfwf2p,char **Ppstdo,int Pstdoctr);//~v5fnI~
//**************************************************************** //~v56jM~
//*umkdir                                                          //~v56jM~
//*  257:mkd command success                                       //~v56jR~
//*  550:file exist/not found/permisson denied                     //~v56jR~
//*retrn:rc(=errno)                                                //~v56jM~
//**************************************************************** //~v56jM~
int uftpmkdir(PUFTPHOST Ppuftph,UCHAR *Pdirname,ULONG Pmode,ULONG *Pprmode)//~v5afR~
{                                                                  //~v56jM~
	FILEFINDBUF3 ffb3;                                             //~v56jI~
    UCHAR ftpcmd[FTP_MAXPATH];                                     //~v56jM~
    char **stdo,**stdo0,*dirname;                                  //~v56jR~
    int stdoctr,rc,rc2,mode;                                       //~v56jR~
//*********************************                                //~v56jM~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
        return u3270mkdir(Ppuftph,Pdirname,Pmode,Pprmode);         //~v5jdI~
    dirname=Pdirname+Ppuftph->UFTPHhostnmlen+1;                    //~v5afR~
    if (Pmode)                                                     //~v56jR~
    {                                                              //~v56jI~
    	mode=(int)(Pmode & FTP_CHMODMASK);                         //~v56jR~
    	sprintf(ftpcmd,                                            //~v56jI~
            "mkdir \"%s\"\n"              \
            "site chmod %o \"%s\"\n",                              //~v5bfR~
             dirname,mode,dirname);                                //~v56jR~
    }                                                              //~v56jI~
    else                                                           //~v56jI~
	    sprintf(ftpcmd,                                            //~v56jR~
            "mkdir \"%s\"\n",                                      //~v5bfR~
             dirname);                                             //~v56jM~
    rc=uftpcmd(Ppuftph,0,ftpcmd,&stdo0,&stdoctr,0,0);	//get stdout/stderr//~v5afR~
    stdo=stdo0;                                                    //~v56jI~
    if (!rc)                                                       //~v56jM~
    {                                                              //~v56jM~
//  	rc=uftpsimplerespchk("mkdir","257 550 ",Pdirname,&stdo,&stdoctr,ENOENT);//~v5cnR~
    	rc=uftpsimplerespchk("mkdir","257 5** ",Pdirname,&stdo,&stdoctr,ENOENT);//~v5cnI~
        if (!rc)	//mkdir success                                //~v56jI~
        {                                                          //~v56jI~
    		if (Pmode)                         //site chmod issued //~v56jI~
            {                                                      //~v56jI~
		        rc2=uftpcmdsrchrespid(&stdo,&stdoctr,"200 ");	//site cmd//~v56jI~
                if (rc2)                                           //~v56jI~
                	uerrmsg("\"site chmod %o %s\" failed",0,	   //~v56jI~
					         mode,dirname);                        //~v56jI~
            }                                                      //~v56jI~
            if (Pprmode)                                           //~v56jR~
            {                                                      //~v56jR~
                if (uftpfstat(Ppuftph,dirname,&ffb3))              //~v5afR~
                    *Pprmode=0;                                    //~v56jM~
                else                                               //~v56jI~
                    *Pprmode=FILE_GETMODE(ffb3.attrFile) & FTP_CHMODMASK;//~v56jM~
            }                                                      //~v56jR~
        }                                                          //~v56jI~
	    ufree(stdo0);                                              //~v56jM~
    }                                                              //~v56jM~
    return rc;                                                     //~v56jR~
}//uftpmkdir                                                       //~v56jM~
//**************************************************************** //~v56jM~
//*urmdir                                                          //~v56jM~
//* remove dir                                                     //~v56jM~
//*  250:rmd command success                                       //~v56jI~
//*  550:file exist/not found/permisson denied                     //~v56jI~
//*retrn:rc(=errno),-2:root dir,-3:current dir                     //~v56jM~
//**************************************************************** //~v56jM~
int uftprmdir(PUFTPHOST Ppuftph,UCHAR *Pdirname)                   //~v5afR~
{                                                                  //~v56jM~
    UCHAR ftpcmd[FTP_MAXPATH];                                     //~v56jI~
    char **stdo,**stdo0,*dirname;                                  //~v56jI~
    int stdoctr,rc;                                                //~v56jI~
//********************                                             //~v56jM~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270rmdir(Ppuftph,Pdirname);                       //~v5jdI~
    dirname=Pdirname+Ppuftph->UFTPHhostnmlen+1;                    //~v5afR~
    if (FTP_ROOTDIR(dirname))  //dosfindfirst faile if root        //~v56jR~
        return ufileroot(Pdirname,-2);                             //~v56jM~
//  if (!uftpfullpath(fpath,Pdirname,FTP_MAXPATH))                 //~v56jI~
//      return -1;                                                 //~v56jI~
    sprintf(ftpcmd,                                                //~v56jI~
            "rmdir \"%s\"\n",                                      //~v5bfR~
             dirname);                                             //~v56jI~
    rc=uftpcmd(Ppuftph,0,ftpcmd,&stdo0,&stdoctr,0,0);	//get stdout/stderr//~v5afR~
    if (!rc)                                                       //~v56jI~
    {                                                              //~v56jI~
        stdo=stdo0;                                                //~v56jI~
        rc=uftpcmdsrchrespid(&stdo,&stdoctr,"250 550 ");           //~v56jI~
        switch(rc)                                                 //~v56jI~
        {                                                          //~v56jI~
        case 0:    //250                                           //~v56jR~
        	break;                                                 //~v56jI~
        case 1:    //550                                           //~v56jI~
		    if (!Gufile_nomsg)   //nomsg option                    //~v56jI~
        		uerrmsg("rmdir failed.(%s)",0,                     //~v56jR~
						*(stdo-1));	//already exit or path not found//~v56jR~
            rc=ENOENT;                                             //~v56jI~
        	break;                                                 //~v56jI~
        default:                                                   //~v56jI~
            ;                                                      //~v56jI~
        }                                                          //~v56jI~
        ufree(stdo0);                                              //~v56jI~
    }                                                              //~v56jI~
    return rc;                                                     //~v56jR~
}//uftprmdir                                                       //~v56jR~
//**************************************************************** //~v56jI~
//*uremove                                                         //~v56jI~
//* delete file,cannot del dir                                     //~v56jI~
//* 250:command success                                            //~v56jI~
//* 550:no such file                                               //~v56jI~
//*parm1:file name                                                 //~v56jI~
//*retrn:rc(=errno)                                                //~v56jI~
//**************************************************************** //~v56jI~
int uftpremove(PUFTPHOST Ppuftph,int Popt,UCHAR *Pfilename)        //~v5afR~
{                                                                  //~v56jI~
    UCHAR ftpcmd[FTP_MAXPATH];                                     //~v56jI~
    char **stdo,**stdo0,*pfname;                                   //~v56jR~
    int stdoctr,rc;                                                //~v56jR~
//*********************************                                //~v56jI~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270remove(Ppuftph,Popt,Pfilename);                //~v5jdI~
    pfname=Pfilename+Ppuftph->UFTPHhostnmlen+1;                    //~v5afR~
    sprintf(ftpcmd,                                                //~v56jI~
            "delete \"%s\"\n",                                     //~v5bfR~
             pfname);                                              //~v56jI~
    rc=uftpcmd(Ppuftph,0,ftpcmd,&stdo0,&stdoctr,0,0);	//get stdout/stderr//~v5afR~
    if (!rc)                                                       //~v56jI~
    {                                                              //~v56jI~
        stdo=stdo0;                                                //~v56jI~
        rc=uftpcmdsrchrespid(&stdo,&stdoctr,"250 550 ");           //~v56jI~
        switch(rc)                                                 //~v56jI~
        {                                                          //~v56jI~
        case 0:    //250                                           //~v56jI~
    	    if (Popt & UXDELMSG) //msg put option                  //~v56jI~
         	   ufiledeleted(Pfilename,'F',-1,0);//size=-1  mean no display size/attr//~v56jI~
        	break;                                                 //~v56jI~
        case 1:    //550                                           //~v56jI~
		    if (!Gufile_nomsg)   //nomsg option                    //~v56jI~
        		uerrmsg("%s remove failed.(%s)",0,                 //~v5amR~
						Pfilename,*(stdo-1));	//already exit or path not found//~v5amR~
            rc=ENOENT;                                             //~v56jI~
        	break;                                                 //~v56jI~
        default:                                                   //~v56jI~
            ;                                                      //~v56jI~
        }                                                          //~v56jI~
        ufree(stdo0);                                              //~v56jI~
    }                                                              //~v56jI~
    return rc;                                                     //~v56jI~
}//uftpremove                                                      //~v56jI~
//**************************************************************** //~v56jI~
//urename                                                          //~v56jI~
//*retrn:rc(=errno)                                                //~v56jI~
//**************************************************************** //~v56jI~
int uftprename(PUFTPHOST Ppuftph,int Popt,UCHAR *Poldname,UCHAR *Pnewname,UCHAR *Pnewspec)//~v5afR~
{                                                                  //~v56jI~
    int rc;                                                        //~v56jI~
    int pathlen1,pathlen2;                                         //~v56jI~
    int renamectr;                                                 //~v56jR~
    UCHAR *pc;                                                     //~v56jR~
    UCHAR realname[FTP_MAXPATH];                                   //~v56jR~
//********************                                             //~v56jI~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270rename(Ppuftph,Popt,Poldname,Pnewname,Pnewspec);//~v5jdI~
	Srenameopt=Popt;                                               //~v56jI~
    pathlen1=FTP_PATHLEN(Poldname);                                //~v56jR~
    pathlen2=FTP_PATHLEN(Pnewname);                                //~v56jR~
    if (pc=WILDCARD(Poldname),pc)   //wild char pos                //~v56jI~
    {                                                              //~v56jI~
        if (pathlen1 && (ULONG)pc-(ULONG)Poldname<(ULONG)pathlen1) //~v56jI~
            return ufilewildpatherr(-1);                           //~v56jI~
        rc=uftpwildfunc(Ppuftph,Poldname,FILE_ALL,uftpwildrename,Pnewname,&renamectr);//~v5afR~
        if (rc)                                                    //~v56jI~
            return rc;                                             //~v56jI~
        uerrmsg("%d object renamed",                               //~v56jI~
                "%d ",                                       //~v56jI~
                renamectr);                                        //~v56jI~
        return 0;                                                  //~v56jI~
    }                                                              //~v56jI~
    if (WILDCARD(Pnewname))                                        //~v56jI~
    {                                                              //~v56jI~
        memcpy(realname,Pnewname,(UINT)pathlen2);                  //~v56jI~
        udoseditname(DEN_UNIX | DEN_CASE,                          //~v56jR~
					Poldname+pathlen1,Pnewname+pathlen2,realname+pathlen2);//~v56jI~
        if (Pnewspec)   //no output  parm                          //~v56jI~
            strcpy(Pnewspec,realname);                             //~v56jI~
        Pnewname=realname;                                         //~v56jI~
        if (WILDCARD(Pnewname))     //path has wild card           //~v56jI~
            return ufilewildpatherr(-1);                           //~v56jI~
    }                                                              //~v56jI~
    else                                                           //~v56jI~
        if (Pnewspec)   //no output  parm                          //~v56jI~
            *Pnewspec=0;        //return id of no wild card        //~v56jI~
//rename succes evenif newname exist;                              //~v56jI~
	if (!Popt)		//not override existing option                 //~v56jR~
    {                                                              //~v56jI~
        if (uftpisexist(Ppuftph,Pnewname))    //exist chk          //~v5afR~
            return ufileexist(Pnewname,EEXIST);                    //~v56jR~
    }                                                              //~v56jI~
    return uftprenamesub(Ppuftph,Poldname,Pnewname);               //~v5afR~
}//uftprename                                                      //~v56jI~
//**************************************************************** //~v56jI~
//uftprenamesub                                                    //~v56jI~
//*retrn:rc(=errno)                                                //~v56jI~
//**************************************************************** //~v56jI~
int uftprenamesub(PUFTPHOST Ppuftph,UCHAR *Poldname,UCHAR *Pnewname)//~v5afR~
{                                                                  //~v56jI~
//  UCHAR ftpcmd[FTP_MAXPATH];                                     //~v5fnR~
    UCHAR ftpcmd[FTP_MAXPATH+FTP_MAXPATH+32];                      //~v5fnI~
    char **stdo,**stdo0,*poldname,*pnewname;                       //~v5ahR~
    int stdoctr,rc;                                                //~v56jI~
//*********************************                                //~v56jI~
    poldname=Poldname+Ppuftph->UFTPHhostnmlen+1;                   //~v5afR~
//  pnewname=Pnewname+PATHLEN(Pnewname);                           //~v5bgR~
    pnewname=Pnewname+Ppuftph->UFTPHhostnmlen+1;                   //~v5bgI~
    sprintf(ftpcmd,                                                //~v56jI~
            "rename \"%s\" \"%s\"\n",   //rename success even if already existing target//~v5bfR~
             poldname,pnewname);                                   //~v5ahR~
    rc=uftpcmd(Ppuftph,0,ftpcmd,&stdo0,&stdoctr,0,0);	//get stdout/stderr//~v5afR~
    if (!rc)                                                       //~v56jI~
    {                                                              //~v56jI~
        stdo=stdo0;                                                //~v56jI~
        rc=uftpcmdsrchrespid(&stdo,&stdoctr,"250 550 ");           //~v56jR~
        switch(rc)                                                 //~v56jI~
        {                                                          //~v56jI~
        case 0:    //250                                           //~v56jI~
        	break;                                                 //~v56jI~
//      case 1:    //350 	//already exist but done               //~v56jR~
        case 1:    //550                                           //~v56jR~
		    if (!Gufile_nomsg)   //nomsg option                    //~v56jI~
        		uerrmsg("rename %s->%s failed .(%s)",0,            //~v56jI~
						Poldname,Pnewname,*(stdo-1));	//already exit or path not found//~v56jI~
            rc=ENOENT;                                             //~v56jI~
        	break;                                                 //~v56jI~
        default:                                                   //~v56jI~
            ;                                                      //~v56jI~
        }                                                          //~v56jI~
        ufree(stdo0);                                              //~v56jI~
    }                                                              //~v56jI~
    return rc;                                                     //~v56jI~
}//uftprenamesub                                                   //~v56jI~
//**************************************************************** //~v56jI~
//!ufilewildrename                                                 //~v56jI~
//* delete by wild card                                            //~v56jI~
//*parm1:filename thru wildfunc                                    //~v56jI~
//*parm2:dirlist ptr thru wildfunc                                 //~v56jI~
//*parm3:parm thru uwildfunc(Pnewname parm of urename)             //~v56jI~
//*retrn:rc                                                        //~v56jI~
//**************************************************************** //~v56jI~
int uftpwildrename(PUFTPHOST Ppuftph,UCHAR *Pfullpath,PUDIRLIST Ppudirlist,PVOID Pparm)//~v5afR~
{                                                                  //~v56jI~
    return uftprename(Ppuftph,Srenameopt,Pfullpath,Pparm,0);//no real name//~v5afR~
}//uftpwildrename                                                  //~v56jR~
//****************************************************************//~5903I~
//uattrib                                                       //~5903I~
//* set file attribute(read/hidden/system/archive)              //~5903R~
//* return file attribute when p2==0 and p3==0                  //~5903I~
//*parm1:filename                                               //~5903I~
//*parm2:attribute to set on   mode+attr                           //~0901R~
//*parm3:attribute to set off  mode+attr   if on=0,off=0:query     //~0901R~
//*parm4:result attribute      mode+attr                           //~0901R~
//*retrn:rc                                                     //~5903R~
//****************************************************************//~5903I~
int uftpattrib(PUFTPHOST Ppuftph,UCHAR *Pfname,ULONG Pattron,ULONG  Pattroff,ULONG  *Poutattr)//~v5afR~
{                                                               //~5903I~
    ULONG   mode,modeon,modeoff;                                   //~v56jR~
    FILEFINDBUF3 fstat30;                                          //~v56jR~
    int rc;                                                     //~5909R~
//********************                                          //~5903I~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270attrib(Ppuftph,Pfname,Pattron,Pattroff,Poutattr);//~v5jdI~
    if (rc=(int)uftpfstat(Ppuftph,Pfname,&fstat30),rc)             //~v5afR~
    {                                                              //~v381I~
        if (rc==ENOENT||rc==ENOTDIR)                               //~v381I~
            return ufilenotfound(Pfname,rc);                       //~v381I~
        return rc;                                              //~5905I~
    }                                                              //~v381I~
    mode=FILE_GETMODE(fstat30.attrFile);                           //~v380R~
//printf("curr  mode=%08x(o%o)\n",mode,mode);                      //~0901R~
    modeon=FILE_GETMODE(Pattron);                                  //~v380R~
    modeoff=FILE_GETMODE(Pattroff);                                //~v380R~
    if (modeon || modeoff)                                         //~0827R~
    {                                                           //~5903I~
        mode&=~modeoff;                                            //~0827R~
        mode|=modeon;                                              //~0827R~
//printf("chmod mode=%08x(o%o)\n",mode,mode);                      //~0901R~
        if (rc=uftpsetmod(Ppuftph,Pfname,mode),rc)          //set  //~v5afR~
            return rc;                                             //~v381R~
    }                                                           //~5903I~
    if (Poutattr)                                                  //~v56jI~
    {                                                              //~v56jI~
        if (rc=(int)uftpfstat(Ppuftph,Pfname,&fstat30),rc)//confirm result//~v5amR~
            return rc;                                             //~v56jR~
        *Poutattr=fstat30.attrFile;                                //~v56jR~
    }                                                              //~v56jI~
    return 0;                                                      //~0827R~
}//uattrib                                                      //~5903I~
//**************************************************************** //~0902I~
//uattrxon                                                         //~0902I~
//* set x bit(USER)                                                //~0902I~
//*parm1:filename                                                  //~0902I~
//*retrn:rc                                                        //~0902I~
//**************************************************************** //~0902I~
int uftpattrxon(PUFTPHOST Ppuftph,UCHAR *Pfname)                   //~v5afR~
{                                                                  //~0902I~
    ULONG   attron;                                    //+v396R~   //~v56jR~
//********************                                             //~0902I~
    attron=FILE_SETMODEATTR(S_IXUSR,0);                            //~v396R~
    return uftpattrib(Ppuftph,Pfname,attron,0,0);                  //~v5afR~
}//uftpattrxon                                                     //~v56jR~
//**************************************************************** //~0902I~
//uattrxchk                                                        //~0902I~
//* chk x bit(USER)                                                //~0902I~
//*parm1:filename                                                  //~0902I~
//*parm2:opt to issue errmsg                                       //~0902I~
//*retrn:rc:0 not executable,1:executable                          //~0902I~
//**************************************************************** //~0902I~
int uftpattrxchk(PUFTPHOST Ppuftph,UCHAR *Pfname,int Popt)         //~v5afR~
{                                                                  //~0902I~
    FILEFINDBUF3 fstat30;                                          //~0902I~
    ULONG mode;                                                    //~v56jR~
    char *uname;                                                   //~v5afI~
    int rc;                                                        //~0902I~
//********************                                             //~0902I~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270attrxchk(Ppuftph,Pfname,Popt);                 //~v5jdI~
    if (rc=(int)uftpfstat(Ppuftph,Pfname,&fstat30),rc)             //~v5afR~
        return rc;                                                 //~0902I~
    mode=FILE_GETMODE(fstat30.attrFile);                           //~0902R~
    uname=Ppuftph->UFTPHuser;                                      //~v5afR~
    if (!(mode & S_IXOTH)                                          //~0902I~
//  &&   ((gid!=fstat30.gid && uid)||!(mode & S_IXGRP))            //~v56jR~
    &&   ((strcmp(uname,fstat30.uname) && strcmp(uname,FTP_ROOTUSER))||!(mode & S_IXUSR)))//~v56jR~
    {                                                              //~0902I~
        if (Popt & UFTPAXC_MSG)                                    //~v56jR~
            uerrmsg("%s has no x-permissin",                       //~0902I~
                    "%s ɂ͎s܂",                 //~0902I~
                    Pfname);                                       //~0902I~
        return 0;                                                  //~0902I~
    }                                                              //~0902I~
    return 1;                                                      //~0902I~
}//uftpattrxchk                                                    //~v56jR~
//**************************************************************** //~v56jI~
//uftpgetftime                                                     //~v56jR~
//* get file time stamp                                            //~v56jI~
//* (W)modtime fail  for dir(not plain file),fmt IS GMT but not JST//~v56jR~
//*retrn:rc                                                        //~v56jI~
//**************************************************************** //~v56jI~
int uftpgetftime(PUFTPHOST Ppuftph,UCHAR *Pfname,FDATE *Ppdate,FTIME *Pptime)//~v5afR~
{                                                                  //~v56jI~
    int  rc;                                                       //~v56jI~
    FILEFINDBUF3 ffb3;                                             //~v56jI~
//********************                                             //~v56jI~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270getftime(Ppuftph,Pfname,Ppdate,Pptime);        //~v5jdR~
    rc=ufstat(Pfname,&ffb3);                                       //~v56jR~
    if(rc==ENOENT || rc==ENOTDIR) //not found or no more file      //~v56jI~
        return ufilenotfound(Pfname,rc);                           //~v56jI~
    *Ppdate=ffb3.fdateLastWrite;                                   //~v56jI~
    *Pptime=ffb3.ftimeLastWrite;                                   //~v56jI~
    return rc;                                                     //~v56jI~
}//uftpgetftime                                                    //~v56jR~
//****************************************************************//~5910I~
//uftpsetftime                                                     //~v56jR~
//* no method to set time                                          //~v56jI~
//*retrn:rc                                                     //~5910I~
//****************************************************************//~5910I~
int uftpsetftime(PUFTPHOST Ppuftph,UCHAR *Pfname,FDATE Pdate,FTIME Ptime)//~v5afR~
{                                                               //~5910I~
//********************                                          //~5910I~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270setftime(Ppuftph,Pfname,Pdate,Ptime);          //~v5jdI~
	return uftpnotsupported("setftime",Pfname);                    //~v56jR~
}//uftpsetftime                                                    //~v56jR~
//**************************************************************** //~v365I~
//usetftime2                                                       //~v365I~
//* no method to set time                                          //~v56jI~
//* set file time stamp; unit=second                               //~v365I~
//**************************************************************** //~v365I~
int uftpsetftime2(PUFTPHOST Ppuftph,UCHAR *Pfname,ULONG Patime,ULONG Pmtime)//~v5afR~
{                                                                  //~v365I~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270setftime2(Ppuftph,Pfname,Patime,Pmtime);       //~v5jdR~
	return uftpnotsupported("setftime2",Pfname);                   //~v56jR~
}//uftpsetftime2                                                   //~v56jR~
//****************************************************************//~5910I~
//uftpcopypathinfo                                                 //~v56jR~
//  called when one of sorce and target is remote                  //~v56jI~
//* local<-->remote,remote<-->remote                               //~v56jR~
//* no method to set time                                          //~v56jI~
//*retrn:rc                                                     //~5910I~
//****************************************************************//~5910I~
#ifdef W32                                                         //~v56jI~
int uftpcopypathinfo(PUFTPHOST Ppuftphs,PUFTPHOST Ppuftpht,UCHAR *Psource,UCHAR *Ptarget)//~v5afR~
{                                                                  //~v56jI~
    FILEFINDBUF3 ffb3;                                             //~v56jI~
    int rc=0,remoteswt,remotesws;                                  //~v56jI~
//********************                                             //~v56jI~
    if (UFTPHISTSO(Ppuftphs)||UFTPHISTSO(Ppuftpht))                //~v5jdR~
		return u3270copypathinfo(Ppuftphs,Ppuftpht,Psource,Ptarget);//~v5jdI~
	remotesws=(Ppuftphs!=0);                                       //~v5ahR~
	remoteswt=(Ppuftpht!=0);                                       //~v5afR~
    if (!remotesws||!remoteswt) 	//not bote is remote           //~v56jR~
    {//set time only                                               //~v56jI~
    	if (!remoteswt)		//remote-->local                       //~v56jI~
        {                                                          //~v56jI~
    		if (rc=ufstat(Psource,&ffb3),rc)                       //~v56jI~
        		return rc;                                         //~v56jI~
			rc=usetftime(Ptarget,ffb3.fdateLastWrite,ffb3.ftimeLastWrite);//~v56jR~
        }                                                          //~v56jI~
    }                                                              //~v56jI~
    else                                                           //~v56jI~
    {                                                              //~v56jI~
    	if (rc=ufstat(Psource,&ffb3),rc)                           //~v56jI~
        	return rc;                                             //~v56jI~
//  	if (rc=usetftime2(Ptarget,ffb3.atime,ffb3.mtime),rc)//no ftp method to set time//~v56jI~
//      	return rc;                                             //~v56jI~
    	rc+=uftpsetmod(Ppuftpht,Ptarget,FILE_GETMODE(ffb3.attrFile)); //all off then set on//~v5ahR~
    }//both remote                                                 //~v56jI~
    return rc;                                                     //~v56jI~
}//uftpcopypathinfo                                                //~v56jI~
#else                                                              //~v56jI~
int uftpcopypathinfo(PUFTPHOST Ppuftphs,PUFTPHOST Ppuftpht,UCHAR *Psource,UCHAR *Ptarget)//~v5afR~
{                                                               //~5910I~
    FILEFINDBUF3 ffb3;                                             //~v365I~
    int rc;                                                        //~v365R~
//********************                                          //~5910I~
    if (UFTPHISTSO(Ppuftphs))                                      //+v5jdR~
		return u3270copypathinfo(Ppuftphs,Ppuftpht,Psource,Ptarget);//~v5jdI~
    if (rc=ufstat(Psource,&ffb3),rc)                               //~v56jR~
        return rc;                                                 //~v365I~
//  if (rc=usetftime2(Ptarget,ffb3.atime,ffb3.mtime),rc)           //~v56jR~
//      return rc;                                                 //~v56jR~
    rc+=ufilesetmod(Ptarget,FILE_GETMODE(ffb3.attrFile)); //all off then set on//~v56jR~
    return rc;                                                     //~v365R~
}//uftpcopypathinfo                                                //~v56jR~
#endif //UNX                                                       //~v56jI~
//**************************************************************** //~v365I~
//uftpsetown                                                       //~v56jR~
//* set uid/gid                                                    //~v365I~
//*parm1:target name                                               //~v365I~
//*parm2:uid                                                       //~v365I~
//*parm3:gid                                                       //~v365I~
//*retrn:rc                                                        //~v365I~
//**************************************************************** //~v365I~
int uftpsetown(PUFTPHOST Ppuftph,UCHAR *Pfname,ULONG Puid,ULONG Pgid)//~v5afR~
{                                                                  //~v365I~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270setown(Ppuftph,Pfname,Puid,Pgid);              //~v5jdI~
	return uftpnotsupported("chown",Pfname);                       //~v56jR~
}//uftpsetown                                                      //~v56jR~
//**************************************************************** //~v365I~
//ufilesetmod                                                      //~v365I~
//* set modifier                                                   //~v381R~
//*parm1:target name                                               //~v365I~
//*parm2:mode  or attr fpr MDOS file                               //~v519R~
//*retrn:rc                                                        //~v365I~
//**************************************************************** //~v365I~
int uftpsetmod(PUFTPHOST Ppuftph,UCHAR *Pfname,ULONG Pmode)        //~v5afR~
{                                                                  //~v365I~
    UCHAR ftpcmd[FTP_MAXPATH];                                     //~v56jI~
    UCHAR rshcmd[FTP_MAXPATH];                                     //~v5evI~
    char **stdo,**stdo0,*pfname;                                   //~v56jR~
    int stdoctr,rc;                                                //~v56jR~
    int rc2;                                                       //~v5evI~
    ULONG mode;                                                    //~v56jI~
//********************                                             //~v56jI~
    if (UFTPHISTSO(Ppuftph))                                       //~v5jdI~
		return u3270setmod(Ppuftph,Pfname,Pmode);                  //~v5jdI~
    mode=Pmode & FTP_CHMODMASK;                                    //~v56jI~
    pfname=Pfname+Ppuftph->UFTPHhostnmlen+1;                       //~v5afR~
    sprintf(ftpcmd,                                                //~v56jI~
            "site chmod %o \"%s\"\n",                              //~v5bfR~
             (int)mode,pfname);                                    //~v56jR~
    rc=uftpcmd(Ppuftph,0,ftpcmd,&stdo0,&stdoctr,0,0);	//get stdout/stderr//~v5afR~
    stdo=stdo0;                                                    //~v56jI~
    if (!rc)                                                       //~v56jI~
    {                                                              //~v56jI~
		rc=uftpsimplerespchk("chmod","200 550 ",Pfname,&stdo,&stdoctr,ENOENT);//~v56jI~
        if (rc==-1) //no 200,550 found                             //~v56jR~
            uerrmsg("\"site chmod %o %s\" failed",0,               //~v56jI~
				        mode,pfname);                              //~v56jI~
	    ufree(stdo0);                                              //~v56jI~
    	sprintf(rshcmd,                                            //~v5evI~
            "chmod %o \\\"%s\\\"",                                 //~v5evR~
             (int)mode,pfname);                                    //~v5evI~
		rc2=uproc_rsh(UPROC_PUFTPH|UPROC_RSHLOG,Ppuftph,0,rshcmd,0,0,0,0,0,0);	//no userid,no redirect//~v5evR~
        if (!rc2)                                                  //~v5evI~
        	rc=0;                                                  //~v5evI~
    }                                                              //~v56jI~
    return rc;                                                     //~v56jI~
}//uftpsetmod                                                      //~v56jR~
//**************************************************************** //~v56jI~
//uftpwildfunc                                                     //~v56jI~
//* apply function for wild card                                   //~v56jI~
//*parm1:option for apply to ea data(1:apply)                      //~v56jI~
//*parm2:wild card filename                                        //~v56jI~
//*parm3:file selection attribute mask                             //~v56jI~
//*parm4:apply function(int func(char *filename,void *parm))       //~v56jI~
//*parm5:apply function parm                                       //~v56jI~
//*parm5:output applied count                                      //~v56jI~
//*retrn:rc                                                        //~v56jI~
//**************************************************************** //~v56jI~
int uftpwildfunc(PUFTPHOST Ppuftph,UCHAR *Psource,unsigned Pattrmask,//~v5afR~
                FTP_WILDAPPLYFUNC *Pfunc,void *Pparm,int *Pfilectr)//~v56jR~
{                                                                  //~v56jI~
    int rc=0,filectr,ii,pathlen;                                   //~v56jI~
    PUDIRLIST pudirlist,pudirlist0;                                //~v56jI~
    UCHAR fpath[FTP_MAXPATH];                                      //~v56jR~
//********************                                             //~v56jI~
    if (!uftpfullpath(Ppuftph,fpath,Psource,FTP_MAXPATH))          //~v5afR~
        return 4;                                                  //~v56jI~
    filectr=udirlist(fpath,Pattrmask,&pudirlist0,'L');             //~v56jR~
    if (filectr<0)  //err                                          //~v56jI~
        return 4;                                                  //~v56jI~
    pathlen=FTP_PATHLEN(fpath);                                    //~v56jR~
    pudirlist=pudirlist0;                                          //~v56jI~
    *Pfilectr=0;                                                   //~v56jI~
    for (ii=0;ii<filectr;ii++,pudirlist++)  //until eof/err        //~v56jI~
    {                                                              //~v56jI~
        if (!strcmp(pudirlist->name,".")        //curr             //~v56jI~
        ||  !strcmp(pudirlist->name,".."))      //parent           //~v56jI~
            continue;                                              //~v56jI~
        *Pfilectr=*Pfilectr+1;                                     //~v56jI~
        strcpy(fpath+pathlen,pudirlist->name);                     //~v56jR~
        if (rc=Pfunc(Ppuftph,fpath,pudirlist,Pparm),rc)            //~v5afR~
            break;                                                 //~v56jI~
    }//dir list                                                    //~v56jI~
    ufree(pudirlist0);                                             //~v56jI~
    return rc;                                                     //~v56jI~
}//uftpwildfunc                                                    //~v5amR~
//**************************************************************** //~v5amI~
//uwildfunc2                                                       //~v5amI~
//* apply function for wild card for remote file                   //~v5amI~
//*retrn:rc                                                        //~v5amI~
//**************************************************************** //~v5amI~
int uftpwildfunc2(int Popt,UCHAR *Psource,unsigned Pattrmask,      //~v5amR~
                FTPCMD_CALLBACK *Pfunc,void *Pparm,int *Ppfilectr,long *Ppfilesize)//~v5amR~
{                                                                  //~v5amI~
    int rc=0,filectr,stdoctr;                                      //~v5amR~
    PUDIRLIST pudirlist;                                           //~v5amI~
    PUFTPHOST puftph;                                              //~v5amI~
    UCHAR fpath[_MAX_PATH];                                        //~v5amR~
    UFWF2PARM wf2p;                                                //~v5amI~
    char **pstdo;                                                  //~v5amI~
//********************                                             //~v5amI~
	*Ppfilectr=0;                                                  //~v5amI~
	*Ppfilesize=0;                                                 //~v5amI~
    if (Popt & UXDELRONLYCHK)  //readonly chk only                 //~v5amR~
    	return 0;	//bypass process                               //~v5amI~
    wf2p.UFWF2Pcmdokctr=0;	//processed ctr                        //~v5amR~
    wf2p.UFWF2Pfilesize=0;	//deleted size                         //~v5amR~
    if (!uftpisremote(Psource,&puftph))	//local file               //~v5amR~
    	return 4;                                                  //~v5amI~
    if (!uftpfullpath(puftph,fpath,Psource,_MAX_PATH))             //~v5amR~
        return 4;                                                  //~v5amI~
    if (uftpdirlistsub(puftph,FTP_DLSNONFMSG,&filectr,fpath,Pattrmask,&pudirlist))//~v5amR~
        return 4;                                                  //~v5amI~
    if (filectr)                                                   //~v5amI~
    {                                                              //~v5amI~
    	wf2p.UFWF2Pfpath=fpath+puftph->UFTPHhostnmlen+1;           //~v5amR~
    	wf2p.UFWF2Ppathlen=PATHLEN(wf2p.UFWF2Pfpath);              //~v5amR~
    	wf2p.UFWF2Ppudl=pudirlist;                                 //~v5amI~
    	wf2p.UFWF2Ppudlctr=filectr;                                //~v5amI~
    	wf2p.UFWF2Pwildparm=Pparm;                                 //~v5amR~
    	wf2p.UFWF2Pattrmask=Pattrmask;                             //~v5amR~
    	wf2p.UFWF2Popt=Popt;                                       //~v5amR~
//    	if (uftpcmd(puftph,0,0,&pstdo,&stdoctr,Pfunc,&wf2p))//callback Pfunc//~v5d7R~
    	rc=uftpcmd(puftph,0,0,&pstdo,&stdoctr,Pfunc,&wf2p);//callback Pfunc//~v5d7I~
      	if (rc)                                                    //~v5d7I~
        {                                                          //~v5d7I~
	    	if (rc==FTPRC_NOMOREFILE)	//request skip ftp cmd     //~v5d7I~
                rc=0;                                              //~v5d7I~
        }                                                          //~v5d7I~
        else                                                       //~v5amI~
	    	if (uftpxdelrchk(&wf2p,pstdo,stdoctr))//stdo is freed in the func//~v5amR~
            	rc=4;                                              //~v5amI~
    }                                                              //~v5amI~
	if (pudirlist)                                                 //~v5amI~
    	ufree(pudirlist);                                          //~v5amI~
    *Ppfilectr=wf2p.UFWF2Pcmdokctr;	//processed ctr                //~v5amR~
    *Ppfilesize=wf2p.UFWF2Pfilesize;	//deleted size             //~v5amR~
    return rc;                                                     //~v5amI~
}//uftpwildfunc2                                                   //~v5amR~
//**************************************************************** //~v5fdI~
//uftpmultidel                                                     //~v5fdI~
//* delete at once multiple file in the remote dir                 //~v5fdI~
//* parm3:dirname with hostname prefix                             //~v5fdI~
//*retrn:rc                                                        //~v5fdI~
//**************************************************************** //~v5fdI~
int uftpmultidel(int Popt,PUFTPHOST Ppuftph,PUFTPMULTIDEL Ppfmd,   //~v5fdR~
                 int Pfilectr,void *Pparm)                         //~v5fdR~
{                                                                  //~v5fdI~
    int rc=0,stdoctr;                                              //~v5fdR~
    UFWF2PARM wf2p;                                                //~v5fdI~
    char **pstdo;                                                  //~v5fdI~
//********************                                             //~v5fdI~
    wf2p.UFWF2Pcmdokctr=0;	//processed ctr                        //~v5fdI~
    wf2p.UFWF2Pfilesize=0;	//deleted size                         //~v5fdI~
    wf2p.UFWF2Pfpath=UFWF2PFPATH_MULTIDEL;	//id of multidel       //~v5fdR~
    wf2p.UFWF2Ppathlen=0;                                          //~v5fdR~
    wf2p.UFWF2Ppudl=(PUDIRLIST)(ULONG)Ppfmd;                       //~v5fdR~
    wf2p.UFWF2Ppudlctr=Pfilectr;                                   //~v5fdI~
    wf2p.UFWF2Pwildparm=Pparm;                                     //~v5fdI~
    wf2p.UFWF2Pattrmask=0;	//no meaningfull                       //~v5fdI~
    wf2p.UFWF2Popt=Popt;                                           //~v5fdI~
    rc=uftpcmd(Ppuftph,0,0,&pstdo,&stdoctr,uftpmultidelsub,&wf2p);//callback Pfunc//~v5fdR~
    if (rc)                                                        //~v5fdI~
    {                                                              //~v5fdI~
        if (rc==FTPRC_NOMOREFILE)   //request skip ftp cmd         //~v5fdI~
            rc=0;                                                  //~v5fdI~
    }                                                              //~v5fdI~
    else                                                           //~v5fdI~
        if (uftpmultidelrchk(&wf2p,pstdo,stdoctr))//stdo is freed in the func//~v5fdR~
            rc=4;                                                  //~v5fdI~
    return rc;                                                     //~v5fdI~
}//uftpmultidel                                                    //~v5fdR~
//**************************************************************** //~v5fnI~
//uftpmultirename                                                  //~v5fnI~
//* rename at once multiple file in the remote dir                 //~v5fnI~
//* parm3:dirname with hostname prefix                             //~v5fnI~
//*retrn:rc                                                        //~v5fnI~
//**************************************************************** //~v5fnI~
int uftpmultirename(int Popt,PUFTPHOST Ppuftph,PUFTPMULTIRENAME Ppfmr,//~v5fnI~
                 int Pfilectr,void *Pparm)                         //~v5fnI~
{                                                                  //~v5fnI~
    int rc=0,stdoctr;                                              //~v5fnI~
    UFWF2PARM wf2p;                                                //~v5fnI~
    char **pstdo;                                                  //~v5fnI~
//********************                                             //~v5fnI~
    wf2p.UFWF2Pcmdokctr=0;	//processed ctr                        //~v5fnI~
    wf2p.UFWF2Pfilesize=0;	//deleted size                         //~v5fnI~
    wf2p.UFWF2Pfpath=UFWF2PFPATH_MULTIDEL;	//id of multidel       //~v5fnR~
    wf2p.UFWF2Ppathlen=0;                                          //~v5fnI~
    wf2p.UFWF2Ppudl=(PUDIRLIST)(ULONG)Ppfmr;                       //~v5fnI~
    wf2p.UFWF2Ppudlctr=Pfilectr;                                   //~v5fnI~
    wf2p.UFWF2Pwildparm=Pparm;                                     //~v5fnI~
    wf2p.UFWF2Pattrmask=0;	//no meaningfull                       //~v5fnI~
    wf2p.UFWF2Popt=Popt;                                           //~v5fnI~
    rc=uftpcmd(Ppuftph,0,0,&pstdo,&stdoctr,uftpmultirenamesub,&wf2p);//callback Pfunc//~v5fnI~
    if (rc)                                                        //~v5fnI~
    {                                                              //~v5fnI~
        if (rc==FTPRC_NOMOREFILE)   //request skip ftp cmd         //~v5fnI~
            rc=0;                                                  //~v5fnI~
    }                                                              //~v5fnI~
    else                                                           //~v5fnI~
        if (uftpmultirenamerchk(&wf2p,pstdo,stdoctr))//stdo is freed in the func//~v5fnR~
            rc=4;                                                  //~v5fnI~
    return rc;                                                     //~v5fnI~
}//uftpmultirename                                                 //~v5fnI~
//**************************************************************** //~v5amI~
//!uftpwildxdel(uftpcmd callback)                                  //~v5amR~
//* delete by wild card                                            //~v5amI~
//*parm1:filename thru wildfunc                                    //~v5amI~
//*parm2:dirlist ptr thru wildfunc                                 //~v5amI~
//*parm3:parm thru uwildfunc(Pattrmask parm of xdelete)            //~v5amI~
//*retrn:rc                                                        //~v5amI~
//**************************************************************** //~v5amI~
int uftpwildxdel(FILE *Phfile,void *Ppvoid)                        //~v5amI~
{                                                                  //~v5amI~
    PUFWF2PARM pwf2p;                                              //~v5amI~
	PUDIRLIST pudirlist;                                           //~v5amI~
    int rc=0,pudlctr,ii,filectr=0,pathlen;                         //~v5amI~
    long filesize=0;                                               //~v5amI~
    char fpath[_MAX_PATH];                                         //~v5amI~
//***********************************                              //~v5amI~
	pwf2p=(PUFWF2PARM)Ppvoid;                                      //~v5amI~
    pudirlist=pwf2p->UFWF2Ppudl;                                   //~v5amR~
    pudlctr=pwf2p->UFWF2Ppudlctr;                                  //~v5amR~
    pathlen=pwf2p->UFWF2Ppathlen;                                  //~v5amI~
    memcpy(fpath,pwf2p->UFWF2Pfpath,(UINT)pathlen);                //~v5amR~
    for (ii=0;ii<pudlctr;ii++,pudirlist++)  //until eof/err        //~v5amI~
    {                                                              //~v5amI~
    	pudirlist->attr&=~FILE_FTPWKSL;	//id of cmd put for respchk//~v5amI~
    	if (UCBITCHK(pudirlist->attr,(FILE_DIRECTORY|FILE_SPECIAL|FILE_READONLY)))//~v5amR~
        	continue;                                              //~v5amI~
    	pudirlist->attr|=FILE_FTPWKSL;	//id of cmd put for respchk//~v5amI~
        strcpy(fpath+pathlen,pudirlist->name);                     //~v5amI~
    	ufile2putstmt(Phfile,"delete",fpath);                      //~v5amR~
        filesize+=pudirlist->size;                                 //~v5amI~
        filectr++;                                                 //~v5amR~
    }//dir list                                                    //~v5amI~
    if (!filectr)                                                  //~v5amI~
//  	rc=ENOENT;	//request skip ftp cmd                         //~v5d7R~
    	rc=FTPRC_NOMOREFILE;	//request skip ftp cmd             //~v5d7I~
    return rc;                                                     //~v5amI~
}//uftpwildxdel                                                    //~v5amI~
//**************************************************************** //~v5fdI~
//!uftpmultidel(uftpcmd callback)                                  //~v5fdI~
//* delete multiple request entry                                  //~v5fdI~
//*retrn:rc                                                        //~v5fdI~
//**************************************************************** //~v5fdI~
int uftpmultidelsub(FILE *Phfile,void *Ppvoid)                     //~v5fdR~
{                                                                  //~v5fdI~
    PUFWF2PARM pwf2p;                                              //~v5fdI~
    int rc=0,reqctr,ii,filectr=0;                                  //~v5fdR~
	PUFTPMULTIDEL pfmd;                                            //~v5fdR~
//***********************************                              //~v5fdI~
	pwf2p=(PUFWF2PARM)Ppvoid;                                      //~v5fdI~
    pfmd=(PUFTPMULTIDEL)(ULONG)(pwf2p->UFWF2Ppudl);                //~v5fdR~
    reqctr=pwf2p->UFWF2Ppudlctr;                                   //~v5fdI~
    for (ii=0;ii<reqctr;ii++,pfmd++)  //until eof/err              //~v5fdI~
    {                                                              //~v5fdI~
    	pfmd->UFMDflag=0;	//clear ctl                            //~v5fdI~
    	if (UCBITCHK(pfmd->UFMDattr,(FILE_DIRECTORY|FILE_SPECIAL|FILE_READONLY)))//~v5fdR~
        {                                                          //~v5fdI~
    		pfmd->UFMDrc=UFMDRC_TYPEERR;                           //~v5fdI~
        	continue;                                              //~v5fdI~
        }                                                          //~v5fdI~
    	pfmd->UFMDflag|=UFMDFDELREQ;                               //~v5fdR~
    	pfmd->UFMDrc=0;                                            //~v5fdI~
    	ufile2putstmt(Phfile,"delete",pfmd->UFMDpfpath);           //~v5fdI~
        filectr++;                                                 //~v5fdI~
    }//dir list                                                    //~v5fdI~
    if (!filectr)                                                  //~v5fdI~
    	rc=FTPRC_NOMOREFILE;	//request skip ftp cmd             //~v5fdI~
    return rc;                                                     //~v5fdI~
}//uftpmultidelsub                                                 //~v5fdR~
//**************************************************************** //~v5fnI~
//!uftpmultirename(uftpcmd callback)                               //~v5fnI~
//* rename multiple request entry                                  //~v5fnI~
//*retrn:rc                                                        //~v5fnI~
//**************************************************************** //~v5fnI~
int uftpmultirenamesub(FILE *Phfile,void *Ppvoid)                  //~v5fnI~
{                                                                  //~v5fnI~
    PUFWF2PARM pwf2p;                                              //~v5fnI~
    int rc=0,reqctr,ii,filectr=0;                                  //~v5fnI~
	PUFTPMULTIRENAME pfmr;                                         //~v5fnI~
    UCHAR renameopd[FTP_MAXPATH+FTP_MAXPATH+4];                    //~v5fnI~
    UCHAR newname[FTP_MAXPATH];                                    //~v5fnI~
//***********************************                              //~v5fnI~
	pwf2p=(PUFWF2PARM)Ppvoid;                                      //~v5fnI~
    pfmr=(PUFTPMULTIRENAME)(ULONG)(pwf2p->UFWF2Ppudl);             //~v5fnI~
    reqctr=pwf2p->UFWF2Ppudlctr;                                   //~v5fnI~
    for (ii=0;ii<reqctr;ii++,pfmr++)  //until eof/err              //~v5fnI~
    {                                                              //~v5fnI~
    	pfmr->UFMRflag=0;	//clear ctl                            //~v5fnR~
    	if (UCBITCHK(pfmr->UFMRattr,(FILE_DIRECTORY|FILE_SPECIAL|FILE_READONLY)))//~v5fnR~
        {                                                          //~v5fnI~
    		pfmr->UFMRrc=UFMRRC_TYPEERR;                           //~v5fnR~
        	continue;                                              //~v5fnI~
        }                                                          //~v5fnI~
    	pfmr->UFMRflag|=UFMRFRENAMEREQ;                            //~v5fnR~
    	pfmr->UFMRrc=0;                                            //~v5fnR~
    	strcpy(newname,pfmr->UFMRpfpath);                          //~v5fnI~
        strcpy(newname+FTP_PATHLEN(newname),pfmr->UFMRpnewname);   //~v5fnR~
    	sprintf(renameopd,"\"%s\" \"%s\"",pfmr->UFMRpfpath,newname);//~v5fnR~
    	ufile2putstmt(Phfile,"rename",renameopd);                  //~v5fnI~
        filectr++;                                                 //~v5fnI~
    }//dir list                                                    //~v5fnI~
    if (!filectr)                                                  //~v5fnI~
    	rc=FTPRC_NOMOREFILE;	//request skip ftp cmd             //~v5fnI~
    return rc;                                                     //~v5fnI~
}//uftpmultirenamesub                                              //~v5fnI~
//**************************************************************** //~v5amI~
//ftp delete cmd result chk                                        //~v5amI~
//*retrn:rc                                                        //~v5amI~
//**************************************************************** //~v5amI~
int uftpxdelrchk(PUFWF2PARM Ppfwf2p,char **Ppstdo,int Pstdoctr)    //~v5amI~
{                                                                  //~v5amI~
	PUDIRLIST pudirlist;                                           //~v5amI~
    int rc=0,filectr=0,pudlctr,stdoctr,ii,pathlen,opt;             //~v5amR~
    char newsrc[_MAX_PATH],**stdo;                                 //~v5amR~
    long filesize=0;                                               //~v5amI~
//****************************                                     //~v5amI~
	stdoctr=Pstdoctr;                                              //~v5amI~
    stdo=Ppstdo;                                                   //~v5amI~
    pudlctr=Ppfwf2p->UFWF2Ppudlctr;                                //~v5amR~
    pudirlist=Ppfwf2p->UFWF2Ppudl;                                 //~v5amI~
    pathlen=Ppfwf2p->UFWF2Ppathlen;                                //~v5amR~
    memcpy(newsrc,Ppfwf2p->UFWF2Pfpath,(UINT)pathlen);             //~v5amI~
    opt=Ppfwf2p->UFWF2Popt;                                        //~v5amR~
    for (ii=0;ii<pudlctr;ii++,pudirlist++)  //until eof/err        //~v5amI~
    {                                                              //~v5amI~
        if (!(pudirlist->attr & FILE_FTPWKSL))                     //~v5amI~
            continue;                                              //~v5amI~
        strcpy(newsrc+pathlen,pudirlist->name);      //parent      //~v5amI~
        rc=uftpcmdsrchrespid(&stdo,&stdoctr,"250 550 ");           //~v5amI~
        switch(rc)                                                 //~v5amI~
        {                                                          //~v5amI~
        case 0:    //250                                           //~v5amI~
            filectr++;                                             //~v5amI~
            filesize+=pudirlist->size;                             //~v5amI~
            if (opt & UXDELMSG)                                    //~v5amI~
            	ufiledeleted(newsrc,'F',pudirlist->size,pudirlist->attr);//size=-1  mean no display size/attr//~v5amI~
            break;                                                 //~v5amI~
        case 1:    //550                                           //~v5amI~
            if (!Gufile_nomsg)   //nomsg option                    //~v5amI~
        		uerrmsg("%s remove failed.(%s)",0,                 //~v5amI~
						newsrc,*(stdo-1));	//already exit or path not found//~v5amI~
            rc=ENOENT;                                             //~v5amI~
            break;                                                 //~v5amI~
        }                                                          //~v5amI~
    }                                                              //~v5amI~
    Ppfwf2p->UFWF2Pcmdokctr=filectr;                               //~v5amR~
    Ppfwf2p->UFWF2Pfilesize=filesize;                              //~v5amR~
    ufree(Ppstdo);                                                 //~v5amI~
    return rc;                                                     //~v5amI~
}//uftpxdelrchk                                                    //~v5fdR~
//**************************************************************** //~v5fdI~
//ftp delete cmd result chk                                        //~v5fdI~
//*retrn:rc                                                        //~v5fdI~
//**************************************************************** //~v5fdI~
int uftpmultidelrchk(PUFWF2PARM Ppfwf2p,char **Ppstdo,int Pstdoctr)//~v5fdI~
{                                                                  //~v5fdI~
	PUFTPMULTIDEL pfmd;                                            //~v5fdI~
    int rc=0,filectr=0,delctr,stdoctr,ii,opt;                      //~v5fdR~
    char **stdo,*pfpath;                                           //~v5fdR~
//****************************                                     //~v5fdI~
	stdoctr=Pstdoctr;                                              //~v5fdI~
    stdo=Ppstdo;                                                   //~v5fdI~
    pfmd=(PUFTPMULTIDEL)(ULONG)(Ppfwf2p->UFWF2Ppudl);              //~v5fdR~
    delctr=Ppfwf2p->UFWF2Ppudlctr;                                 //~v5fdR~
    opt=Ppfwf2p->UFWF2Popt;                                        //~v5fdI~
    for (ii=0;ii<delctr;ii++,pfmd++)  //until eof/err              //~v5fdR~
    {                                                              //~v5fdI~
        if (!(pfmd->UFMDflag & UFMDFDELREQ))                       //~v5fdR~
            continue;                                              //~v5fdI~
        pfpath=pfmd->UFMDpfpath;                                   //~v5fdR~
        rc=uftpcmdsrchrespid(&stdo,&stdoctr,"250 550 ");           //~v5fdI~
        switch(rc)                                                 //~v5fdI~
        {                                                          //~v5fdI~
        case 0:    //250                                           //~v5fdI~
            filectr++;                                             //~v5fdI~
            if (opt & UXDELMSG)                                    //~v5fdI~
            	ufiledeleted(pfpath,'F',-1,0);//size=-1  mean no display size/attr//~v5fdR~
            break;                                                 //~v5fdI~
        case 1:    //550                                           //~v5fdI~
            if (!Gufile_nomsg)   //nomsg option                    //~v5fdI~
        		uerrmsg("%s remove failed.(%s)",0,                 //~v5fdI~
						pfpath,*(stdo-1));	//already exit or path not found//~v5fdR~
            rc=ENOENT;                                             //~v5fdI~
    		pfmd->UFMDrc=rc;                                       //~v5fqI~
            break;                                                 //~v5fdI~
        }                                                          //~v5fdI~
    }                                                              //~v5fdI~
    Ppfwf2p->UFWF2Pcmdokctr=filectr;                               //~v5fdI~
    ufree(Ppstdo);                                                 //~v5fdI~
    return rc;                                                     //~v5fdI~
}//uftpmultidelrchk                                                //~v5fdI~
//**************************************************************** //~v5fnI~
//ftp rename cmd result chk                                        //~v5fnI~
//*retrn:rc                                                        //~v5fnI~
//**************************************************************** //~v5fnI~
int uftpmultirenamerchk(PUFWF2PARM Ppfwf2p,char **Ppstdo,int Pstdoctr)//~v5fnI~
{                                                                  //~v5fnI~
	PUFTPMULTIRENAME pfmr;                                         //~v5fnI~
    int rc=0,filectr=0,renamectr,stdoctr,ii;                       //~v5fqR~
    char **stdo,*pfpath,*pnewname;                                 //~v5fnI~
//****************************                                     //~v5fnI~
	stdoctr=Pstdoctr;                                              //~v5fnI~
    stdo=Ppstdo;                                                   //~v5fnI~
    pfmr=(PUFTPMULTIRENAME)(ULONG)(Ppfwf2p->UFWF2Ppudl);           //~v5fnI~
    renamectr=Ppfwf2p->UFWF2Ppudlctr;                              //~v5fnI~
    for (ii=0;ii<renamectr;ii++,pfmr++)  //until eof/err           //~v5fnI~
    {                                                              //~v5fnI~
        if (!(pfmr->UFMRflag & UFMDFDELREQ))                       //~v5fnI~
            continue;                                              //~v5fnI~
        pfpath=pfmr->UFMRpfpath;                                   //~v5fnI~
        pnewname=pfmr->UFMRpnewname;                               //~v5fnI~
        rc=uftpcmdsrchrespid(&stdo,&stdoctr,"250 550 ");           //~v5fnI~
        switch(rc)                                                 //~v5fnI~
        {                                                          //~v5fnI~
        case 0:    //250                                           //~v5fnI~
            filectr++;                                             //~v5fnI~
            break;                                                 //~v5fnI~
        case 1:    //550                                           //~v5fnI~
            if (!Gufile_nomsg)   //nomsg option                    //~v5fnI~
        		uerrmsg("%s %s rename failed.(%s)",0,              //~v5fnI~
						pfpath,pnewname,*(stdo-1));	//already exit or path not found//~v5fnI~
            rc=ENOENT;                                             //~v5fnI~
    		pfmr->UFMRrc=rc;                                       //~v5fqR~
            break;                                                 //~v5fnI~
        }                                                          //~v5fnI~
    }                                                              //~v5fnI~
    Ppfwf2p->UFWF2Pcmdokctr=filectr;                               //~v5fnI~
    ufree(Ppstdo);                                                 //~v5fnI~
    return rc;                                                     //~v5fnI~
}//uftpmultirenamerchk                                             //~v5fnI~
//**************************************************************** //~v5amI~
//uftpcopystmt                                                     //~v5amI~
//  write get/put statement                                        //~v5amI~
//**************************************************************** //~v5amI~
int ufile2putstmt(FILE *Phfile,char *Pcmd,char *Pfnm)              //~v5amI~
{                                                                  //~v5amI~
//  char ftpcmd[_MAX_PATH+16];                                     //~v5fnR~
    char ftpcmd[_MAX_PATH+_MAX_PATH+32];	//may have 2 filename  //~v5fnI~
//****************************                                     //~v5amI~
    if (Pfnm)                                                      //~v5amI~
      if (*Pfnm=='\"')	//already enclosed                         //~v5fnI~
	    sprintf(ftpcmd,"%s %s\n",Pcmd,Pfnm);                       //~v5fnI~
      else                                                         //~v5fnI~
	    sprintf(ftpcmd,"%s \"%s\"\n",Pcmd,Pfnm);                   //~v5bfR~
    else                                                           //~v5amI~
		sprintf(ftpcmd,"%s\n",Pcmd);                               //~v5amI~
    fprintf(Phfile,ftpcmd);                                        //~v5amI~
    uftplog(0,ftpcmd);                                             //~v5amI~
    return 0;                                                      //~v5amI~
}//ufile2putstmt                                                   //~v5amI~
//**************************************************************** //~v56jI~
int uftpnotsupported(char *Pcmd,char *Pfnm)                        //~v56jI~
{                                                                  //~v56jI~
    uerrmsg("%s is not supported for FTP remote (%s).",0,          //~v56jI~
				Pcmd,Pfnm);                                        //~v56jI~
    errno=FTPRC_NOTSUPPORTED;                                      //~v56jR~
    return FTPRC_NOTSUPPORTED;	//not implemented                  //~v56jR~
}//uftpnotsupported                                                //~v56jI~
//**************************************************************** //~v56jI~
int uftpnotsupportedforlocal(char *Pcmd,char *Pfnm)                //~v56jI~
{                                                                  //~v56jI~
    uerrmsg("%s (%s) is supported for remote file only.",0,        //~v56jR~
				Pcmd,Pfnm);                                        //~v56jI~
    errno=FTPRC_NOTSUPPORTED;                                      //~v56jI~
    return FTPRC_NOTSUPPORTED;	//not implemented                  //~v56jI~
}//uftpnotsupportedforlocal                                        //~v56jI~
