//CID://+v053R~:                                                   //~v053R~
//*******************************************************
//*ufuncmap.h
//*******************************************************
//v053:970107:gcc version(control by DPMI)                         //~v053I~
//            -stack accessible by external symbol(__djgpp...)     //~v053I~
//v046:961109:chk Heap middle hole(decommitted page)               //~v046I~
//v034:961008:VisualC++ support(identify by (_MSC_VER>=800))       //~v034I~
//*******************************************************          //~v034I~
#ifdef DPMI					//DPMI version                         //~v053I~
    #define PAG_COMMIT          0x00000001   //dpmi v1.0 ax=0506h defined//+v053R~
#else                       //not DPMI                             //~v053I~
    #ifdef W32  //copy from f:\toolkt21\c\os2h\bsexcpt.h           //~v053I~
        #define PAG_COMMIT          0x00000010   //no corresponding in w95//~v053I~
    #else                       //not DPMI                         //~v053I~
    #endif                      //DPMI or not                      //~v053I~
#endif                      //DPMI or not                          //~v053I~
#define MAPEPANAMESZ 	32
#define MAXPATHPARM 	8		//parm word count to be set
//********************************************************************
#define  VALIDDATA(addr)                            \
			((ULONG)(addr) >= pstacktop  && (ULONG)(addr) < pstackend)
//*******************************************************
typedef struct _EPATBL	{
						long  addr;		//atorage addr
						long  len;		//function len
						UCHAR funcname[MAPEPANAMESZ];//null for stopper
						} EPATBL;
typedef EPATBL *PEPATBL;

//* call path table
typedef struct _PATHTBL{
						ULONG 	ebp;
						ULONG   epa;
						UCHAR   funcname[32];
						ULONG	ebpp;
						ULONG	ret;
						ULONG	parm[MAXPATHPARM];
						} PATHTBL;
typedef PATHTBL*  PPATHTBL;
#define PATHTBLSZ (sizeof(PATHTBL))
//*******************************************************
//*ufuncmap
//* create epa table from map file
//* parm1:map file path/name
//* parm2:base(main) addr
//* parm3:ptr of tbl ptr
//* return: rc
//*******************************************************
int ufuncmap(UCHAR *Pfilename,PVOID Pbase,PEPATBL *Ppepatbl);

//*******************************************************
//*ugetepa
//* search epa table entry containing parm addr
//* parm1:map tbl addr gotten by ufuncmap
//* parm2:instruction addr
//* return:epa tbl entry addr or 0 if not found
//*******************************************************
PEPATBL ugetepa(PEPATBL Ppepatbl,PVOID Paddr);

//****************************************************************
//*ufuncpathmsg
//*create function call path table *
//*parm1: map filename
//*parm2: first EBP value if 0,uehpathmsg call point is assumed
//*parm3: first EIP value
//*return:msg buff addr
//****************************************************************
UCHAR *ufuncpathmsg(UCHAR *Pmapfilename,ULONG Pebp,ULONG Paddr);

//***************************************************
//* ufuncpathmsgsub         
//* setup call path function name 
//*   parm1:pathtbl
//*   parm2:output buff;
//*  return:msg length
//****************************************************
int ufuncpathmsgsub(PPATHTBL Pppathtbl,UCHAR *Pbuff);

//****************************************************************
//*get function call path table *
//*parm1: epatbl ptr
//*parm2: first EBP value
//*parm3: first EIP value(abend instruction)
//*return:path table addr(0 if err)
//****************************************************************
PPATHTBL ufuncpathtbl(PEPATBL Ppepatbl,ULONG Pebp,ULONG Paddr);

//********************************************************************
//* ֐     : ugetstackaddr                                       *
//* INPUT      :                                                     *
//*     p1:addr of pointer to set top addr                           *
//*     p2:addr of pointer to set end addr                           *
//* OUTPUT     : set of pointer
//* RETURN     : none                                                *
//* @\Tv   : stack addr get(start/end)
//********************************************************************
void ugetstackaddr(ULONG *pstacktop,ULONG *pstackend);

#ifdef DPMI                                                        //~v053I~
//********************************************************************//~v053I~
//* ֐     : ugetdataseg                                         *//~v053I~
//* INPUT      :                                                     *//~v053I~
//*     p1:addr of pointer to set data seg top addr                           *//~v053I~
//*     p2:addr of pointer to set data seg end addr                           *//~v053I~
//*     p3:addr of pointer to set bss  seg top addr                //~v053I~
//*     p4:addr of pointer to set bss  seg end addr                //~v053I~
//*     p5:addr of pointer to set ds base                          //~v053I~
//*     p6:addr of pointer to set ds base+limit                    //~v053I~
//* OUTPUT     : set of pointer                                    //~v053I~
//* RETURN     : none                                                *//~v053I~
//* @\Tv   : data seg addr get(data,bss,ds limit)              //~v053I~
//********************************************************************//~v053I~
void ugetdataseg(ULONG *Ppdatasegtop,ULONG *Ppdatasegend,          //~v053I~
                 ULONG *Ppbsssegtop,ULONG *Ppbsssegend,            //~v053I~
                 ULONG *Ppdsbase,ULONG *Ppdsend);                  //~v053R~
#else           //no DPMI                                          //~v053I~
//********************************************************************
//* ֐     : usetmainebp                                       *
//* INPUT      :                                                     *
//*     p1	   :mai ebp valu
//* OUTPUT     : Sdosmainebp
//* RETURN     : none                                                *
//* @\Tv   : save main rtn ebp value for ugetstackaddr
//********************************************************************
void usetmainebp(ULONG Pebp);
#endif      //no DPMI                                              //~v053I~

//**********************************************
//*memory accessible test
//*parm 1:addr to be chk
//*parm 2:storage len
//*parm 3:storage attr
//**********************************************
UINT umemchk(ULONG Paddr,ULONG *Ppsize,ULONG *Ppattr);
                                                                   //~v034I~
#if (_MSC_VER >= 800)                                      //+v034I~//~v034I~
//********************************************************************//~v034I~
//* ֐     : ugettopheap                                       //~v034I~
//* INPUT      :                                                     *//~v034I~
//*     p1:addr of area to set heap handle                         //~v034I~
//*     p1:addr of area to set offset of next ptr field            //~v034I~
//* OUTPUT     : heap handle                                       //~v034I~
//* RETURN     : rc                                                //~v034I~
//* @\Tv   : get top heap handle                               //~v034I~
//********************************************************************//~v034I~
int ugettopheap(void **Ppheaph,int *Ppnextoff);                    //~v034R~
                                                                   //~v034I~
//********************************************************************//~v034I~
//* ֐     : ugetmoduledata                                    //~v034I~
//* INPUT      :                                                     *//~v034I~
//*     p1:addr of pointer to set text start addr                  //~v034I~
//*     p2:addr of pointer to set text end   addr                  //~v034I~
//*     p3:addr of pointer to set data start addr                  //~v034I~
//*     p4:addr of pointer to set data end   addr                  //~v034I~
//* OUTPUT     : set of pointer                                    //~v034I~
//* RETURN     : rc                                                //~v034I~
//* @\Tv   : code/data segment data get                        //~v034I~
//********************************************************************//~v034I~
int ugetmoduledata(ULONG *Ptexttop,ULONG *Ptextend,ULONG *Pdatatop,ULONG* Pdataend);//~v034I~
                                                                   //~v034I~
#else 	//not vc                                                     //+v034I~//~v034I~
#endif                                                     //+v034I~//~v034I~
                                                                   //~v034I~
#ifdef DOS                                                         //~v046I~
#else                                                              //~v046I~
//**********************************************                   //~v046I~
//*search commit page                                              //~v046I~
//*parm 1:addr to be chk start                                     //~v046I~
//*parm 2:chk len                                                  //~v046I~
//*retern:output first commit page addr                            //~v046I~
//**********************************************                   //~v046I~
void *umemsrch(void *Paddr,ULONG Ppsize);                          //~v046I~
#endif                                                             //~v046I~
