//*CID://+v5g9R~:                             update#=  104;       //+v5g9R~
//*************************************************************
//ukbdl.c    (intf between ukbd and ukbdlnxc)                      //~v57BR~
//*kbd get for linux console screen
//*************************************************************
//v5g9:050708 (LNX)openwith support(add terminal sim nxterm,color-xterm,rxvt)//+v5g9I~
//v5ec:040211 (AIX:BUG)shellmode dosenot understand cr(carrige return)//~v5ecR~
//v5bm:040211 (AIX)force tab delay mode(rep tab by space)          //~v5bmI~
//v592:030928 (LNX)mouse support                                   //~v592I~
//v587:030816 (AIX)chk term-sim id by "ps -ef"                     //~v587I~
//v57X:030801 (AIX)defalt curses key setup for all X-term if not duplicated//~v57XI~
//v57N:030712 (LNX)defalt curses key setup for all X-term if not duplicated//~v57NI~
//v57E:030419 (AIX)getsimid func for aix                           //~v57EI~
//v57B:030419 (LNX)no process chain when xe executed by shell      //~v57BI~
//v57A:030413 (LNX)TTY=pts/n under X(ptsn for kon,ttyn for console)//~v57AI~
//v57z:030406 (LNX)gnome-terminal support                          //~v57zI~
//v57w:030223 (LNX:BUG)xterm/kterm should determined by cmd name not by TERM env var.//~v57wI~
//v555:020421 (AIX)accept key for aixterm                          //~v555I~
//v50M:010724 AIX:shell mode(if raw "sh" return immediately)       //~v50MR~
//v50z:010521 LINUX support:support getch/kbhit                    //~v50zI~
//v501:010305 X support:kterm/xterm generate 0x1b[A(hard codes in input.c)//~v501I~
//            but terminfo is 0x1bOA for up cursor key.            //~v501I~
//v39b:001113 LINUX support:move posix logic(common to linux and aix) to ukbdl from ukbdlnxc//~v39bI~
//v395:001105 LINUX support:switch echo,noraw<-->noecho,raw for sub-shell mode//~v395I~
//v384:001001 LINUX support(hearing of key assign from kbdinit)    //~v384I~
//v324 000813:LINUX support                                        //~v324I~
//*************************************************************    //~v324I~
#include <stdio.h>
#include <stdlib.h>                                                //~v324I~
#include <string.h>                                                //~v555I~
                                                                   //~v395I~
#ifdef AIX                                                         //~v395I~
	#include <curses.h>                                            //~v395I~
	#include <errno.h>                                             //~v50zI~
	#include <unistd.h>                                            //~v57ER~
#else                                                              //~v395I~
	#include <ncurses.h>                                           //~v395I~
	#include <unistd.h>                                            //~v57wI~
#endif                                                             //~v395I~
#include <term.h>                                                  //~v39bI~
                                                                   //~v324I~
#include <ulib.h>                                                  //~v324R~
#include <uabend.h>                                                //~v39bI~
#include <ukbd.h>                                                  //~v324I~
#include <uproc.h>                                                 //~v57wI~
#include <uerr.h>                                                  //~v57wI~
                                                                   //~v50zI~
#define UKBDL_GBL		//for ukbdl.h,generate gbl                 //~v50zI~
#include <ukbdl.h>                                                 //~v324I~
                                                                   //~v50zI~
#include <ukbdlnxc.h>                                              //~v324I~
#ifdef LNX                                                         //~v592I~
	#include <ukbdlnxm.h> 	//mouse                                //~v592I~
#endif                                                             //~v592I~
                                                                   //~v384I~
//*********************************************************************
static int Sfd;		//fd returned by init                          //~v39bR~
static int Sgetchinit=0,Sgetcheinit=0;                             //~v555R~
static struct termios Soldgetch,Soldgetche;                        //~v39bI~
//**************************************************               //~v324I~
//*kbdpeek                                                         //~v324I~
//*peek keyin                                                      //~v324I~
//*rc   :0:no data, 1:data exist                                   //~v324I~
//**************************************************               //~v324I~
int ukbdpeek(PKBDKEYINFO Pkeyinfo)                                 //~v324I~
{                                                                  //~v324I~
//*********************                                            //~v324I~
    return ukbdcharin(Pkeyinfo,-1);                                //~v324R~
}//ukbdpeek                                                        //~v324I~
                                                                   //~v324I~
//**************************************************               //~v324I~
//*get keyboard input                                              //~v324I~
//*wait option: 0(IO_WAIT) 1(IO_NOWAIT),-1(PEEK)                   //~v324R~
//*rc   :0:no data(NO WAIT only), 1:data exist                     //~v324I~
//**************************************************               //~v324I~
int ukbdcharin(KBDKEYINFO *Pkeyinfo,int Pnowait)                   //~v324R~
{                                                                  //~v324I~
    char inp[4];                                                   //~v324R~
    int  len,shiftstatus;                                      //~v324R~
//*********************                                            //~v324I~
    memset(Pkeyinfo,0,sizeof(KBDKEYINFO));                         //~v324R~
    len=ukbdlnxc_read(inp,&shiftstatus,Pnowait);                   //~v324R~
    Pkeyinfo->fsState=(USHORT)shiftstatus;                          //~v324I~
    if (!len)                                                      //~v324I~
        return 0;                                                  //~v324R~
    Pkeyinfo->chChar=inp[0];                                        //~v324I~
    Pkeyinfo->chScan=inp[1];                                        //~v324I~
#ifdef LNX                                                         //~v592I~
    if (Pkeyinfo->chScan==UKLM_MOUSEID)                            //~v592I~
    {                                                              //~v592I~
   	 	Pkeyinfo->chMouseposx=inp[2];                              //~v592R~
    	Pkeyinfo->chMouseposy=inp[3];                              //~v592R~
    }                                                              //~v592I~
#endif                                                             //~v592I~
    return 1;                                                      //~v324I~
}//ukbdcharin                                                      //~v324I~
//**************************************************               //~v324I~
//*keyboard init for linux                                         //~v324I~
//**************************************************               //~v324I~
void ukbdl_init(int Popt,UCHAR *Pkeyassign)                        //~v384R~
{                                                                  //~v324I~
    UCHAR usekey[MAXPFKNO][4],*pc;    //f1-f12,plain,shift,control,alt//~v384R~
    int   exaltctl[4]={0,1,3,2};  //exchange alt<-->ctl            //~v384R~
    int   ii,jj;                                                   //~v384R~
//*********************                                            //~v324I~
//*get key assign info                                             //~v384I~
    for (ii=0,pc=Pkeyassign;ii<MAXPFKNO;ii++)                      //~v384R~
    	for (jj=0;jj<4;jj++,pc++)                                  //~v384R~
            usekey[ii][exaltctl[jj]]=*pc;                          //~v384R~
    Sfd=ukbdlnxc_init(Popt,(UCHAR*)usekey);                        //~v39bR~
    return;                                                        //~v324I~
}                                                                  //~v324I~
//**************************************************               //~v324I~
//*keyboard init for linux                                         //~v324I~
//**************************************************               //~v324I~
void ukbdl_term(void)                                              //~v324R~
{                                                                  //~v324I~
//*********************                                            //~v324I~
    ukbdlnxc_term(1);  //restore                                               //~v324I~
    return;                                                        //~v324I~
}                                                                  //~v324I~
//*********************************************************************//~v39bI~
//* assign sym to keycode with modifier                            //~v39bI~
//*********************************************************************//~v39bI~
void ukbdl_setkbmode(int Prestoresw)                               //~v39bI~
{                                                                  //~v39bI~
static int S1stsw=0;                                               //~v555R~
static struct termios Soldtios;                                    //~v39bI~
//************************                                         //~v39bI~
    if (Prestoresw)                                                //~v39bI~
    {                                                              //~v39bI~
        if (!S1stsw)                                               //~v39bI~
            return;                                                //~v39bI~
    	ukbdl_tcsetattr(Sfd,&Soldtios);                            //~v39bI~
    }                                                              //~v39bI~
    else                                                           //~v39bI~
    {                                                              //~v39bI~
        S1stsw=1;                                                  //~v39bI~
#ifdef AIX                                                         //~v5bmI~
		ukbdl_setgetchmode(Sfd,-2,&Soldtios);		//-2:set TABDLY//~v5bmI~
#else                                                              //~v5bmI~
		ukbdl_setgetchmode(Sfd,0,&Soldtios);		//no echo      //~v39bI~
#endif                                                             //~v5bmI~
    }                                                              //~v39bI~
    return;                                                        //~v39bI~
}//ukbdl_setkbmode                                                 //~v39bI~
//**************************************************               //~v395I~
//*for sub-shell mode,switch echo,noraw<-->noecho,raw mode         //~v395I~
//**************************************************               //~v395I~
void ukbdl_shellmode(int Pentrysw)                                 //~v395I~
{                                                                  //~v395I~
	struct termios oldtios,newtios;                                //~v39bI~
//************************                                         //~v39bI~
#ifdef AIX                                                         //~v50MR~
    switch(Pentrysw)                                               //~v50MR~
    {                                                              //~v50MR~
	case -1:    //from uviol_init;save shellmode                   //~v50MR~
        def_shell_mode();   //for later reset_shell_mode           //~v50MR~
        return;                                                    //~v50MR~
    case 2:     //exit by any exit cmd                             //~v50MR~
        def_prog_mode();    //save cur mode as curses mode for later restore//~v50MR~
        noraw();                                                   //~v50MR~
        reset_shell_mode();   //reset to shell mode saved at uviol_init//~v50MR~
        return;                                                    //~v50MR~
    case 3:     //temp exit                                        //~v50MR~
        raw();                                                     //~v50MR~
        reset_prog_mode();   //reset to prog mode saved before entry to shellmode//~v50MR~
        return;                                                    //~v50MR~
    }                                                              //~v50MR~
#endif                                                             //~v50MR~
    ukbdl_tcgetattr(Sfd,&oldtios);                                 //~v39bI~
    memcpy(&newtios,&oldtios,sizeof(newtios));                     //~v39bI~
    switch(Pentrysw)                                               //~v39bI~
    {                                                              //~v39bI~
    case 0:     //temp entry(exit by any key)                      //~v39bI~
        newtios.c_oflag |=  ONLCR; //change lf to crlf             //~v39bI~
        newtios.c_oflag |=  OPOST; //change lf to crlf             //~v5ecR~
        break;                                                     //~v39bI~
    case 1:     //temp exit                                        //~v39bI~
        newtios.c_oflag &= ~ONLCR; //restore                       //~v39bI~
        newtios.c_oflag &= ~OPOST; //change lf to crlf             //~v5ecR~
        break;                                                     //~v39bI~
#ifdef AIX                                                         //~v50MR~
#else                                                              //~v50MR~
    case 2:     //exit by any exit cmd                             //~v39bI~
        newtios.c_oflag |=  ONLCR; //change lf to crlf             //~v39bI~
        newtios.c_lflag |=  ECHO ; //change lf to crlf             //~v39bI~
        break;                                                     //~v39bI~
    case 3:     //temp exit                                        //~v39bI~
        newtios.c_oflag &= ~ONLCR; //restore                       //~v39bI~
        newtios.c_lflag &= ~ECHO ; //change lf to crlf             //~v39bI~
        break;                                                     //~v39bI~
#endif                                                             //~v50MR~
    }                                                              //~v39bI~
    ukbdl_tcsetattr(Sfd,&newtios);                                 //~v39bI~
    return;                                                        //~v39bI~
}//ukbdl_shellmode                                                 //~v39bI~
//*********************************************************************//~v39bM~
//* assign sym to keycode with modifier                            //~v39bM~
//* p1rm2:0:no echo,1:echo,-1:peek mode(and no echo)               //~v50zI~
//*********************************************************************//~v39bM~
void ukbdl_setgetchmode(int Pfd,int Pechosw,struct termios *Ppoldtios)//~v39bR~
{                                                                  //~v39bM~
    struct termios newtios;                                        //~v39bR~
//************************                                         //~v39bM~
    ukbdl_tcgetattr(Pfd,Ppoldtios);                                //~v39bR~
    memcpy(&newtios,Ppoldtios,sizeof(newtios));                    //~v39bR~
    newtios.c_lflag &= ~ (ICANON | ISIG);                          //~v39bR~
    if (Pechosw>0)   //getch but not getche                        //~v50zR~
        newtios.c_lflag |=   ECHO;  //echo off                     //~v50zI~
    else            //getch but not getche                         //~v50zI~
    {                                                              //~v5bmI~
        newtios.c_lflag &= ~ ECHO;  //echo off                     //~v39bR~
#ifdef AIX                                                         //~v5bmI~
      if (Pechosw==-2)   //called from ukbdl_setkbmode             //~v5bmI~
      {                                                            //~v5bmI~
        newtios.c_oflag &= TABDLY;  //tab delay(rep tab by space)  //~v5bmI~
        Pechosw=0;		//not peek		                           //~v5bmI~
      }                                                            //~v5bmI~
#endif                                                             //~v5bmI~
    }                                                              //~v5bmI~
    newtios.c_iflag = 0;                                           //~v39bR~
    if (Pechosw<0)   //peek mode                                   //~v50zI~
    {                                                              //~v50zI~
    	newtios.c_cc[VMIN] = 0; //expect no read                   //~v50zI~
    	newtios.c_cc[VTIME] = 0; //no wait                         //~v50zI~
    }                                                              //~v50zI~
    else                                                           //~v50zI~
    {                                                              //~v50zI~
    newtios.c_cc[VMIN] = 1; //at least 1 byte wait                 //~v39bR~
    newtios.c_cc[VTIME] = 1;    /* 0.1 sec intercharacter timeout *///~v39bR~
    }                                                              //~v50zI~
    ukbdl_tcsetattr(Pfd,&newtios);                                 //~v39bI~
    return;                                                        //~v39bM~
}//ukbdl_setgetchmode                                              //~v39bI~
//*********************************************************************//~v39bM~
//* tc get attr                                                    //~v39bM~
//*********************************************************************//~v39bM~
void ukbdl_tcgetattr(int Pfd,struct termios *Pptios)               //~v39bI~
{                                                                  //~v39bM~
    int rc;                                                        //~v39bM~
//************************                                         //~v39bM~
    rc=tcgetattr(Pfd,Pptios);                                      //~v39bI~
    if (rc)                                                        //~v39bM~
    {                                                              //~v39bM~
        fprintf(stderr,"fd=%d,tcgetattr rc=%d :",Pfd,rc);          //~v39bI~
        perror("tcgetattr");                                       //~v39bM~
        fprintf(stderr,"\r");                                      //~v39bM~
        uabend(1,errno,0,0);                                       //~v39bM~
    }                                                              //~v39bM~
    return;                                                        //~v39bM~
}//ukbdl_tcgetattr                                                 //~v39bI~
//*********************************************************************//~v39bM~
//* tc set attr                                                    //~v39bM~
//*********************************************************************//~v39bM~
void ukbdl_tcsetattr(int Pfd,struct termios *Pptios)               //~v39bI~
{                                                                  //~v39bM~
    int rc;                                                        //~v39bM~
//************************                                         //~v39bM~
//  rc=tcsetattr(Pfd,TCSAFLUSH,Pptios);                            //~v50zR~
    rc=tcsetattr(Pfd,TCSANOW,Pptios);                              //~v50zI~
    if (rc)                                                        //~v39bM~
    {                                                              //~v39bM~
        fprintf(stderr,"fd=%d,tcsetattr rc=%d :",Pfd,rc);          //~v39bI~
        perror("tcsetattr");                                       //~v39bM~
        fprintf(stderr,"\r");                                      //~v39bM~
        uabend(2,errno,0,0);                                       //~v39bM~
    }                                                              //~v39bM~
    return;                                                        //~v39bM~
}//ukbdl_tcsetattr                                                 //~v39bI~
//*********************************************************************//~v39bI~
//* init for getch out of curses                                   //~v39bI~
//*********************************************************************//~v39bI~
int ukbdl_getch_init(void)                                         //~v39bI~
{                                                                  //~v39bI~
//*******************************                                  //~v39bI~
	if (Sgetchinit)                                                //~v39bI~
    	return 0;                                                  //~v39bI~
	ukbdl_getche_term();		//reset previous getche            //~v50zI~
	ukbdl_setgetchmode(0,0,&Soldgetch);                            //~v39bI~
    Sgetchinit=1;                                                  //~v39bI~
    return 0;                                                      //~v39bI~
}//ukbdl_getch_init                                                //~v39bI~
//*********************************************************************//~v39bI~
//* init for getche out of curses                                  //~v39bI~
//*********************************************************************//~v39bI~
int ukbdl_getche_init(void)                                        //~v39bI~
{                                                                  //~v39bI~
//*******************************                                  //~v39bI~
	if (Sgetcheinit)                                               //~v39bI~
    	return 0;                                                  //~v39bI~
	ukbdl_getch_term();		//reset previous getch                 //~v50zI~
	ukbdl_setgetchmode(0,1,&Soldgetche);                           //~v39bI~
    Sgetcheinit=1;                                                 //~v39bI~
    return 0;                                                      //~v39bI~
}//ukbdl_getche_init                                               //~v39bI~
//*********************************************************************//~v39bI~
//* end of getch env                                               //~v39bI~
//*********************************************************************//~v39bI~
int ukbdl_getch_term(void)                                         //~v39bI~
{                                                                  //~v39bI~
//*******************************                                  //~v39bI~
	if (!Sgetchinit)                                               //~v39bI~
    	return 0;                                                  //~v39bI~
	ukbdl_tcsetattr(0,&Soldgetch);                                 //~v39bI~
    Sgetchinit=0;                                                  //~v39bI~
    return 0;                                                      //~v39bI~
}//ukbdl_getch_term                                                //~v39bI~
//*********************************************************************//~v39bI~
//* end of getch env                                               //~v39bI~
//*********************************************************************//~v39bI~
int ukbdl_getche_term(void)                                        //~v39bR~
{                                                                  //~v39bI~
//*******************************                                  //~v39bI~
	if (!Sgetcheinit)                                              //~v39bI~
    	return 0;                                                  //~v39bI~
	ukbdl_tcsetattr(0,&Soldgetche);                                //~v39bI~
    Sgetcheinit=0;                                                 //~v39bI~
    return 0;                                                      //~v39bI~
}//ukbdlnxc_getche_term                                            //~v39bR~
//*********************************************************************//~v50zI~
//* peek once by kbhit                                             //~v50zI~
//  return:0:no hit,1:hit any                                      //~v50zI~
//*********************************************************************//~v50zI~
int ukbdl_kbhit(void)                                              //~v50zI~
{                                                                  //~v50zI~
	struct termios oldtios;                                        //~v50zR~
	KBDKEYINFO keyinfo;                                            //~v50zI~
    int rc;                                                        //~v50zI~
//*******************************                                  //~v50zI~
    ukbdl_setgetchmode(0,-1,&oldtios);	//peek mode                //~v50zI~
	rc=ukbdpeek(&keyinfo);                                         //~v50zI~
	ukbdl_tcsetattr(0,&oldtios);                                   //~v50zR~
    return rc;                                                     //~v50zI~
}//ukbdl_kbhit                                                     //~v50zI~
//*********************************************************************//~v39bI~
//* getch                                                          //~v39bI~
//* ret:char ,-1:err                                               //~v39bI~
//*********************************************************************//~v39bI~
int ukbdl_getch(int Popt)                                          //~v39bI~
{                                                                  //~v39bI~
    int modx=0,ch;                                                 //~v39bI~
    char outch[16];                                                //~v39bR~
//************************                                         //~v39bI~
	if (!Sgetchinit)                                               //~v39bI~
		ukbdl_getch_init();                                        //~v39bI~
    if (!ukbdlnxc_read(outch,&modx,0))                             //~v39bR~
    	ch=-1;                                                     //~v39bI~
                                                                   //~v39bI~
    else                                                           //~v39bI~
    if (!outch[0])                                                 //~v39bI~
    	ch=(int)(outch[1]);                                        //~v39bI~
    else                                                           //~v39bI~
    	ch=(int)(outch[0]);                                        //~v39bI~
    if (Popt & UKBDL_GETCH_ONCE)                                   //~v39bR~
		ukbdl_getch_term();                                        //~v39bI~
    return ch;                                                     //~v39bI~
}//ukbdl_getch                                                     //~v39bI~
//*********************************************************************//~v50zI~
//* getch                                                          //~v50zI~
//* ret:char ,-1:err                                               //~v50zI~
//*********************************************************************//~v50zI~
int ukbdl_getche(int Popt)                                         //~v50zI~
{                                                                  //~v50zI~
    int modx=0,ch;                                                 //~v50zI~
    char outch[16];                                                //~v50zI~
//************************                                         //~v50zI~
	if (!Sgetcheinit)                                              //~v50zI~
		ukbdl_getche_init();                                       //~v50zI~
    if (!ukbdlnxc_read(outch,&modx,0))                             //~v50zI~
    	ch=-1;                                                     //~v50zI~
    else                                                           //~v50zI~
    if (!outch[0])                                                 //~v50zI~
    	ch=(int)(outch[1]);                                        //~v50zI~
    else                                                           //~v50zI~
    	ch=(int)(outch[0]);                                        //~v50zI~
    if (Popt & UKBDL_GETCHE_ONCE)                                  //~v50zI~
		ukbdl_getche_term();                                       //~v50zI~
    return ch;                                                     //~v50zI~
}//ukbdl_getche                                                    //~v50zI~
//*********************************************************************//~v501I~
//* xterm chk                                                      //~v501I~
//* ret:termid(xterm/kterm)                                        //~v501I~
//*********************************************************************//~v501I~
int ukbdl_gettermid(void)                                          //~v501I~
{                                                                  //~v501I~
//#ifdef LNX                                                       //~v587R~
    int termsimid;                                                 //~v57wI~
//#endif                                                           //~v587R~
    char *envterm;                                                 //~v501M~
    int termid=0;                                                  //~v501I~
//************************                                         //~v501I~
#ifdef LNX                                                         //~v57wI~
    if (ukbdlnxc_getkeysym(0,1,0))  //0:msgopt,1:keycode,0:normal=plain//~v57NR~
    	termid=TERM_TTYLCONS;                                      //~v57EI~
    else                                                           //~v57EI~
    {                                                              //~v57EI~
#endif                                                             //~v587I~
    termsimid=ukbdl_gettermsim();                                  //~v57wR~
//#endif                                                           //~v587R~
    if ((envterm=getenv("TERM"))!=0)                               //~v501I~
    {                                                              //~v501I~
    	if (!strcmp(envterm,"kterm"))                              //~v501R~
        	termid=TERM_KTERM;                                     //~v501I~
        else                                                       //~v501I~
	    	if (!strcmp(envterm,"xterm"))                          //~v501R~
    	    	termid=TERM_XTERM;                                 //~v501I~
        else                                                       //~v555I~
	    	if (!strcmp(envterm,"aixterm"))                        //~v555I~
    	    	termid=TERM_AIXTERM;                               //~v555I~
        else                                                       //~v555I~
	    	if (!strcmp(envterm,"dtterm"))                         //~v555I~
    	    	termid=TERM_DTTERM;                                //~v555I~
        else                                                       //~v57XI~
	    	if (!strcmp(envterm,"vt100"))                          //~v57XI~
    	    	termid=TERM_VT100;                                 //~v57XI~
    }                                                              //~v501I~
//#ifdef LNX                                                       //~v587R~
    termid|=termsimid;                                             //~v57wI~
#ifdef LNX                                                         //~v587I~
    }//not tty console                                             //~v57EI~
#endif                                                             //~v57wI~
    return termid;                                                 //~v501I~
}//ukbdl_gettermid                                                 //~v501I~
//#ifdef LNX                                                       //~v57BR~
//*********************************************************************//~v57wI~
//* xterm chk by parent process command                            //~v57wI~
//* ret:termid(xterm/kterm)                                        //~v57wI~
//*********************************************************************//~v57wI~
int ukbdl_gettermsim(void)                                         //~v57wI~
{                                                                  //~v57wI~
	PUPSINFO pupsinfo,pupsinfo0;                                   //~v57wI~
	PUPSINFO pupsinfo1st=0;                                        //~v57BR~
    char *pc;                                                      //~v57wR~
    int  pid,termid=0;                                             //~v57zR~
    int  sw1st=0,konsw=0;                                          //~v57AR~
    int opt=0,conid=0;                                             //~v57BR~
static int Stermid=0;                                              //~v57wI~
//************************                                         //~v57wI~
	if (Stermid)			//2nd time                             //~v57wI~
    	return Stermid;                                            //~v57wI~
    Stermid=TERM_SIMCHKSW;                                         //~v57zI~
    if (!uproc_getpsinfo(0,&pupsinfo0))                            //~v57wR~
    {                                                              //~v57wR~
    	ugeterrmsg();	//clear errmsg for exec cmd                //~v57wI~
//      for (pid=getppid();;)               //parent               //~v57wR~
        for (pid=getpid();;)               //parent may not found
        {                                                          //~v57wR~
//printf("**pid=%d\n",pid);                                        //~v57ER~
//          if (!(pupsinfo=uproc_srchpsinfo(pupsinfo0,pid)))       //~v57BR~
            if (!(pupsinfo=uproc_srchpsinfo(UPSPSI_PPID,pupsinfo0,pid)))//~v57BR~
            {                                                      //~v57BI~
              if (!pupsinfo1st)	//no any parent found              //~v57BR~
                break;                                             //~v57wR~
	            pupsinfo=uproc_srchpsinfo(opt,pupsinfo0,conid);    //~v57BR~
              	if (!pupsinfo)                                     //~v57BI~
                	break;                                         //~v57BI~
//printf("same pty pid=%d,ppid=%d,pts=%d,cmd=%s\n",pupsinfo->UPSIpid,pupsinfo->UPSIppid,pupsinfo->UPSIptyno,pupsinfo->UPSIcmd);//~v57ER~
            }                                                      //~v57BI~
            pupsinfo->UPSIflag |= UPSIFPATH;	//found sw         //~v57BI~
//printf("pid=%d,ppid=%d,pts=%d,cmd=%s\n",pupsinfo->UPSIpid,pupsinfo->UPSIppid,pupsinfo->UPSIptyno,pupsinfo->UPSIcmd);//~v57ER~
			if (!sw1st)                                            //~v57AI~
            {                                                      //~v57AI~
            	sw1st=1;                                           //~v57AI~
                pupsinfo1st=pupsinfo;                              //~v57BI~
                if (pupsinfo->UPSIflag & UPSIFPTS)                 //~v57BI~
                {                                                  //~v57BM~
					opt=UPSPSI_CONPTS;                             //~v57BM~
                    conid=pupsinfo->UPSIptyno;                     //~v57BI~
                }                                                  //~v57BM~
                else                                               //~v57BM~
                if (pupsinfo->UPSIflag & UPSIFPTY)                 //~v57BI~
                {                                                  //~v57BM~
                	opt=UPSPSI_CONPTY;                             //~v57BM~
                    conid=pupsinfo->UPSIptyno;                     //~v57BI~
                }                                                  //~v57BM~
                else                                               //~v57BM~
                {                                                  //~v57BM~
                	opt=UPSPSI_CONTTY;                             //~v57BM~
                    conid=pupsinfo->UPSIttyno;                     //~v57BI~
                }                                                  //~v57BM~
                opt|=UPSPSI_CONID;                                 //~v57BM~
                if (pupsinfo->UPSIflag & UPSIFPTS)                 //~v57AI~
                    Stermid|=TERM_UNDERPTS;                        //~v57BR~
            }                                                      //~v57AI~
            if (pupsinfo->UPSIcmd)                                 //~v57wR~
            {                                                      //~v57wR~
#ifdef AIX                                                         //~v587I~
                if (pc=strstr(pupsinfo->UPSIcmd,"telnetd"),pc)     //~v587I~
                {                                                  //~v587I~
                    termid=TERM_TELNET;                            //~v587I~
                    break;                                         //~v587I~
                }                                                  //~v587I~
                else                                               //~v587I~
#endif                                                             //~v587I~
                if (pc=strstr(pupsinfo->UPSIcmd,"aixterm"),pc)     //~v57ER~
                {                                                  //~v57ER~
                    termid=TERM_AIXTERMSIM;                        //~v57ER~
                    break;                                         //~v57ER~
                }                                                  //~v57ER~
                else                                               //~v57ER~
                if (pc=strstr(pupsinfo->UPSIcmd,"xterm"),pc)       //~v57wR~
                {                                                  //~v57wI~
                    termid=TERM_XTERMSIM;                          //~v57zR~
                    break;                                         //~v57wI~
                }                                                  //~v57wI~
                else                                               //~v57wR~
                if (pc=strstr(pupsinfo->UPSIcmd,"kterm"),pc)       //~v57wR~
                {                                                  //~v57wI~
                    termid=TERM_KTERMSIM;                          //~v57wR~
                    break;                                         //~v57wI~
                }                                                  //~v57wI~
                else                                               //~v57AI~
                if (pc=strstr(pupsinfo->UPSIcmd,"gnome-terminal"),pc)//~v57zI~
                {                                                  //~v57zI~
                    termid=TERM_GTERMSIM;                          //~v57zI~
                    break;                                         //~v57zI~
                }                                                  //~v57zI~
                else                                               //~v57AI~
                if (pc=strstr(pupsinfo->UPSIcmd,"dtterm"),pc)      //~v57ER~
                {                                                  //~v57ER~
                    termid=TERM_DTTERMSIM;                         //~v57ER~
                    break;                                         //~v57ER~
                }                                                  //~v57ER~
                else                                               //~v57ER~
                if (pc=strstr(pupsinfo->UPSIcmd,"nxterm"),pc)      //+v5g9I~
                {                                                  //+v5g9I~
                    termid=TERM_NXTERMSIM;                         //+v5g9I~
                    break;                                         //+v5g9I~
                }                                                  //+v5g9I~
                else                                               //+v5g9I~
                if (pc=strstr(pupsinfo->UPSIcmd,"color-xterm"),pc) //+v5g9I~
                {                                                  //+v5g9I~
                    termid=TERM_COLORXSIM;                         //+v5g9I~
                    break;                                         //+v5g9I~
                }                                                  //+v5g9I~
                else                                               //+v5g9I~
                if (pc=strstr(pupsinfo->UPSIcmd,"rxvt"),pc)        //+v5g9I~
                {                                                  //+v5g9I~
                    termid=TERM_RXVTSIM;                           //+v5g9I~
                    break;                                         //+v5g9I~
                }                                                  //+v5g9I~
                else                                               //+v5g9I~
                if (pc=strstr(pupsinfo->UPSIcmd,"kon"),            //~v57BR~
                    (pc && (*(pc+3)==' '||!*(pc+3))))              //~v57BI~
                    konsw=1;                                       //~v57AI~
            }                                                      //~v57wR~
            pid=pupsinfo->UPSIppid;     //parent pid               //~v57wR~
            if (pid==1)                                            //~v57wR~
                break;                                             //~v57wR~
        }                                                          //~v57wR~
        uproc_freepsinfo(pupsinfo0);                               //~v57wR~
    }//getpsinfo success                                           //~v57wR~
    if (!termid)	//no terminal sim found                        //~v57BI~
    	if (getenv("DISPLAY"))                                     //~v57BI~
        	termid=TERM_OTHERSIM;                                  //~v57BI~
    Stermid|=termid;                                               //~v57zI~
    if (konsw && (Stermid & TERM_UNDERPTS)==0)                     //~v57BR~
    	Stermid|=TERM_UNDERKON;                                    //~v57AR~
//printf("teimid=%x\n",Stermid);                                   //~v57ER~
    return Stermid;                                                //~v57wI~
}//ukbdl_gettermsim                                                //~v57wI~
//#endif                                                           //~v57BR~
//*********************************************************************//~v57NI~
//* edit esc string                                                //~v57NI~
//*********************************************************************//~v57NI~
void ukbdl_editstring(char *Pstr,char *Poutstr)                    //~v57NI~
{                                                                  //~v57NI~
	char *pci,*pco;                                                //~v57NI~
    int ii;                                                        //~v57NI~
//************************                                         //~v57NI~
    if (*Pstr==0x1b)                                               //~v57NI~
        sprintf(Poutstr,"^[%s",Pstr+1);                            //~v57NI~
    else                                                           //~v57NI~
    {                                                              //~v57NI~
        pci=Pstr;                                                  //~v57NI~
        pco=Poutstr;                                               //~v57NI~
        for (ii=strlen(Pstr);ii>0;ii--,pci++)                      //~v57NR~
        	pco+=sprintf(pco,"0x%02X",*pci);                       //~v57NI~
    }                                                              //~v57NI~
}//ukbdl_editstring                                                //~v57NI~
