//*CID://+v72FR~:                                                  //~v72FR~
//****************************************************************
//xe3270.h
//****************************************************************
//v72F:061206 3270:test C3270                                      //~v72FI~
//v72E:061205 3270:add tso subcmd "cmd" to enter Enter/PA1 etc     //~v72EI~
//v72B:061205 3270:like rsh,use =6 panel as TSO terminal screen "tso "tostid TSO"/Exit//~v72BI~
//v72u:061202 3270:tso spf cmd support                             //~v72uI~
//v72t:061202 (BUG)3270:abend when "FOLLOWING ALIAS NAME EXIST WITHOUT TRUE NAME" if using native LISTDS//~v72tI~
//v72h:061124 allow SEQ dataset update(upload)                     //~v72hI~
//v726:061118 3270:more FTP retry by config file specification     //~v726I~
//v71T:061112 3270:add also get confirmation(once get err(dup record) occured)//~v71TI~
//v71R:061111 3270:check after save by reloading and keep result in workdir//~v71RI~
//v71n:061020 3270:add alloc/free cmd                              //~v71nI~
//v71g:061014 3270:copy/move support                               //~v71gI~
//v71e:061011 3270:REname support                                  //~v71eI~
//v719:061004 dirlist DSN list support                             //~v719I~
//v715:060221 (LNX)3270 ftp support(hostfile,TSO command)          //~v715I~
//v70z:060904 3270 ftp support
//****************************************************************
//************************************
//#define XE3270_FTPCMDID ':'     //ftp cmd id                     //~v715R~
#ifdef LNX                                                         //~v715M~
	#define EM3270  		"s3270"		//emulator pgm             //~v715R~
	#define XE3270PIPE "/tmp/xe3270FIFO"                           //~v715M~
	#define XE3270_STARTCMD   "gnome-terminal -e \"%s\""           //~v715M~
#else                                                              //~v715M~
#define EM3270  		"s3270"		//emulator pgm
#define XE3270PIPE "\\\\.\\pipe\\xe3270"
	#define XE3270_STARTCMD   "start %s"                           //~v715I~
#endif                                                             //~v715I~
                                                                   //~v715I~
#define XE3270SERVER  "xe3270"
                                                                   //~v715M~

#define XE3270OPT_LOG           0x01
#define XE3270OPT_APPENDLOG     0x02
#define XE3270OPT_UNLINK        0x04                               //~v715R~
#define XE3270OPT_TRACE         0x08                               //~v715I~
#define XE3270OPT_TESTERRRESP   0x10                               //~v715R~
#define XE3270OPT_TESTNOTFOUND  0x20                               //~v715R~
//#define XE3270OPT_PUTCONFIRM    0x40      //confirm after put    //~v726R~
//#define XE3270OPT_GETCONFIRM    0x80      //confirm get(get twice)//~v726R~

#ifdef LNX                                                         //~v715I~
	#define MAX_3270CLIENT  1  //only one servaer pipe             //~v715I~
#else                                                              //~v715I~
#define MAX_3270CLIENT  10  //string pier to client
#endif                                                             //~v715I~
#define MAX_THREADTB    10 	//thread pier to 3270 emulator

#define XE3270_DEFAULT_LOGFILE "xe3270.log"
#define XE3270_DEFAULT_PORTNO   3270
#define XE3270_SUBCMD_STRING    "Reply"
#define XE3270_SUBCMD_LOGON     "Logon"
#define XE3270_SUBCMD_LOGOFF    "Logoff"                           //~v72BI~
#define XE3270_SUBCMD_QUIT      "Quit"
#define XE3270_SUBCMD_ALLOC     "Alloc"                            //~v71nI~
#define XE3270_SUBCMD_FREE      "Free"                             //~v71nI~
#define XE3270_SUBCMD_SPF       "SPF"                              //~v72uI~
#define XE3270_SUBCMD_CMD       "Cmd"                              //~v72EI~
#define XE3270_SUBCMD_RSH       "RSH"                              //~v72BI~
                                                                   //~v72BI~
#define XE3270RSHOPT_FSMODE     0x01	//rsh fullscreen mode      //~v72BI~
                                                                   //~v719I~
#define MAX_SCREENSZ    8000   //16384                             //~v726R~
//*parameter operand index                                         //~v719M~
#define PARM_REQ       0                                           //~v719M~
#define PARM_HOST      1                                           //~v719M~
#define PARM_USER      2                                           //~v719M~
#define PARM_HOSTFILE  3                                           //~v719M~
#define PARM_LOCALFILE 4                                           //~v719M~
#define PARM_MINIMUM   5                                           //~v719M~
//******************************************************************//~v719I~
#define WORDCHK_REENTER     "REENTER"                              //~v719R~
#define WORDCHK_ENTER       "ENTER"                                //~v71eI~
#define WORDCHK_INUSE       "ENTER LOGON OR LOGOFF"                //~v719I~
#define WORDCHK_READY       "READY"                                //~v71eI~
#define WORDCHK_READY_SZ    5                                      //~v71eI~
#define WORDCHK_MEMBERNOTFOUND "DIRECTORY INFORMATION NOT"         //~v71eI~
#define WORDCHK_MEMBERNOTFOUND_SZ    25                            //~v71eI~
#define WORDCHK_NOTCAT      "NOT IN CAT"                           //~v71eI~
#define WORDCHK_FILEEXIST   "File exists"                          //~v71eI~
#define WORDCHK_DSINUSE     "ALREADY IN USE"                       //~v71nR~
#define WORDCHK_INVALIDALIAS     "THE FOLLOWING ALIAS"             //~v72tI~
#define WORDCHK_INVALIDALIAS_SZ  19                                //~v72tI~
//******************************************************************//~v71eI~
typedef struct _THREADTB {                                         //~v719M~
#define THTHOSTNAMESZ  32                                          //~v719M~
#define THTUSERNAMESZ  32                                          //~v719M~
							int  THTseqid;		//internal thread id(seqno from 1)//~v719M~
							char THThostname[THTHOSTNAMESZ];       //~v719M~
							char THTusername[THTUSERNAMESZ];       //~v719M~
                            int  THTport;	//portno               //~v719M~
                            int  THTflag;                          //~v719M~
#define THTF_TIMEOUT   0x01          //clear pending after timeout //~v719M~
#define THTF_NOTAVAIL  0x02          //do not use;ecb cleate failed//~v719M~
#define THTF_CONNECTED 0x04          //do not use;ecb cleate failed//~v719M~
#define THTF_LOGON     0x08          //do not use;ecb cleate failed//~v719M~
#define THTF_CLOSE     0x10          //do not use;ecb cleate failed//~v719M~
#define THTF_CMDTHREAD 0x20          //req frm cmd thread          //~v72hI~
                            ULONG THTecbm2s;    //event handle signal from mainthread to subthread//~v719M~
                            ULONG THTecbs2m;    //event handle signal from subthread to mainthread//~v719M~
#ifdef LNX                                                         //~v719M~
                            ULONG THTecbkill;   //child kill wait SIGCHILD signal//~v719M~
#endif                                                             //~v719M~
                            ULONG THTchildph;  //child process hProcess//~v719M~
                            ULONG THTkillph;   //kill requested pid//~v719M~
#ifdef LNX                                                         //~v719M~
                            pthread_t THThthread;  //thread handle //~v719M~
#else                                                              //~v719M~
                            ULONG THThthread;  //thread handle     //~v719M~
#endif                                                             //~v719M~
#ifdef W32                                                         //~v719M~
                            int   THTchildpid; //child process pid //~v719M~
#endif                                                             //~v719M~
                            int   THTpipep2c;   //pipe parent->child//~v719M~
                            int   THTpipec2p;   //pipe chaild->parent//~v719M~
                            int   THTreqcode;   //request code     //~v719M~
                            void *THTparm; 	//req parm;            //~v719M~
                            int   THTrc; 		//thread rc        //~v719M~
#define THTRC_SUBPENDING -1          //thread pending              //~v719M~
#define THTRC_SUBNORMAL   0          //thread process returned     //~v719M~
#define THTRC_SUBERR      4          //thread process returned err //~v719M~
#define THTRC_SUBEXIT     8          //thread exit                 //~v719M~
#define THTRC_TIMEOUT    16                                        //~v719M~
#define THTRC_BUSY       20                                        //~v719M~
#define THTRC_OTHERERR   32                                        //~v719M~
                            int   THTexitcode;	//thread exitcode  //~v719M~
#define THTEC_NORMAL      1          //thread exit nomaly          //~v719M~
#define THTEC_CHILDEND    4          //thread exit by child process end//~v719M~
#define THTEC_POSTBACKERR 8          //thread exit by postback fail//~v719M~
#define THTEC_ERR        12          //thread exit by child process end//~v719M~
							int   THTrespdatalen;                  //~v719M~
							void *THTrespdata;                     //~v719M~
                            int   THTmaxrow;                       //~v719R~
                            int   THTcurrow;                       //~v719M~
                            int   THTstartrow;//cmd entered row    //~v719I~
                        } THREADTB,*PTHREADTB;                     //~v719M~
#define THREADTBSZ sizeof(THREADTB)                                //~v719M~
//******************************************************************//~v719I~
int screenchk(int Popt,PTHREADTB Ppthtb,char *Pvalidresp);         //~v719M~
char *uerrmsgmt(int Popt,char *     ,char *      ,... );           //~v719M~
int screenclear(int Pkeepcount,PTHREADTB Ppthtb);                  //~v719M~
int funcenter(int Popt,PTHREADTB Ppthtb);                          //~v719M~
int funcsnap(int Popt,PTHREADTB Ppthtb);                           //~v719M~
int snap3270(int Popt,PTHREADTB Ppthtb,char *Pbuff,int Pbuffsz,int *Pplen);//~v719M~
int send3270(int Popt,PTHREADTB Ppthtb,char *Pcmd);                //~v719M~
int wait3270(int Popt,PTHREADTB Ppthtb,int Pwaittime);             //~v719M~
int funcbreak(PTHREADTB Ppthtb);                                   //~v719M~
int funcbreak2(PTHREADTB Ppthtb);                                  //~v71gI~
                                                                   //~v719M~
#define SENDO_SNAPPRINT     0x01                                   //~v719M~
#define SENDO_CASE          0x02                                   //~v719M~
#define SENDO_DROPSTATUS    0x04                                   //~v719M~
#define SENDO_RCHK_FTP      0x08     //chk response "complete"     //~v719M~
#define SENDO_PSWD          0x10     //hide pswd display           //~v719M~
#define SENDO_RCHK_FTPGET   0x20     //chk filenotfound            //~v719M~
#define SENDO_RCHK_FORMAT   0x40     //chk format status flag      //~v719M~
#define SENDO_WAIT_UNLOCK   0x0100    //wait unlock                //~v719M~
#define SENDO_WAIT_OUTPUT   0x0200    //wait unlock                //~v719M~
#define SENDO_WAIT_INPUTF   0x0400    //wait unlock                //~v719M~
#define SENDO_WAIT_DISCONN  0x0800    //wait unlock                //~v719M~
#define SENDO_SELECTROW     0x1000    //select line                //~v719I~
#define SENDO_REENTERCHK    0x2000    //chk REENTER response       //~v719R~
#define SENDO_UIDINUSECHK   0x4000    //chk USERID IN USE response //~v719I~
#define SENDO_BREAKREENTER  0x8000    //break if REENTER response  //~v71eI~
#define SENDO_ENTERCHK    0x010000    //chk ENTER response         //~v71eI~
#define SENDO_RSHMODE     0x020000    //get rsh response msg       //~v72BI~
                                                                   //~v719M~
#define RECVRC_ERR           0x01        //cmd response "error"    //~v719M~
#define RECVRC_NOTCONNECT    0x02		//statrusline connect status//~v719M~
#define RECVRC_BUFFOVERFLOW  0x04		//buffer overflow          //~v719M~
#define RECVRC_NOTFORMATTED  0x08		//response to SENDO_FORMAT //~v719M~
#define RECVRC_REENTER       0x10		//response to SENDO_FORMAT //~v719I~
                                                                   //~v719M~
int iscmdthread();                                                 //~v719M~
