//*CID://+v72HR~:                                                  //+v72HR~
//****************************************************************
//xe3270s.h (common to xe3270s and xe3270s2)                       //~v725R~
//****************************************************************
//v72H:061206 3270:change FTP timeout foy sysincmd to same as req from xe//+v72HI~
//v72F:061206 3270:configuarable emulator name                     //~v72FI~
//v72n:061127 3270:spf cmd to update spf info                      //~v72nI~
//v72i:061124 3270:timeout value is setable by cfg file            //~v72iI~
//v72h:061124 optionaly(cfg setup) allow SEQ dataset update(upload)//~v72hI~
//v727:061119 3270:optionaly use xe4s001z to list pds member       //~v727I~
//v725:061117 3270:conf file support                               //~v725I~
//****************************************************************
#ifdef GBL_XE3270                                                  //~v725I~
  #define EXT3                                                     //~v725R~
  #define INIT3(value) =value                                      //~v725R~
#else                                                              //~v725I~
  #define EXT3 extern                                              //~v725R~
  #define INIT3(value)                                             //~v725R~
#endif                                                             //~v725I~
                                                                   //~v725I~
#define NEXTLINE(pcout,pc) ((pcout=strchr(pc,'\n'))?++pcout:0)     //~v725M~
#define WORDTOP(pc) (pc+=strspn(pc," "))                           //~v725M~
#define WORDEND(pcout,pc) ((pcout=strpbrk(pc," \n"))?pcout:0)      //~v725M~
                                                                   //~v725I~
#define CONFXE3270   "xe3270.cfg"                                  //~v725I~
#define RETRYGETMAX      4                                         //~v725R~
#define RETRYPUTMAX      4                                         //~v725R~
#define RETRYGETMIN      0                                         //~v725R~
#define RETRYPUTMIN      0                                         //~v725R~
#define RETRYGETDEFAULT  2                                         //~v725R~
#define RETRYPUTDEFAULT  2                                         //~v725R~
                                                                   //~v72hI~
#define TIMEOUT_INFINITE     -1 //accept cancel after 1 sec        //~v72hM~
#define TIMEOUT_INITCHILD     3 //child start                      //~v72hM~
#define TIMEOUT_CONNECT      10                                    //~v72iR~
#define TIMEOUT_TRANSFER     -1 //accept cancel after 1 sec for req by stdincmd//~v72iR~
//#define TIMEOUT_TRANSFER_STDINCMD  2 //ftp by stdin cmd          //+v72HR~
#define TIMEOUT_NOWAIT        0 //no timeout wait                  //~v72hM~
#define TIMEOUT_LOGON         5                                    //~v72hM~
#define TIMEOUT_DISCONNECT    3                                    //~v72hM~
#define TIMEOUT_CHKENDPROCESS 3 //chk pid after kill               //~v72hM~
#define TIMEOUT_UNIT       1000  //milisec                         //~v72hM~
#define TIMEOUT_OVERHEAD    200  //overhead for main, 200ms        //~v72hM~
#define TIMEOUT_ENDTHREAD     3                                    //~v72hM~
#define TIMEOUT_LOGOFF        3                                    //~v72hM~
#define TIMEOUT_SNAP          3                                    //~v72hM~
#define TIMEOUT_CMD          10                                    //~v72hM~
#define TIMEOUT_STRING        3                                    //~v72hM~
#define TIMEOUT_TSOCMD       30                                    //~v72iR~
#define TIMEOUT_PIPECONNECT  5000     //5sec                       //~v72hM~
                                                                   //~v72hI~
#define CONFIGP_GETRETRY      "RETRY_DOWNLOAD"                     //~v725R~
#define CONFIGP_PUTRETRY      "RETRY_UPLOAD"                       //~v725R~
#define CONFIGP_CMDMEMBLIST   "CMD_MEMBLIST"                       //~v725I~
#define CONFIGP_PSUPLOAD      "PS_UPLOAD"                          //~v72hI~
#define CONFIGP_TO_CONNECT    "TIMEOUT_CONNECT"                    //~v72iR~
#define CONFIGP_TO_FTP        "TIMEOUT_FTP"                        //~v72hI~
#define CONFIGP_TO_TSOCMD     "TIMEOUT_TSOCMD"                     //~v72hI~
#define CONFIGP_SPFLEVEL      "SPF_LEVEL"                          //~v72nI~
#define CONFIGP_CMD3270       "CMD3270"                            //~v72FI~
                                                                   //~v72nI~
#define WORDCHK_SPFUPDATEOK      "=======>"                        //~v72nR~
//**************************************************************** //~v725I~
EXT3 char G3270emulator[MAX_CMDSZ] INIT3(EM3270);                  //~v72FR~
EXT3 char G3270workdir[_MAX_PATH];                                 //~v725R~
EXT3 char G3270memblistcmd[MAX_CMDSZ];                             //~v725R~
EXT3 int  G3270retryget INIT3(RETRYGETDEFAULT);                    //~v725R~
EXT3 int  G3270retryput INIT3(RETRYPUTDEFAULT);                    //~v725I~
                                                                   //~v72iI~
EXT3 int  G3270opt;                                                //~v72hI~
#define G3270OPT_PSUPLOAD   0x01      //allow ps upload            //~v72iM~
#define G3270OPT_CMDLINET   0x02      //cmd line parm -T (transfer timeout) specified//~v72iR~
#define G3270OPT_CMDLINEC   0x04      //cmd line parm -C (connect  timeout) specified//~v72iR~
#define G3270OPT_SPFLVL1    0x10      //cfg parm (get spf info only)//~v72nR~
#define G3270OPT_SPFLVL2    0x20      //cfg parm (update spf info) //~v72nR~
                                                                   //~v72iI~
EXT3 int  G3270to_connect INIT3(TIMEOUT_CONNECT);                  //~v72iR~
EXT3 int  G3270to_ftp     INIT3(TIMEOUT_TRANSFER);                 //~v72iR~
EXT3 int  G3270to_tsocmd  INIT3(TIMEOUT_TSOCMD);                   //~v72iR~
//**************************************************************** //~v725I~
typedef struct _SPFLINEFMT  {   //xe4s001z output member line format//~v727R~
                    char   SLFmember[8];                           //~v727R~
                    char   SLFsep1[2];                             //~v727R~
                    char   SLFver[2];       //version              //~v727R~
#define SLFVERALIAS     'A'                 //alias line           //~v727R~
#define SLFVERNOSPF     '-'                 //no spf data on directory//~v727R~
                    char   SLFsep2[1];                             //~v727R~
                    char   SLFmod[2];       //modification         //~v727R~
                    char   SLFsep3[2];                             //~v727R~
                    char   SLFcdate[8];     //creation date YY/MM/DD//~v727R~
                    char   SLFsep4[2];                             //~v727R~
                    char   SLFudate[8];     //update   date YY/MM/DD//~v727R~
                    char   SLFsep5[1];                             //~v727R~
                    char   SLFutime[5];     //update   time hh:mm  //~v727R~
                    char   SLFsep6[2];                             //~v727R~
                    char   SLFlinecnt[11];     //current lineno    //~v727R~
                    char   SLFsep7[1];                             //~v727R~
                    char   SLFinitcnt[11]; //initial lineno        //~v727R~
                    char   SLFsep8[2];                             //~v727R~
                    char   SLFuserid[8];    //user id              //~v727R~
                    char   SLFsep9[3];                             //~v727R~
                    } SPFLINEFMT,*PSPFLINEFMT;                     //~v727R~
typedef struct _DSLINEFMT  {   //xe4s001z output dataset info line format//~v727R~
                    char   DLFsep1[7];                             //~v727R~
                    char   DLFdsorg[2];     //dsorg                //~v727R~
                    char   DLFsep2[7];                             //~v727R~
                    char   DLFrecfm[2];     //recfm                //~v727R~
                    char   DLFsep3[7];                             //~v727R~
                    char   DLFlrecl[5];     //lrecl                //~v727R~
                    char   DLFsep4[9];                             //~v727R~
                    char   DLFblksz[5];     //blksize              //~v727R~
                    } DSLINEFMT,*PDSLINEFMT;                       //~v727R~
//**************************************************************** //~v725I~
int funcalloc(PTHREADTB Ppthtb);                                   //~v725I~
//**************************************************************** //~v725I~
int funcfree(PTHREADTB Ppthtb);                                    //~v725M~
//**************************************************************** //~v725I~
int funcrename(PTHREADTB Ppthtb);                                  //~v725M~
//**************************************************************** //~v725I~
int funcdelete(PTHREADTB Ppthtb);                                  //~v725M~
//**************************************************************** //~v725I~
int funclistds(PTHREADTB Ppthtb);                                  //~v725M~
//**************************************************************** //~v72nI~
int funcspf(PTHREADTB Ppthtb);                                     //~v72nI~
//**************************************************************** //~v725I~
int getfulldata(int Popt,PTHREADTB Ppthtb,char *Pbuff,int Pbuffsz,int Prow,char **Poutbuff,int *Ppoutbufflen);//~v725M~
//**************************************************************** //~v725I~
int readconf(void);                                                //~v725I~
