//*CID://+v72FR~:                              update#=  987;      //+v72FR~
//*************************************************************
//v72F:061206 3270:configuarable emulator name                     //+v72FI~
//v72n:061127 3270:spf cmd to update spf info                      //~v72iI~
//v72i:061124 3270:timeout value is setable by cfg file            //~v72iI~
//v72h:061124 optionaly(cfg setup) allow SEQ dataset update(upload)//~v725I~
//v725:061117 3270:conf file support
//*************************************************************
//*xeftpc.c
//*************************************************************

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>      //offsetof
#include <ctype.h>
#include <string.h>
#include <fcntl.h>

//**********
#ifdef LNX
	#define _MT		//multithred notification to UTRACE etc
    #include <unistd.h>
#else
	#include <dos.h>
	#include <errno.h>
#endif
//**********
#include <ulib.h>
#include <ualloc.h>
#include <uque.h>
#include <uerr.h>
#include <ufile.h>
#include <uftp.h>
#include <u3270.h>
#include <utrace.h>
#include <ustring.h>
#include <uedit.h>
#include <uparse.h>

#include "xe.h"
#include "xe3270.h"
#define  GBL_XE3270
#include "xe3270s.h"

//*************************************************************
int readconfsub(char *Pfnm);
int chkconfparm(char *Ppkey,char *Ppvalue);
//****************************************************************
//*config file process
//****************************************************************
int readconf(void)
{
    int rc;
    char cfnm[_MAX_PATH];
    FILEFINDBUF3 ffb3;
//************************
UTRACEP("readconf entry\n");
	if (!*G3270workdir)	//no config parm specified
    {
	    uerrmsgmt(1,"Warning:No config file used(if need use \"-W\" option)",0);
        return 0;
    }
    strcpy(cfnm,G3270workdir);
    rc=ufstat(cfnm,&ffb3);
    if (rc)
    {
	    uerrmsgmt(1,"-W option err, %s not found",0,
					cfnm);
        return 4;
    }
    if (ffb3.attrFile & FILE_DIRECTORY)
    {
    	strcat(cfnm,DIR_SEPS CONFXE3270);
	    rc=ufstat(cfnm,&ffb3);
	    if (rc)
    	{
	    	uerrmsgmt(1,"%s not found,No config file used",0,
						cfnm);
        	return 0;
    	}
    }
	uerrmsgmt(1,"start using config file: %s",0,
						cfnm);
    if (readconfsub(cfnm))
    	return 4;
UTRACEP("readconf exit \n");
    return 0;
}//readconf
//****************************************************************
//*config file process
//****************************************************************
int readconfsub(char *Pfnm)
{
	int rc=0,len,opt,opdno;
    FILE *fh;
    char *pdelmstr=" \t=";
    UCHAR  **pargc;
    void   *pargc0;
    char buff[MAX_CMDSZ+32];
//************************
UTRACEP("readconf sub entry\n");
	fh=fopen(Pfnm,"r");
    if (!fh)
    {
	    uerrmsgmt(1,"%s open failed",0,
        			Pfnm);
        return 4;
    }
//****
    while (fgets(buff,sizeof(buff),fh))
    {
    	len=strlen(buff);
        if (len && *(buff+len-1)=='\n')
        {
            len--;
            *(buff+len)=0;
        }
        if (len && *(buff+len-1)=='\r') 	//0x0d
        {
            len--;
            *(buff+len)=0;
        }
    	opt=UPARSETABISSPACE;
        uparsev(buff,&pargc,&opdno,opt,pdelmstr);//no ignore crlf,no delmstr
        pargc0=(void*)(ULONG)pargc;   //free area
        if (!opdno)    //null line
        {
            continue;
            break;
        }
        if (*pargc[0]=='#')	//1st opd
        	continue;
        if (opdno<2 || chkconfparm(pargc[0],pargc[1]))
        {
        	rc=4;
            uerrmsgmt(1,"config file(%s) has error(%s)",0,         //~v72iR~
            			Pfnm,buff);
            break;
        }
    	if (pargc0)
	    	ufree(pargc0);
    }//err break
//****
	fclose(fh);
    if (G3270opt & (G3270OPT_SPFLVL1|G3270OPT_SPFLVL2))            //~v72iR~
    	if (!*G3270memblistcmd)                                    //~v72iR~
        {                                                          //~v72iI~
        	rc=4;                                                  //~v72iI~
            uerrmsgmt(1,"specify %s parm if use %s parm",0,        //~v72iI~
            			CONFIGP_CMDMEMBLIST,CONFIGP_SPFLEVEL);     //~v72iI~
        }                                                          //~v72iI~
UTRACEP("readconfsub exit\n");
    return rc;
}//readconfsub
//****************************************************************
//*config file process
//****************************************************************
int chkconfparm(char *Ppkey,char *Ppvalue)
{
	int rc=0,no;
//************************
UTRACEP("chkconfparm entry\n");
    for (;;)
    {
        if (!stricmp(Ppkey,CONFIGP_GETRETRY))
        {
        	no=atoi(Ppvalue);
            if (no<RETRYGETMIN || no>RETRYGETMAX)
            {
            	uerrmsgmt(1,"config parm err(%s value should be %d to %d)",0,
            				 CONFIGP_GETRETRY,RETRYGETMIN,RETRYGETMAX);
                rc=4;
	            break;
            }
            G3270retryget=no;
            uerrmsgmt(1,"config parm accepted: %s=%d",0,
            			 CONFIGP_GETRETRY,G3270retryget);
            break;
        }
        else
        if (!stricmp(Ppkey,CONFIGP_PUTRETRY))
        {
        	no=atoi(Ppvalue);
            if (no<RETRYPUTMIN || no>RETRYPUTMAX)
            {
            	uerrmsgmt(1,"config parm err(%s value should be %d to %d)",0,
            				 CONFIGP_PUTRETRY,RETRYPUTMIN,RETRYPUTMAX);
                rc=4;
	            break;
            }
            G3270retryput=no;
            uerrmsgmt(1,"config parm accepted: %s=%d",0,
            			 CONFIGP_PUTRETRY,G3270retryput);
            break;
        }
        else
        if (!stricmp(Ppkey,CONFIGP_CMDMEMBLIST))
        {
        	if (strlen(Ppvalue)>=MAX_CMDSZ)
            {
            	uerrmsgmt(1,"config parm err(%s length>=%d)",0,
            				 CONFIGP_CMDMEMBLIST,MAX_CMDSZ);
                rc=4;
	            break;
            }
            strcpy(G3270memblistcmd,Ppvalue);
            uerrmsgmt(1,"config parm accepted: %s=%s",0,
            				 CONFIGP_CMDMEMBLIST,G3270memblistcmd);
	        break;
        }
        if (!stricmp(Ppkey,CONFIGP_CMD3270))                       //+v72FI~
        {                                                          //+v72FI~
        	if (strlen(Ppvalue)>=MAX_CMDSZ)                        //+v72FI~
            {                                                      //+v72FI~
            	uerrmsgmt(1,"config parm err(%s length>=%d)",0,    //+v72FI~
            				 CONFIGP_CMD3270,MAX_CMDSZ);           //+v72FI~
                rc=4;                                              //+v72FI~
	            break;                                             //+v72FI~
            }                                                      //+v72FI~
            strcpy(G3270emulator,Ppvalue);                         //+v72FI~
            uerrmsgmt(1,"config parm accepted: %s=%s",0,           //+v72FI~
            				 CONFIGP_CMD3270,G3270emulator);       //+v72FI~
	        break;                                                 //+v72FI~
        }                                                          //+v72FI~
        if (!stricmp(Ppkey,CONFIGP_PSUPLOAD))                      //~v72hI~
        {                                                          //~v72hI~
        	if (*Ppvalue=='1')                                     //~v72hI~
            	G3270opt|=G3270OPT_PSUPLOAD;                       //~v72hI~
            else                                                   //~v72hI~
        	if (*Ppvalue=='0')                                     //~v72hI~
            	G3270opt&=~G3270OPT_PSUPLOAD;                      //~v72hI~
            else                                                   //~v72hI~
            {                                                      //~v72hI~
            	uerrmsgmt(1,"config parm err(%s value is \"1\" or \"0\")",0,//~v72hI~
            				 CONFIGP_PSUPLOAD);                    //~v72hI~
                rc=4;                                              //~v72hI~
	            break;                                             //~v72hI~
            }                                                      //~v72hI~
            uerrmsgmt(1,"config parm accepted: %s=%c",0,           //~v72hI~
            			 CONFIGP_PSUPLOAD,*Ppvalue);               //~v72hI~
	        break;                                                 //~v72hI~
        }                                                          //~v72hI~
        if (!stricmp(Ppkey,CONFIGP_TO_CONNECT))                    //~v72iI~
        {                                                          //~v72iI~
            if (G3270opt & G3270OPT_CMDLINEC)	//cmd parameter setup//~v72iI~
            	uerrmsgmt(1,"config parm ignored,accepted command line parameter: %s=%d",0,//~v72iI~
            				 CONFIGP_TO_CONNECT,G3270to_connect);  //~v72iR~
            else                                                   //~v72iI~
            {                                                      //~v72iI~
        		no=atoi(Ppvalue);                                  //~v72iI~
            	G3270to_connect=no;                                //~v72iI~
            	uerrmsgmt(1,"config parm accepted: %s=%d",0,       //~v72iI~
            				 CONFIGP_TO_CONNECT,G3270to_connect);  //~v72iR~
            }                                                      //~v72iI~
	        break;                                                 //~v72iI~
        }                                                          //~v72iI~
        if (!stricmp(Ppkey,CONFIGP_TO_FTP))                        //~v72iI~
        {                                                          //~v72iI~
            if (G3270opt & G3270OPT_CMDLINET)	//cmd parameter setup//~v72iR~
            	uerrmsgmt(1,"config parm ignored,accepted command line parameter: %s=%d",0,//~v72iI~
            				 CONFIGP_TO_FTP,G3270to_ftp);          //~v72iR~
            else                                                   //~v72iI~
            {                                                      //~v72iI~
        	    no=atoi(Ppvalue);                                  //~v72iI~
            	G3270to_ftp=no;                                    //~v72iR~
            	uerrmsgmt(1,"config parm accepted: %s=%d",0,       //~v72iI~
            				 CONFIGP_TO_FTP,G3270to_ftp);          //~v72iR~
            }                                                      //~v72iI~
	        break;                                                 //~v72iI~
        }                                                          //~v72iI~
        if (!stricmp(Ppkey,CONFIGP_TO_TSOCMD))                     //~v72iI~
        {                                                          //~v72iI~
        	no=atoi(Ppvalue);                                      //~v72iI~
            G3270to_tsocmd=no;                                     //~v72iR~
            uerrmsgmt(1,"config parm accepted: %s=%d",0,           //~v72iI~
            			 CONFIGP_TO_TSOCMD,G3270to_tsocmd);        //~v72iR~
	        break;                                                 //~v72iI~
        }                                                          //~v72iI~
        if (!stricmp(Ppkey,CONFIGP_SPFLEVEL))                      //~v72iI~
        {                                                          //~v72iI~
        	no=atoi(Ppvalue);                                      //~v72iI~
            switch(no)                                             //~v72iI~
            {                                                      //~v72iI~
            case 0:                                                //~v72iI~
                break;                                             //~v72iI~
            case 1:                                                //~v72iI~
                G3270opt|=G3270OPT_SPFLVL1;                        //~v72iI~
                break;                                             //~v72iI~
            case 2:                                                //~v72iI~
                G3270opt|=(G3270OPT_SPFLVL1|G3270OPT_SPFLVL2);     //~v72iR~
                break;                                             //~v72iI~
            default:                                               //~v72iI~
            	uerrmsgmt(1,"config parm err(%s value should be 0 to 2)",0,//~v72iI~
            				 CONFIGP_SPFLEVEL);                    //~v72iI~
                rc=4;                                              //~v72iI~
                break;                                             //~v72iI~
            }                                                      //~v72iI~
            if (!rc)                                               //~v72iI~
            	uerrmsgmt(1,"config parm accepted: %s=%d",0,       //~v72iI~
            				 CONFIGP_SPFLEVEL,no);                 //~v72iI~
	        break;                                                 //~v72iI~
        }                                                          //~v72iI~
    	rc=4;
	    break;
    }
UTRACEP("chkconfparm exit rc=%d\n",rc);
    return rc;
}//chkconfparm
