//CID://+v70xR~:                                                   //~v70xR~
//*************************************************************
//*xecap.c
//* cut and paste
//************************************************************* //~v069I~
//v70x:060903 (BUG)caut&paste;clear abend when last line is the hdr line(end-of-file).//~v70xI~
//v676:051226 cut & paste;margined file(COBOL etc) consideration(ignore space cut by margin)//~v676I~
//v673:051226 cut & paste;margined file(COBOL etc) consideration(use OPBREP and chk rc=1:overflow cut)//~v673I~
//v66u:051121 cap:accept hdr/end line as region specification start/end point//~v66uI~
//v66n:051026 assume eol at end of line if cursor is on lineno fld when Ctrl+v//~v66nI~
//v66f:051021 support standard mode cut & paste,assign Ctrl+v for stream insert//~v66fI~
//                     None   OpenBlock  ClosedBlock   OpenRegion ClosedRegion//~v66fI~
//            C+v    RgnIns   NoBlockErr BlockClearRep OpenRgnErr RgnDel+Ins//~v66fI~
//            A+Ins  BlockIns NoBlockErr GetBlock+Ins  OpenRgnErr RgnDel+Ins//~v66fI~
//            A+Rep  BlockRep NoBlockErr GetBlock+Rep  OpenRgnErr RgnDel+Ins//~v66fI~
//v66f:051021 (BUG)A+F9 abend when A+F7 on same excludeline and pos1>pos2//~v66fI~
//v66e:051020 support standard mode cut & paste;                   //~v66eI~
//            A+F6/A+v:range specification, A+F9:copy, A+Ins:paste Ins, A+F8:paste Rep, C+v:paste Del then Ins//~v66eR~
//            Del/BackSpace:delete range, A+Del:del+copy to clipboard//~v66eI~
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#ifdef DOS
#else
	#ifdef W32                                                     //~v085I~
//  	#include <windows.h>                                       //~v085I~
	#else                                                          //~v085I~
	#define INCL_BASE
	#include <os2.h>
	#endif                                                         //~v085I~
#endif
//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <uque.h>
#include <ufile.h>                                              //~5318R~
#include <ualloc.h>                                             //~v04dI~
#include <ukbd.h>                                               //~v06lI~
                                                                //~5318I~
#include "xe.h"
#include "xescr.h"
#include "xefile.h"
#include "xefile2.h"                                               //~v66fI~
#include "xefile42.h"                                              //~v673I~
#include "xefile6.h"                                               //~v66fI~
#include "xefunc.h"
#include "xechar.h"
#include "xechar2.h"                                               //~v66fI~
#include "xelcmd.h"
#include "xelcmd2.h"                                               //~v66fR~
#include "xelcmd3.h"                                               //~v66fI~
#include "xefsub.h"                                             //~5318I~
#include "xefcmd.h"                                             //~v06iI~
#include "xeerr.h"                                                 //~v098I~
#include "xecap.h"                                                    //~v06tI~
#include "xecap2.h"                                                //~v66fI~
#include "xepan.h"                                                 //~v10MI~
#include "xesub.h"                                                 //~v10MI~
#include "xeundo.h"                                                //~v66fI~
//*******************************************************
int capstdpasteblockline(PUCLIENTWE Ppcw,PULINEH Pplht,PULINEH Pplhs,int Ppos1,int Ppos2,char *Pwork);//~v66fR~
//*******************************************************          //~v66eI~
//!capcut   assumption:top and last is data line                   //~v66eR~
//* del region                                                     //~v66eI~
//* retrn:rc                                                       //~v66eI~
//*******************************************************          //~v66eI~
int capcutregion(PUCLIENTWE Ppcw,PULINEH *Ppplh1,PULINEH *Ppplh2,int Ppos1,int Ppos2)//~v66eR~
{                                                                  //~v66eI~
	PULINEH  plh,Pplh1,Pplh2,delplh1,delplh2,nextplh,sortplh1,sortplh2;//~v66fR~
	int rc=0,spos,ulhlen,joinsw=1;                                 //~v66fR~
//*******************                                              //~v66eI~
	Pplh1=sortplh1=*Ppplh1;                                        //~v66fR~
	Pplh2=sortplh2=*Ppplh2;                                        //~v66fR~
//top line process                                                 //~v66fI~
    plh=Pplh1;                                                     //~v66fI~
    ulhlen=plh->ULHlen;                                            //~v66fR~
    if (Pplh1==Pplh2         //single line                         //~v66fR~
    &&  Ppos1<ulhlen       //line replace                          //~v66fI~
    &&  Ppos2<=ulhlen)     //leave eol and cut intermediate        //~v66fI~
    {                                                              //~v66fI~
        if (Ppos1<0)                                               //~v66fI~
            spos=0;                                                //~v66fI~
        else                                                       //~v66fI~
            spos=Ppos1;                                            //~v66fI~
        return charfldedit(CHAROPETOL,//erase top of line up to start col//~v66fI~
               plh->ULHdata,        //buffer                       //~v66fI~
               plh->ULHdbcs,        //buffer                       //~v66fI~
               Ppos2,           //current col                      //~v66fI~
               spos,         //start col                           //~v66fI~
               ulhlen,          //end col                          //~v66fI~
               plh->ULHbufflen,     //buff len last                //~v66fI~
               Ppcw,                    //pcw                      //~v66fI~
               plh);            //update ctr etc                   //~v66fI~
    }//one line                                                    //~v66fI~
    if (Ppos1>0                                                    //~v66fI~
    && 	Ppos1<ulhlen)			//top line cut                     //~v66fI~
    {                                                              //~v66fI~
        if (rc=charfldedit(CHAROPEEOL,//erase top of line up to start col//~v66fR~
               plh->ULHdata,        //buffer                       //~v66fI~
               plh->ULHdbcs,        //buffer                       //~v66fI~
               Ppos1,           //current col                      //~v66fI~
               0,               //start col                        //~v66fI~
               ulhlen,         //end col                           //~v66fI~
               plh->ULHbufflen,     //buff len last                //~v66fI~
               Ppcw,                    //pcw                      //~v66fI~
               plh),rc)             //update ctr etc               //~v66fI~
            return rc;                                             //~v66fI~
    }                                                              //~v66fI~
    else                                                           //~v66fI~
    	if (Ppos1>ulhlen)                                          //~v66fI~
        	joinsw=0;                                              //~v66fI~
//midlle line process                                              //~v66fI~
    plh=Pplh2;                                                     //~v66fI~
    ulhlen=plh->ULHlen;                                            //~v66fR~
    if (Ppos1<=0)                                                  //~v66fI~
    {                                                              //~v66fI~
    	delplh1=Pplh1;                                             //~v66fI~
        sortplh1=0;  //capreset restore the fld when lcmddel called//~v66fR~
    }                                                              //~v66fI~
    else                                                           //~v66fI~
    	delplh1=UGETQNEXT(Pplh1);                                  //~v66fI~
    if (Pplh1==Pplh2)   //single                                   //~v66fI~
    {                                                              //~v66fI~
	    if (Ppos1<=0)                                              //~v66fI~
    	    delplh2=delplh1;                                       //~v66fI~
        else                                                       //~v66fI~
        	delplh1=0;                                             //~v66fI~
    }                                                              //~v66fI~
	else	//multiline                                            //~v66fI~
    {                                                              //~v66fI~
    	if (Ppos2>ulhlen)	//eol delete                           //~v66fI~
        	delplh2=Pplh2;	//del last line                        //~v66fI~
        else                                                       //~v66fI~
            if (delplh1==Pplh2) //2 line                           //~v66fI~
            	delplh1=0;	//no line delete                       //~v66fI~
            else                                                   //~v66fI~
	        	delplh2=UGETQPREV(Pplh2);                          //~v66fR~
    }                                                              //~v66fI~
    if (delplh1)                                                   //~v66fI~
    {                                                              //~v66fI~
        nextplh=UGETQNEXT(delplh2);                                //~v66fM~
		if (lcmddel(Ppcw,delplh1,delplh2,1,1,1),rc)                //~v66fI~
                 //repeat=1,csr set req for all line delete case,UFHcmdline clear//~v66fI~
	        return rc;                                             //~v66fI~
        if (delplh2==Pplh2)                                        //~v66fI~
        	sortplh2=nextplh;                                      //~v66fR~
        *Ppplh1=sortplh1;                                          //~v66fI~
        *Ppplh2=sortplh2;                                          //~v66fI~
    }                                                              //~v66fI~
//last line process                                                //~v66fI~
	if (Pplh2!=Pplh1 && delplh2!=Pplh2)	//last not deleted         //~v66fR~
    {                                                              //~v66fI~
    	if (Ppos2>0)                                               //~v66fI~
			if (rc=charfldedit(CHAROPETOL,//erase top of line up to start col//~v66fR~
					   plh->ULHdata,		//buffer               //~v66fI~
					   plh->ULHdbcs,		//buffer               //~v66fI~
					   Ppos2,			//current col              //~v66fI~
					   0,         //start col                      //~v66fI~
					   ulhlen,			//end col                  //~v66fI~
					   plh->ULHbufflen,		//buff len last        //~v66fI~
					   Ppcw,		    		//pcw              //~v66fI~
					   plh),rc) 			//update ctr etc       //~v66fR~
            	return rc;                                         //~v66fI~
    }                                                              //~v66fI~
    if (delplh1!=Pplh1)                                            //~v66fI~
    	if (joinsw)	//eol deleted                                  //~v66fI~
          if (Pplh2->ULHtype==ULHTDATA) //if hdr pos=0;dont join to hdr line//~v66uI~
	    	rc=charlcmdjoin(Ppcw,Pplh1,UGETQNEXT(Pplh1));	//plh2!=0 requred for one undo//~v66fR~
	return rc;                                                     //~v66eI~
}//capcutregion                                                    //~v66eI~
//*******************************************************          //~v66eI~
//!capclear                                                        //~v66eI~
//* space clear block;   assumption:top and last is data line      //~v66eR~
//* parm1:pcw                                                      //~v66eI~
//* retrn:rc                                                       //~v66eI~
//*******************************************************          //~v66eI~
int capclearregion(PUCLIENTWE Ppcw,PULINEH Pplh1,PULINEH Pplh2,int Ppos1,int Ppos2)//~v66eI~
{                                                                  //~v66eI~
	PULINEH  plh,endplh;                                           //~v66eI~
	int rc,stepline,endpos,pos1;                                   //~v66eR~
//*******************                                              //~v66eI~
    endplh=getdisplayline(Pplh2,1,&stepline);                      //~v66eR~
  if (endplh)                                                      //~v70xI~
    endplh=UGETQPREV(endplh);                                      //~v66eI~
  else                                                             //~v70xI~
    endplh=Pplh2;                                                  //+v70xR~
    rc=0;                                                          //~v66eI~
	for (plh=Pplh1,pos1=Ppos1;plh;plh=UGETQNEXT(plh))              //~v66eR~
	{                                                              //~v66eI~
    	if (plh->ULHtype==ULHTDATA)                                //~v66eI~
        {                                                          //~v66eI~
            if (!plh->ULHdbcs)                                     //~v66eI~
                if (filechktabdbcs(plh)==UALLOC_FAILED)//expand data len//~v66eI~
                    return UALLOC_FAILED;                          //~v66eI~
            endpos=plh->ULHlen;                                    //~v66eI~
            if (plh==endplh)    //last line                        //~v66eM~
    	        endpos=min(Ppos2,endpos);                          //~v66eI~
            if (endpos>0 && endpos>pos1)                           //~v66eR~
            {                                                      //~v66eI~
                rc=charfldedit(CHAROPCTOL,//erase top of line up to start col//~v66eI~
                               plh->ULHdata,        //buffer       //~v66eI~
                               plh->ULHdbcs,        //buffer       //~v66eI~
                               endpos,              //current col  //~v66eI~
                               pos1,         //start col           //~v66eI~
                               plh->ULHlen,         //end col      //~v66eI~
                               plh->ULHbufflen,     //buff len last//~v66eI~
                               Ppcw,                    //pcw      //~v66eI~
                               plh);                //update ctr etc//~v66eI~
                if (rc)               	                           //~v66eI~
                	break;                                         //~v66eI~
            }                                                      //~v66eI~
        }//data line                                               //~v66eI~
        pos1=0;	//from top for 2nd line                            //~v66eI~
        if (plh==endplh)                                           //~v66eI~
        	break;                                                 //~v66eI~
	}//all plh                                                     //~v66eI~
	return rc;                                                     //~v66eI~
}//capclearregion                                                  //~v66eI~
//*******************************************************          //~v66fI~
//!capstdpaste                                                     //~v66fR~
//* standard paste; if target is block,copy cb in the block        //~v66fR~
//*                 if target is region,del regin and insert cb    //~v66fI~
//* parm1:pcw                                                      //~v66fI~
//* parm2:insert option 0- rep 1:insert                            //~v66fI~
//* retrn:rc                                                       //~v66fI~
//*******************************************************          //~v66fI~
int capstdpaste(PUCLIENTWE Ppcw,PULINEH Psortplh1,PULINEH Psortplh2,int Ppos1,int Ppos2,char Pstat1,char Pstat2)//~v66fI~
{                                                                  //~v66fI~
	PULINEH plhs1,plhs2,plht,plht1,plht2,plhs,endplh,plhlast,plhprev,plhcsr=0;//~v66fR~
	int rc=0,stepline,mode,csrpos,linemodesw,swdelregion,cpos;     //~v66fR~
    int isrteolsw=0;                                               //~v66nI~
    int ovfcutctr=0;                                               //~v673I~
    char *pdata;                                                   //~v66fI~
//*******************                                              //~v66fI~
    swdelregion=0;     //delete rgn and paste,no target block/region//~v66fI~
    if (Gcappcw)                                                   //~v66fI~
    {                                                              //~v66fI~
		if (!UCBITCHK(Pstat1,SBLOCKCLOSED))	//block not closed     //~v66fI~
			return capnoblockerr();                                //~v66fM~
        if (Gcappcw==Ppcw)                                         //~v66fI~
        {                                                          //~v66fI~
			if (!UCBITCHK(Pstat1,SBLOCKSAVED))	//block/rgn saved,that is not target//~v66fI~
        		if (UCBITCHK(Pstat2,SBLOCK2STDREGION))	//after regin saved or at first//~v66fI~
        			swdelregion=1;	//parm to captstdpaste, target is region//~v66fR~
            	else                                               //~v66fI~
        			swdelregion=2;	//parm to captstdpaste, target is block//~v66fR~
            else                                                   //~v66fI~
		        capreset(1);	//clear reverse of copy source block//~v66fI~
        }                                                          //~v66fI~
    }                                                              //~v66fI~
	if (!capgetdata(Ppcw,&plhs1,&plhs2))	//get data plh         //~v66fR~
	{                                                              //~v66fI~
		uerrmsg("No clip board data",                              //~v66fI~
    			"\x93\\tf[^܂");                     //~v66fI~
		return 4;                                                  //~v66fI~
	}                                                              //~v66fI~
	if (swdelregion==2)	//target is block                          //~v66fR~
    {                                                              //~v66fM~
		linemodesw=Ppos1<=0 && Ppos2<=0;                           //~v66fR~
        if (!linemodesw)                                           //~v66fI~
	        pdata=umalloc((UINT)((Ppos2-Ppos1)*2));                //~v66fR~
    	mode=CHAROPBREP;                                           //~v66fI~
	    endplh=getdisplayline(Psortplh2,1,&stepline); //next csr line//~v66fM~
	    for (plht=Psortplh1,plhs=plhs1;plht;plht=UGETQNEXT(plht))  //~v66fM~
        {                                                          //~v66fM~
        	if (plht==endplh)                                      //~v66fM~
            	break;                                             //~v66fM~
        	if (plht->ULHtype!=ULHTDATA)                           //~v66fM~
            	continue;                                          //~v66fM~
            if (linemodesw)                                        //~v66fI~
            {                                                      //~v66fI~
            	if (plhs->ULHlen||plht->ULHlen)                    //~v66fR~
                {                                                  //~v66fI~
		        	if (charcap(Ppcw,mode,plhs,plht,0)==UALLOC_FAILED)//~v66fR~
    	        		return UALLOC_FAILED;                      //~v66fR~
                	if (plhs->ULHlen<plht->ULHlen)                 //~v66fR~
                		plht->ULHlen=plhs->ULHlen;                 //~v66fR~
                }                                                  //~v66fI~
            }                                                      //~v66fI~
            else                                                   //~v66fI~
		        if (capstdpasteblockline(Ppcw,plht,plhs,Ppos1,Ppos2,pdata)==UALLOC_FAILED)//~v66fR~
    	        	return UALLOC_FAILED;                          //~v66fR~
            if (plhs==plhs2) 	//source plh exausted              //~v66fM~
            	break;                                             //~v66fM~
            plhs=UGETQNEXT(plhs);                                  //~v66fM~
        }                                                          //~v66fM~
        if (!linemodesw)                                           //~v66fI~
	        ufree(pdata);                                          //~v66fR~
		filesetcsr(Ppcw,Psortplh1,1,Ppos1);	//Ssortplh1 point prev line//~v66fI~
        uerrmsg("Std paste in Block",                              //~v66fI~
					"ubNւ̕W\x93\\t");                 //~v66fI~
        return 0;                                                  //~v66fI~
    }                                                              //~v66fM~
//target is region                                                 //~v66fI~
    plht1=Psortplh1;                                               //~v66fI~
    plht2=Psortplh2;                                               //~v66fI~
    if (swdelregion==1)    //not null rgn                          //~v66fR~
    {                                                              //~v66fI~
	    plhprev=UGETQPREV(plht1);	//for the case plht1 deleted   //~v66fI~
        if (rc=capcutregion(Ppcw,&plht1,&plht2,Ppos1,Ppos2),rc)    //~v66fR~
            return rc;                                             //~v66fR~
        cpos=Ppos1;                                                //~v66fI~
    }                                                              //~v66fI~
	else					//no target region to delete           //~v66fI~
    {                                                              //~v66fI~
    	if (capgetpoint(Ppcw,&plht1,&cpos))                        //~v66fR~
	  		return errcsrpos();                                    //~v66fI~
        if (cpos<0) //on lineno fld                                //~v66fI~
        {                                                          //~v66nI~
            cpos=0;                                                //~v66fI~
            isrteolsw=1;                                           //~v66nI~
        }                                                          //~v66nI~
        if (!plht1 || plht1->ULHtype!=ULHTDATA)	//on hdr or EXCLUDE line//~v66fI~
	  		return errcsrpos();                                    //~v66fI~
	    plhprev=UGETQPREV(plht1);	//for the case plht1 deleted   //~v66fI~
        if (!plhprev)				//Ctl+v on top hdr line        //~v66fI~
	  		return errcsrpos();                                    //~v66fI~
    }                                                              //~v66fI~
    if (plht1 && cpos<=plht1->ULHlen)	//top not deleted and may split//~v66fR~
    {                                                              //~v66fI~
    	if (rc=charlcmdsplit(Ppcw,plht1,cpos),rc) 	//split top line//~v66fR~
        	return rc;                                             //~v66fM~
        if (cpos)                                                  //~v66fR~
        {                                                          //~v66fI~
	        plhlast=plht1;	//join plh                             //~v66fR~
			csrpos=cpos;                                           //~v66fR~
        }                                                          //~v66fI~
        else                    //if pos=0 len=0 line is inserted after prev line//~v66fI~
        {                                                          //~v66fI~
        	plhlast=UGETQPREV(plht1);                              //~v66fR~
            csrpos=0;                                              //~v66fI~
        }                                                          //~v66fI~
        plhcsr=plhlast;                                            //~v66fI~
	    if (plhs1->ULHlen)                                         //~v66fI~
    	{                                                          //~v66fI~
//  		mode=CHAROPBINS|CHARCAP2_UNDO|CHARCAP2_OVFCUT;         //~v673R~
    	    mode=CHAROPBREP|CHARCAP2_UNDO|CHARCAP2_OVFCUT;         //~v673I~
    	    mode|=CHARCAP2_IGNOVFSPC;	//no rc=1 if overflow cut is all space//~v676R~
    		if (rc=charcap2(Ppcw,mode,plhs1->ULHdata,plhs1->ULHdbcs,plhs1->ULHlen,plhlast,cpos),rc)//~v66fR~
            {                                                      //~v673I~
              if (rc>1)                                            //~v673I~
	        	return rc;                                         //~v66fI~
              ovfcutctr++;                                         //~v673I~
	          rc=0;                                                //~v673I~
            }                                                      //~v673I~
    	}                                                          //~v66fI~
        if (plhs2==plhs1)                                          //~v66fI~
            plhs=0; //no more source line                          //~v66fI~
        else                                                       //~v66fI~
	        plhs=UGETQNEXT(plhs1);	//get next sourceline          //~v66fR~
    }                                                              //~v66fI~
    else                                                           //~v66fI~
    {                                                              //~v66fI~
    	if (plht1)                                                 //~v66fI~
	    	plhlast=plht1;                                         //~v66fR~
        else                //top deleted                          //~v66fI~
        	plhlast=plhprev;                                       //~v66fI~
    	plhs=plhs1;                                                //~v66fI~
    }                                                              //~v66fI~
    for (plht=plhlast;plhs;plhs=UGETQNEXT(plhs))                   //~v66fR~
    {                                                              //~v66fR~
    	if (!plhcsr)                                               //~v66fI~
        {                                                          //~v66fI~
        	plhcsr=plht;                                           //~v66fI~
            csrpos=0;                                              //~v66fI~
        }                                                          //~v66fI~
        if (rc=lcmdisrt(Ppcw,plht,1,0),rc) //repeat=1,indent=0     //~v66fR~
            return rc;                                             //~v66fR~
        plht=UGETQNEXT(plht);   //inserted line                    //~v66fR~
        plhlast=plht;			//join plh                         //~v66fI~
        mode=CHAROPBREP|CHARCAP2_UNDO|CHARCAP2_OVFCUT;             //~v66fR~
    	mode|=CHARCAP2_IGNOVFSPC;	//no rc=1 if overflow cut is all space//~v676I~
        if (rc=charcap2(Ppcw,mode,plhs->ULHdata,plhs->ULHdbcs,plhs->ULHlen,plht,0),rc)//~v66fR~
        {                                                          //~v673I~
          if (rc>1)                                                //~v673I~
            return rc;                                             //~v66fR~
          ovfcutctr++;                                             //~v673I~
          rc=0;                                                    //~v673I~
        }                                                          //~v673I~
        if (plhs==plhs2)                                           //~v66fI~
        	break;                                                 //~v66fI~
    }                                                              //~v66fR~
    if (plhlast)	//join plh                                     //~v66fI~
    {                                                              //~v66nI~
      if (!isrteolsw)	//csr not on lineno fld                    //~v66nI~
	    if (!plhs2->ULHeolid)	//last has no eol                  //~v66fI~
        {                                                          //~v66fI~
			rc=charlcmdjoin(Ppcw,plhlast,UGETQNEXT(plhlast));      //~v66fR~
            if (!rc)                                               //~v66fI~
            	UCBITON(plhlast->ULHflag,ULHFCURCAP);	//recover paste reverse//~v66fI~
            else                                                   //~v673I~
              	if (ovfcutctr)                                     //~v673I~
                	uerrmsg("Last line left splitted by margin limit(intermediate %d lines are are cut)",//~v673I~
                    	    "Ō̍s}[Ŵߕ܂B(r %d s}[WŃJbg)",//~v673R~
                        	ovfcutctr);                            //~v673I~
              	else                                               //~v673I~
                	uerrmsg("Last line left splitted by margin limit.",//~v673I~
                    	    "Ō̍s}[Ŵߕ܂B");//~v673I~
        }                                                          //~v66fI~
    }                                                              //~v66nI~
    if (plhcsr)                                                    //~v66fI~
		filesetcsr(Ppcw,plhcsr,1,csrpos);	//Ssortplh1 point prev line//~v66fI~
    if (!rc)                                                       //~v66fI~
    {                                                              //~v676I~
      if (ovfcutctr)                                               //~v673I~
      {                                                            //~v673I~
		uerrmsg("%d margin overflow lines are cut",                //~v673I~
				"%d s}[WŃJbg܂",           //~v673R~
				ovfcutctr);                                        //~v673I~
        rc=1;                                                      //~v673I~
      }                                                            //~v673I~
      else                                                         //~v673I~
		uerrmsg("Std Paste",                                       //~v66fI~
				"W\x93\\t");                                   //~v66fI~
    }                                                              //~v676I~
	return rc;                                                     //~v66fI~
}//capstdpaste                                                     //~v66fI~
//*******************************************************          //~v66fI~
//!capstdpasteblockline                                            //~v66fI~
//* std paste one block line                                       //~v66fI~
//* retrn:rc                                                       //~v66fI~
//*******************************************************          //~v66fI~
int capstdpasteblockline(PUCLIENTWE Ppcw,PULINEH Pplht,PULINEH Pplhs,int Ppos1,int Ppos2,char *Pwork)//~v66fR~
{                                                                  //~v66fI~
	char *pdbcs,*pdata,*pc,*pcd;                                   //~v66fR~
    int boxw,lens,lent,addlen,mode,rc,ii,lens0;                    //~v66fR~
//**************************                                       //~v66fI~
	boxw=Ppos2-Ppos1;                                              //~v66fM~
    pdata=Pwork;                                                   //~v66fI~
    pdbcs=Pwork+boxw;                                              //~v66fI~
    lent=Pplht->ULHlen;                                            //~v66fR~
    lens=lens0=Pplhs->ULHlen;                                      //~v66fR~
    lens=min(boxw,lens);                                           //~v66fI~
    if (lens)                                                      //~v66fI~
    {                                                              //~v66fI~
    	memcpy(pdata,Pplhs->ULHdata,(UINT)lens);                   //~v66fI~
        for (ii=0,pc=Pplhs->ULHdbcs,pcd=pdbcs;ii<lens;ii++,pc++,pcd++)//~v66uR~
        	if (*pc==TABCHAR||*pc==TABPADCHAR)                     //~v66fI~
		   	 	*pcd=0;		//tab clear to keep line width         //~v66fI~
            else                                                   //~v66fI~
		   	 	*pcd=*pc;                                          //~v66fR~
        if (boxw<lens0)  //source is cut                           //~v66fR~
	        setdbcssplit(pdata,pdbcs,lens,' '); //set space for dbcs split//~v66fR~
    }                                                              //~v66fI~
    if (lens<boxw)  //padd space required                          //~v66fR~
    {                                                              //~v66fI~
        if (lent>=Ppos2)                                           //~v66fI~
            addlen=boxw-lens;                                      //~v66fI~
        else                                                       //~v66fI~
        	addlen=lent-Ppos1-lens;                                //~v66fI~
        if (addlen>0)                                              //~v66fI~
        {                                                          //~v66fI~
	    	memset(pdata+lens,' ',(UINT)addlen);                   //~v66fR~
	    	memset(pdbcs+lens,0  ,(UINT)addlen);                   //~v66fR~
	        lens+=addlen;                                          //~v66fI~
        }                                                          //~v66fI~
    }                                                              //~v66fI~
    if (lens)                                                      //~v66fI~
    {                                                              //~v66fI~
    	mode=CHAROPBREP|CHARCAP2_UNDO|CHARCAP2_OVFCUT;             //~v66fI~
    	if (rc=charcap2(Ppcw,mode,pdata,pdbcs,lens,Pplht,Ppos1),rc)//~v66fI~
        	return rc;                                             //~v66fI~
    }                                                              //~v66fI~
    return 0;                                                      //~v66fI~
}//capstdpasteblockline                                            //~v66fI~
//*******************************************************          //~v66eI~
int caperrregionmode(void)                                         //~v66eI~
{                                                                  //~v66eI~
//*******************                                              //~v66eI~
    uerrmsg("Not Avail for Region specified Cut & Paste",          //~v66eI~
            "̈ŵƂ͂ł܂");                         //~v66eI~
    return 4;                                                      //~v66eI~
}//caperrregionmode                                                //~v66fR~
