//*CID://+v70rR~:                             update#=  592;       //+v70rR~
//*************************************************************
//*xedcmd4.c                                                       //~v638R~
//* grep
//*************************************************************
//v70r:060826 sub cmd;set stdin redirect to protect hung by wait kbd input//+v70rI~
//v67N:060224 (BUG)grep:when space containing dir for *\ or ^*\,it should not enclose wildcard by unix shell standard.//~v67NI~
//v64r:050630 (XXE)xxe support;child shell                         //~v64rI~
//v647:050617 grep fmt change for the availability of dir search on edit/browse scr//~v647I~
//            specify * as filename to search on the current scr   //~v647I~
//v644:050617 (BUG)grep fail if intermediate dir name has embedded space even not used *\,**\  ;//~v647R~
//                 and consider *\ generated space embeding file name//~v644I~
//v63w:050530 grep cmd;support *\ etc for filename only whe that is last parm//~v63wI~
//v63v:050528 (UNX:BUG)grep rc=2(parmerr) for LNX is 512(need ch ::#go)//~v63vR~
//v63t:050527 grep cmd ;chk filename opd exist to protect wait     //~v63tI~
//v63c:050429 change dcmd stdout file(::so) to use pid for contension inter user//~v63cI~
//v63b:050429 change dlcmd "%" temp file(cfso/cf) to use pid for contension inter user//~v63bI~
//v63a:050429 grep original file when file is not updated          //~v63aI~
//v638:050428 change xprint temp file to use pid for contension inter user//~v638I~
//v637:050428 change submit temp file to use pid for contension inter user//~v637I~
//v636:050428 new workdir filename naming ::#((pid).xxx) for grep work filename//~v636I~
//v632:050427 find cmd;support grepline search by *G               //~v632I~
//v630:050426 grep support  as dos cmd(for edit screen flag line and search by rfind for *L)
//*************************************************************
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#ifdef UNX
	#include <termios.h>
#else
#include <process.h>
  #ifdef W32
	#include <io.h>    		//for _A_SUBDIR etc
  #endif
#endif

//*******************************************************
#include <ulib.h>
#include <uerr.h>
#include <uque.h>
#include <ualloc.h>
#include <ufile.h>
#include <ufile2.h>                                                //~v636I~
#include <ufile3.h>
#include <uparse.h>
#include <ustring.h>
#include <uedit.h>
#include <uproc.h>
#include <uproc2.h>
#include <utrace.h>
#ifdef FTPSUPP
    #include <uftp.h>
    #include <ufile1f.h>
#endif

#include "xe.h"
#include "xescr.h"
#include "xefunc.h"
#include "xesub.h"
#include "xeerr.h"
#include "xefile.h"
#include "xefile12.h"
#include "xefile2.h"
#include "xefcmd2.h"
#include "xefcmd22.h"
#include "xeftp.h"
#include "xepan.h"
#include "xedir.h"
#include "xedcmd.h"
#include "xedcmd2.h"
#include "xedcmd3.h"
#define  XEGBL_DCMD4                                               //~v636I~
#include "xedcmd4.h"                                               //~v636I~
//****************************************************************
#define GREPPARM      "-n"
//****************************************************************
//****************************************************************
int dcmdgetgrepresult(PUCLIENTWE Ppcw,char *Pfnm,PUFILEH Ppfh);
int dcmdgrephighlight(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplh,int Plocatesw);
//****************************************************************
//!grep
//*ret :rc 8
//****************************************************************
int dcmd_grep(PUCLIENTWE Ppcw)
{
    UFILEH *pfh;
    char *pparm;
    char cmd[_MAX_PATH+MAXCOLUMN];
    char wdtemp[16],fpathtempi[_MAX_PATH],fpathtempo[_MAX_PATH];
    int  rc,dcmdsw,droptabsw,setredirectsw=0;
    int redirsw,netcmdlen;                                         //~v638R~
    char redirectfnm[_MAX_PATH],redirectfnm2[_MAX_PATH];
    char *pfnm,fpath[_MAX_PATH];                                   //~v63wI~
    int  offsc,offsp;                                              //~v63wI~
    UCHAR *pot,*pc;                                                //~v63tR~
    int ii,opdno,notflagctr;                                       //~v63tR~
    PUPODELMTBL podt;                                              //~v63cI~
    int scrgrepsw,len;                                             //~v647R~
//*******************
    pparm=Ppcw->UCWparm;
    if (!pparm)
    {
//      uerrmsg("Same parameter as grep cmd of each OS except filename(not requred for browse/edit screen)",//~v647R~
//              "eOSgrepR}hƓAAt@C\x95\\ҏWʂł͎w肵ȂB");//~v647R~
        uerrmsg("Same parameter as grep cmd of each OS except spcify * as filename to search on the current screen.",//~v647I~
                "eOSgrepR}hƓAA\x95\\ҏWʏgrepƂ̓t@C\"*\"wB");//~v647I~
        return 4;
    }
    *redirectfnm=0;
    *redirectfnm2=0;
//  if (uprocparseredirect(pparm,redirectfnm,redirectfnm2,&redirsw,&netcmdlen))//+v70rR~
    if (uprocparseredirect(pparm,0,redirectfnm,redirectfnm2,&redirsw,&netcmdlen))//no stdin//+v70rI~
		return dcmdredirectparmerr();
    len=netcmdlen-(int)umemrspnc(pparm,' ',(UINT)netcmdlen);       //~v64rR~
    scrgrepsw=(len>2 && *(pparm+len-2)==' ' && *(pparm+len-1)=='*');//~v647R~
	if (Ppcw->UCWtype==UCWTFILE)//browse/edit
        pfh=UGETPFHFROMPCW(Ppcw);
    else
	if (Ppcw->UCWtype==UCWTDIR)//browse/edit                       //~v644R~
        pfh=UGETPFHFROMPCW(Ppcw);                                  //~v644R~
    else                                                           //~v644I~
        pfh=0;
//  dcmdsw=!pfh						//not browse/edit              //~v644R~
    dcmdsw=!pfh						//not browse/edit/dir          //~v644I~
	    || Ppcw->UCWtype==UCWTDIR  //browse/edit                   //~v644I~
    	|| Ppcw->UCWmenuopt==PANMOCMD	//menu 6
      	|| pfh->UFHtype==UFHTKFI;       //funckey
    if (!dcmdsw)            //edit/browse scr                      //~v647I~
    {                                                              //~v647I~
    	if (scrgrepsw)		// filename is "*"                     //~v647I~
			*(pparm+netcmdlen-2)=0;	//cut current scr id parm      //~v647I~
        else                                                       //~v647I~
        	dcmdsw=1;		//search dir                           //~v647I~
    }                                                              //~v647I~
    if (*redirectfnm||*redirectfnm2)	//redeirect parm exist
    {
		if (!dcmdsw)
        {
    		uerrmsg("redirection not avail for grep in current screen",
					"ʒgrepƂ_CNg͎gpł܂B");
            return 4;
        }
	    *(pparm+netcmdlen)=0;	//drop redirect parm
    }
    if (dcmdsw)
    {
    	podt=Ppcw->UCWopddelmt;                                    //~v63tR~
    	pot=Ppcw->UCWopdpot;                                       //~v63tR~
    	uparse2(pparm,&podt,&pot,&opdno,UPARSE2USEAREAPARM|UPARSE2SETCONTDLM2,0);//~v63tR~
        offsc=0;                                                   //~v63wI~
        for (ii=0,notflagctr=0,pc=pot;ii<opdno;ii++,pc+=strlen(pc)+1,podt++)//~v63tR~
        {                                                          //~v63tR~
        	if (podt->upoquate||*pc!='-')                          //~v63tR~
            {                                                      //~v63wI~
            	notflagctr++;                                      //~v63tR~
                offsp=offsc;			//prev delm offs           //~v63wI~
                offsc=podt->upodelmoffs;   //current offs          //~v63wI~
                pfnm=pc;                                           //~v63wI~
            }                                                      //~v63wI~
        }                                                          //~v63tR~
//      if (Ppcw->UCWopdno==1)                                     //~v63tR~
        if (notflagctr<2)                                          //~v63tR~
            return errmissing();
	    sprintf(cmd,"grep %s",pparm);   //without redirect parm
//      if ((*pfnm==SAMEDIR && Ppcw->UCWtype==UCWTDIR)             //~v644R~
//      if ((  (*pfnm==SAMEDIR && Ppcw->UCWtype==UCWTDIR)          //~v647R~
        if ((  (*pfnm==SAMEDIR && pfh)                             //~v647R~
	         &&((*pfnm+1)==SAMEDIR || *(pfnm+1)==pfh->UFHdirsepc)) //~v644R~
        ||	!memcmp(pfnm,FNMOF2NDSCR,sizeof(FNMOF2NDSCR)-1))	//other screen filename spec//~v63wI~
        {                                                          //~v63wI~
		    if (dcmdfullpath(Ppcw,fpath,pfnm))	//support *\,**\,^*,:://~v63wI~
//  	    	strcpy(cmd+5+offsp+1,fpath);                       //~v644R~
//  	    	uparsein(fpath,cmd+5+offsp+1,sizeof(cmd)-offsp-6,0,'\"');//~v67NR~
    	    	uparseindir(0,fpath,cmd+5+offsp+1,sizeof(cmd)-offsp-6);//~v67NI~
        }                                                          //~v63wI~
    	if (Ppcw->UCWmenuopt!=PANMOCMD)	//menu 6
    		if (!*redirectfnm&&!*redirectfnm2)	//redeirect parm exist
            {
		        strcpy(redirectfnm,DCMDGREPTEMPFNMO);              //~v637R~
                setredirectsw=1;
				Gdcmdtempf|=GDCMDTEMPF_GREPO;                      //~v636R~
            }
    }
    else
    {
        strcpy(redirectfnm,DCMDGREPTEMPFNMO);                      //~v63aM~
        Gdcmdtempf|=GDCMDTEMPF_GREPO;                              //~v63aM~
        *redirectfnm2=0;	// 2>&1                                //~v63aM~
        if (!filefullpath(fpathtempo,redirectfnm,_MAX_PATH))       //~v63aM~
            return 4;                                              //~v63aM~
	  	if (pfh->UFHupctr)	//file updated                         //~v63aR~
      	{                                                          //~v63aR~
            strcpy(wdtemp,DCMDGREPTEMPFNMI);                           //~v637R~
            if (!filefullpath(fpathtempi,wdtemp,_MAX_PATH))
                return 4;
            Gdcmdtempf|=GDCMDTEMPF_GREPI;                              //~v636R~
            droptabsw=0;
            if (!UCBITCHK(Gopt,GOPTTABDISPLAY)) //tab display
            {
                if (!UCBITCHK(pfh->UFHflag5,UFHF5DROPTAB))  //once reset
                {
                    droptabsw=1;
                    UCBITON(pfh->UFHflag5,UFHF5DROPTAB);    //drop tab when save
                }
            }
            rc=filesave(Ppcw,0,pfh,0,0,fpathtempi);
            if (droptabsw)
                UCBITOFF(pfh->UFHflag5,UFHF5DROPTAB);   //drop tab when save
            if (rc)
                return 4;
      	}//grep work saved                                         //~v63aR~
      	else                                                       //~v63aI~
        	strcpy(fpathtempi,pfh->UFHfilename);                   //~v63aI~
	    sprintf(cmd,"grep %s %s %s",GREPPARM,pparm,fpathtempi);
        redirsw=0;	//appendmode=0
    }
    Ppcw->UCWparm=cmd;
//execute
    rc=dcmdsystemcall(Ppcw,Ppcw->UCWparm,redirsw,redirectfnm,redirectfnm2);
#ifdef UNX                                                         //~v63vR~
    rc>>=8;                                                        //~v63vR~
#endif                                                             //~v63vR~
    if (rc==2)	//parm err
    {
    	if (Ppcw->UCWmenuopt!=PANMOCMD)	//menu 6
        {                                                          //~v63tI~
            if (*redirectfnm2)                                     //~v63bI~
		    	uerrmsg("grep failed;See %s",0,                    //~v647R~
    		    			redirectfnm2);                         //~v63bI~
            else                                                   //~v63bI~
        	if (*redirectfnm)
		    	uerrmsg("grep failed;See %s",0,                    //~v647R~
    		    			redirectfnm);
        }                                                          //~v63tI~
        return 4;
    }
    if (rc)
    {                                                              //~v647I~
        if (rc==1)                                                 //~v647I~
		    uerrmsgcat(";No Line Found.",0);                       //~v647R~
    	return 4;
    }                                                              //~v647I~
    if (setredirectsw)
		uerrmsg("grep result is %s",0,
    		    		redirectfnm);
    if (dcmdsw)
    	return 0;
    rc=dcmdgetgrepresult(Ppcw,fpathtempo,pfh);
    return rc;
}//dcmd_grep
//****************************************************************
//flag plh found
//*ret :rc 8
//****************************************************************
int dcmdgetgrepresult(PUCLIENTWE Ppcw,char *Pfnm,PUFILEH Ppfh)
{
	PULINEH plh;
    FILE *fh;
	char *pc;
    int readlen,swcont,swconto=0,locatesw=1,rc,len,foundlinectr=0,updatesw;//~v63aR~
    LONG lineno,linenorw;                                          //~v63aR~
//**********************************************************
	plh=UGETQNEXT(UGETQTOP(&Ppfh->UFHlineque));		//top entry
	fh=fileopen(Pfnm,"rb");
    if (!fh)
    	return 4;
	updatesw=Ppfh->UFHupctr;	//file updated                     //~v63aI~
    for (;;)
    {
    	rc=0;
    	if (!fgets(Gfilebuff,MAXLINEDATA,fh))
        	break;
        pc=memchr(Gfilebuff,'\n',MAXLINEDATA);
        if (pc)
        {
	      	readlen=(int)((ULONG)pc-(ULONG)Gfilebuff);
#ifndef UNX
			if (readlen && *(pc-1)==0x0d)
            	readlen--;
#endif
			swcont=0;
        }
        else
        {
        	readlen=MAXLINEDATA-1;
            swcont=1;
        }
		if (swconto)	//cont line of prev
        	continue;
        swconto=swcont;
        rc=4;		//err when break by errchk
        if (!readlen)
        	break;
        pc=memchr(Gfilebuff,':',(UINT)readlen);	//nnn: fmt lineno
        if (!pc)
        	break;
	    len=(int)((ULONG)pc-(ULONG)Gfilebuff);
        if (len!=unumlen(Gfilebuff,0,len))
        	break;
        lineno=atol(Gfilebuff);
//lineno matching
        for (;plh;plh=UGETQNEXT(plh))
        {                                                          //~v632I~
    		if (plh->ULHtype==ULHTDATA)                            //~v632R~
            {                                                      //~v63aI~
            	if (updatesw)                                      //~v63aR~
                	linenorw=plh->ULHlinenow;                      //~v63aI~
                else                                               //~v63aI~
                	linenorw=plh->ULHlinenor;                      //~v63aI~
        		if (lineno==linenorw)                              //~v63aR~
                {                                                  //~v632I~
                    UCBITON(plh->ULHflag4,ULHF4GREP);   //for search by *G//~v632I~
                    break;                                         //~v632R~
                }                                                  //~v632I~
                else                                               //~v632I~
		            UCBITOFF(plh->ULHflag4,ULHF4GREP);             //~v632I~
            }                                                      //~v63aI~
        }                                                          //~v632I~
        if (!plh)
        	break;
        rc=0;
        dcmdgrephighlight(Ppcw,Ppfh,plh,locatesw);
        foundlinectr++;
        locatesw=0;
        plh=UGETQNEXT(plh); //next of matched                      //~v632I~
    }//until eof
    for (;plh;plh=UGETQNEXT(plh))                                  //~v632I~
        UCBITOFF(plh->ULHflag4,ULHF4GREP);//clear after last greped//~v632I~
	fileclose(Pfnm,fh);
    if (rc)
    {
    	uerrmsg("Invalid grep option?(No lineno prefix),check %s",0,
        			Pfnm);
    	return 4;
    }
    uerrmsg("%d line found",0,
			foundlinectr);
    return 0;
}//dcmdsetgrepline
//***********************************************************
//* setup line as found line
//***********************************************************
int  dcmdgrephighlight(PUCLIENTWE Ppcw,PUFILEH Ppfh,PULINEH Pplh,int Plocatesw)
{
    int rc=0,linenosz;
//*******************
	if (Plocatesw)	//locate to found word
	{
        fcmdfindscroll(Ppcw,Pplh,0);	//0:no scroll option
	    linenosz=Ppcw->UCWlinenosz;
        if (linenosz)
			filesetcsr(Ppcw,Pplh,0,linenosz-1);//csr set on update sign
		else
			filesetcsr(Ppcw,Pplh,1,0);		//csr set on col 1
		Ppfh->UFHmfwtindex=0;
        Ppfh->UFHfindctr++;
        Ppfh->UFHupctrgrep=Ppfh->UFHupctr;                         //~v632I~
//      Sstep=1;//reverse len,next rfind step
//  	Sfoundplh=Pplh;
//  	Sfoundoffs=0;	            //to chk continuas rfind
//  	Schangeopt=0;			//for next rchange
//  	Sfindopt &= ~(FINDOPT_MULTIREV|FINDOPT_MULTIREVNEXT); //ignore multi rev
//  	Sfoundctr=0;					//count up at return
//  	Smfwtovf=0;						//overflow point
// 		Spfhfindctr=Ppfh->UFHfindctr;
	}//first time
    Pplh->ULHrevctr=Ppfh->UFHfindctr;//find cmd ctr for disply current;
	Pplh->ULHrevoffs=ULHULFOUND;		//ipdate line search result id
    Pplh->ULHrevlen=1;//reverse len,next rfind step
    UCBITON(Pplh->ULHflag,ULHFDRAW|ULHFCURFOUND);//draw word after wordrep
	UCBITOFF(Pplh->ULHflag2,ULHF2MFOUND);//reset multiple
    UCBITOFF(Pplh->ULHflag,ULHFCURCAP);//reset hilight reason cap
	return rc;
}//dcmdgrepsetline
//***********************************************************      //~v636I~
//* delete all ::#(pid work file)                                  //~v636I~
//***********************************************************      //~v636I~
int dcmdwdclear(void)                                              //~v636R~
{                                                                  //~v636I~
    char fpath[_MAX_PATH];                                         //~v636I~
//**************************************                           //~v636I~
	if (Gdcmdtempf & GDCMDTEMPF_GREPI)                             //~v636R~
    {                                                              //~v636I~
    	if (filefullpath(fpath,DCMDGREPTEMPFNMI,_MAX_PATH))        //~v637R~
			uremove(fpath);                                        //~v63bI~
    }                                                              //~v636I~
	if (Gdcmdtempf & GDCMDTEMPF_GREPO)                             //~v636I~
    {                                                              //~v636I~
    	if (filefullpath(fpath,DCMDGREPTEMPFNMO,_MAX_PATH))        //~v637R~
			uremove(fpath);                                        //~v63bI~
    }                                                              //~v636I~
	if (Gdcmdtempf & GDCMDTEMPF_SUB)                               //~v637I~
    {                                                              //~v637I~
    	if (filefullpath(fpath,DCMDSUBMITCMDFNM,_MAX_PATH))        //~v637I~
			uremove(fpath);                                        //~v63bI~
    }                                                              //~v637I~
	if (Gdcmdtempf & GDCMDTEMPF_XPRINT)                            //~v638I~
    {                                                              //~v638I~
    	if (filefullpath(fpath,DCMDXPRINTTEMPFNM,_MAX_PATH))       //~v638I~
			uremove(fpath);                                        //~v63bI~
    }                                                              //~v638I~
	if (Gdcmdtempf & GDCMDTEMPF_DLCMDP)                            //~v638I~
    {                                                              //~v638I~
    	if (filefullpath(fpath,DCMDDLCMDPINPFNM,_MAX_PATH))        //~v638I~
			uremove(fpath);                                        //~v63bR~
    }                                                              //~v638I~
	if (Gdcmdtempf & GDCMDTEMPF_DLCMDCF)                           //~v63bR~
    {                                                              //~v63bI~
    	if (filefullpath(fpath,DCMDDLCMDCFSO,_MAX_PATH))           //~v63bR~
			uremove(fpath);                                        //~v63bI~
    }                                                              //~v63bI~
	if (Gdcmdtempf & GDCMDTEMPF_DCMDSO)                            //~v63cI~
    {                                                              //~v63cI~
    	if (filefullpath(fpath,DCMDDCMDSO,_MAX_PATH))              //~v63cI~
			uremove(fpath);                                        //~v63cI~
    }                                                              //~v63cI~
	if (Gdcmdtempf & GDCMDTEMPF_SYSCMDF)	//child shell kick     //~v64rR~
    {                                                              //~v64rR~
    	if (filefullpath(fpath,DCMDSYSCMDTEMPF,_MAX_PATH))         //~v64rR~
			uremove(fpath);                                        //~v64rR~
    }                                                              //~v64rR~
    return 0;                                                      //~v636R~
}//dcmdwdclear                                                     //~v636R~
