//*CID://+v72BR~:                             update#=  486;       //~v72BI~
//*************************************************************    //~v72BI~
//*xetso2.c                                                        //~v72BI~
//**interface to xe3270                                            //~v72BI~
//*************************************************************    //~v72BI~
//v72B:061205 3270:like rsh,use =6 panel as TSO terminal screen "tso "tostid TSO"/Exit//~v72BI~
//*************************************************************    //~v72BI~
#include <time.h>                                                  //~v72BI~
#include <stdio.h>                                                 //~v72BI~
#include <stddef.h>                                                //~v72BI~
#include <stdlib.h>                                                //~v72BI~
#include <ctype.h>                                                 //~v72BI~
#include <string.h>                                                //~v72BI~
#ifdef W32                                                         //~v72BI~
#include <io.h>                                                    //~v72BI~
#include <error.h>                                                 //~v72BI~
#include <errno.h>                                                 //~v72BI~
#endif                                                             //~v72BI~
                                                                   //~v72BI~
//*******************************************************          //~v72BI~
#include <ulib.h>                                                  //~v72BI~
#include <ualloc.h>                                                //~v72BI~
#include <uerr.h>                                                  //~v72BI~
#include <uque.h>                                                  //~v72BI~
#include <ufile.h>                                                 //~v72BI~
#include <ustring.h>                                               //~v72BI~
#include <uedit.h>                                                 //~v72BI~
#include <uftp.h>                                                  //~v72BI~
#include <utrace.h>                                                //~v72BI~
#include <uparse.h>                                                //~v72BI~
#include <u3270.h>                                                 //~v72BI~
                                                                   //~v72BI~
#include "xe.h"                                                    //~v72BI~
#include "xescr.h"                                                 //~v72BI~
#include "xefile.h"                                                //~v72BI~
#include "xefunc.h"                                                //~v72BI~
#include "xeftp.h"                                                 //~v72BI~
#include "xesub.h"                                                 //~v72BI~
#include "xedir.h"                                                 //~v72BI~
#include "xe3270.h"                                                //~v72BI~
#include "xetso.h"                                                 //~v72BI~
#include "xeerr.h"                                                 //~v72BI~
#include "xedcmd3.h"                                               //~v72BI~
#include "xefcmd3.h"                                               //~v72BI~
                                                                   //~v72BI~
#ifdef FTPSUPP                                                     //~v72BI~
                                                                   //~v72BI~
//**************************************************************** //~v72BI~
//**************************************************************** //~v72BI~
//**************************************************************** //~v72BI~
//**************************************************************** //~v72BI~
// set/reset =6 panel to TSO terminal mode by logon/logoff cmd     //~v72BR~
//*rc   :0                                                         //~v72BI~
//**************************************************************** //~v72BI~
int xetsotsocmdlogon(int Popt,PUCLIENTWE Ppcw,PUFTPHOST Ppuftph)   //~v72BR~
{                                                                  //~v72BI~
    PUFTPHOST puftpho;                                             //~v72BI~
    PUFILEC  pfc;                                                  //~v72BI~
    PUFILEH  pfh;                                                  //~v72BI~
    char logtext[256];                                             //~v72BI~
//*********************************                                //~v72BI~
	pfc=Ppcw->UCWpfc;                                              //~v72BI~
	pfh=pfc->UFCpfh;                                               //~v72BI~
	puftpho=pfh->UFHpuftph;	//old                                  //~v72BR~
	if (Popt & XETSOCMDO_LOGOFF)                                   //~v72BI~
    {                                                              //~v72BI~
    	if (puftpho)                                               //~v72BI~
        {                                                          //~v72BI~
            if (puftpho==Ppuftph)                                  //~v72BI~
            {                                                      //~v72BI~
                pfh->UFHpuftph=0;   //old                          //~v72BR~
                UCBITOFF(pfh->UFHflag6,UFHF6RLOGIN);               //~v72BI~
                sprintf(logtext,"Exit TSO mode of %s/%s.",         //~v72BR~
                        puftpho->UFTPHipad,puftpho->UFTPHuser);    //~v72BI~
            }                                                      //~v72BI~
            else                                                   //~v72BI~
                sprintf(logtext,"Continue TSO mode of %s/%s(logoff of %s/%s).",//~v72BR~
                        puftpho->UFTPHipad,puftpho->UFTPHuser,Ppuftph->UFTPHipad,Ppuftph->UFTPHuser);//~v72BI~
            dcmdrloginlog(Ppcw,pfh,logtext);                       //~v72BI~
        }                                                          //~v72BI~
        return 0;                                                  //~v72BI~
    }//reset req                                                   //~v72BI~
//logon req                                                        //~v72BI~
	if (puftpho==Ppuftph)   //already TSO mode of the host         //~v72BI~
        sprintf(logtext,"Continue TSO mode of %s/%s.",             //~v72BR~
                            Ppuftph->UFTPHipad,Ppuftph->UFTPHuser);//~v72BI~
    else                                                           //~v72BI~
        if (puftpho)                                               //~v72BR~
            sprintf(logtext,"Now TSO mode of %s/%s(switched from %s/%s).",//~v72BR~
                            Ppuftph->UFTPHipad,Ppuftph->UFTPHuser,puftpho->UFTPHipad,puftpho->UFTPHuser);//~v72BR~
        else                                                       //~v72BI~
            sprintf(logtext,"Now TSO mode of %s/%s.",              //~v72BR~
                            Ppuftph->UFTPHipad,Ppuftph->UFTPHuser);//~v72BI~
    UCBITON(pfh->UFHflag6,UFHF6RLOGIN);                            //~v72BI~
	if (Popt & XETSOCMDO_LOGONFS)	//fullscreen mode              //~v72BI~
        UCBITON(pfh->UFHflag8,UFHF8TSOFSMODE);                     //~v72BR~
    else                                                           //~v72BI~
        UCBITOFF(pfh->UFHflag8,UFHF8TSOFSMODE);                    //~v72BR~
    pfh->UFHpuftph=Ppuftph;  //new                                 //~v72BR~
	dcmdrloginlog(Ppcw,pfh,logtext);                               //~v72BI~
    return 0;                                                      //~v72BI~
}//xetsotsocmdlogon                                                //~v72BR~
//**************************************************************** //~v72BI~
// process input when =6 screen is TSO mode                        //~v72BI~
//*rc   :0                                                         //~v72BI~
//**************************************************************** //~v72BI~
int xetsotsocmd(PUCLIENTWE Ppcw)                                   //~v72BI~
{                                                                  //~v72BI~
    PUFTPHOST puftph;                                              //~v72BR~
    PUFILEC  pfc;                                                  //~v72BI~
    PUFILEH  pfh;                                                  //~v72BI~
    PULINEH  plh;                                                  //~v72BI~
    PSCRDATA  phdr;                                                //~v72BI~
    int rc,opt,datalen,len,reslen;                                 //~v72BR~
    char cmd[MAX_CMDSZ],*pc,*cmdstr,*pc2;                          //~v72BR~
    char optstr[4];                                                //+v72BI~
    opt=0;                                                         //+v72BI~
//*********************************                                //~v72BI~
	pfc=Ppcw->UCWpfc;                                              //~v72BI~
	pfh=pfc->UFCpfh;                                               //~v72BI~
	puftph=pfh->UFHpuftph;	//old                                  //~v72BR~
    if (!UFTPHISTSO(puftph))                                       //~v72BI~
    	return 4;                                                  //~v72BI~
    if (UCBITCHK(pfh->UFHflag8,UFHF8TSOFSMODE))                    //+v72BI~
    	opt=XE3270RSHOPT_FSMODE;                                   //+v72BI~
    sprintf(optstr,"%d",opt);                                      //+v72BI~
    cmdstr=Ppcw->UCWparm;                                          //~v72BM~
	dcmdrloginlog(Ppcw,pfh,cmdstr);	//cmd line on =6 scr with time stamp//~v72BI~
	pc=cmd+u3270sethostuser(puftph,XE3270_SUBCMD_RSH,cmd);         //~v72BR~
    sprintf(pc," \"%s %s\"",optstr,cmdstr);                        //+v72BR~
    opt=U3CRO_TSOMODE;                                             //~v72BI~
    rc=u3270cmdrequest(U3CRO_UERRMSGIFERR,cmd,(void**)(ULONG)(&phdr),&datalen);//~v72BI~
    if (phdr)                                                      //~v72BI~
    {                                                              //~v72BI~
	    plh=UGETQPREV(UGETQEND(&pfh->UFHlineque));	//timestamp line//~v72BI~
        reslen=phdr->SCRlen;                                       //~v72BR~
        pc=phdr->SCRdata;                                          //~v72BI~
        for (;reslen>0;)                                           //~v72BI~
        {                                                          //~v72BI~
        	pc2=memchr(pc,'\n',reslen);                            //~v72BR~
            if (!pc2)                                              //~v72BI~
            	break;                                             //~v72BI~
            len=(ULONG)pc2-(ULONG)pc;                              //~v72BI~
            rc=fcmdisrtline(Ppcw,plh,pc,len);                      //~v72BI~
            if (rc)                                                //~v72BI~
            	break;                                             //~v72BI~
            plh=UGETQNEXT(plh);                                    //~v72BI~
            len++;	//\n                                           //~v72BI~
            reslen-=len;                                           //~v72BI~
            pc+=len;                                               //~v72BR~
        }                                                          //~v72BI~
        ufree(phdr);                                               //~v72BI~
    }                                                              //~v72BI~
    return rc;                                                     //~v72BR~
}//xetsotsocmd                                                     //~v72BI~
                                                                   //~v72BI~
#endif	//FTPSUPP                                                  //~v72BI~
